/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.43.0(94c055bcbdd49f04a0fa15515e848542a79fb948)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var te=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/advancedLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ie=function(U){for(var n=[],E=0,M=U.length;E<M;E++)n[E]=te[U[E]];return n};const Ne=this,Ee=typeof global=="object"?global:{};var _e;(function(U){U.global=Ne;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}U.Environment=n})(_e||(_e={}));var _e;(function(U){class n{constructor(u,f,g){this.type=u,this.detail=f,this.timestamp=g}}U.LoaderEvent=n;class E{constructor(u){this._events=[new n(1,"",u)]}record(u,f){this._events.push(new n(u,f,U.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}U.LoaderEventRecorder=E;class M{record(u,f){}getEvents(){return[]}}M.INSTANCE=new M,U.NullLoaderEventRecorder=M})(_e||(_e={}));var _e;(function(U){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let u;for(u in M)M.hasOwnProperty(u)&&i(u,M[u])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(u,f)=>{f&&typeof f=="object"?i[u]=n.recursiveClone(f):i[u]=f}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,U.Utilities=n})(_e||(_e={}));var _e;(function(U){function n(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}U.ensureError=n;class E{static validateConfigurationOptions(u){function f(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=f),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(U.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const g=n(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",u.onError(g),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,f=null){let g=U.Utilities.recursiveClone(f||{});return U.Utilities.forEachProperty(u,(a,s)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(s):a==="paths"&&typeof g.paths<"u"?U.Utilities.forEachProperty(s,(_,t)=>g.paths[_]=t):a==="config"&&typeof g.config<"u"?U.Utilities.forEachProperty(s,(_,t)=>g.config[_]=t):g[a]=U.Utilities.recursiveClone(s)}),E.validateConfigurationOptions(g)}}U.ConfigurationOptionsUtil=E;class M{constructor(u,f){if(this._env=u,this.options=E.mergeConfigurationOptions(f),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,(u,f)=>{Array.isArray(f)?this.sortedPathsRules.push({from:u,to:f}):this.sortedPathsRules.push({from:u,to:[f]})}),this.sortedPathsRules.sort((u,f)=>f.from.length-u.from.length)}cloneAndMerge(u){return new M(this._env,E.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let f;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if(f=this.sortedPathsRules[g],U.Utilities.startsWith(u,f.from)){let s=[];for(let _=0,t=f.to.length;_<t;_++)s.push(f.to[_]+u.substr(f.from.length));return s}return[u]}_addUrlArgsToUrl(u){return U.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let f=0,g=u.length;f<g;f++)u[f]=this._addUrlArgsToUrl(u[f]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let f=u,g;if(!U.Utilities.endsWith(f,".js")&&!U.Utilities.isAbsolutePath(f)){g=this._applyPaths(f);for(let a=0,s=g.length;a<s;a++)this.isBuild()&&g[a]==="empty:"||(U.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!U.Utilities.endsWith(g[a],".js")&&!U.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!U.Utilities.endsWith(f,".js")&&!U.Utilities.containsQueryString(f)&&(f=f+".js"),g=[f];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(u){let f=u;return U.Utilities.isAbsolutePath(f)||(f=this._applyPaths(f)[0],U.Utilities.isAbsolutePath(f)||(f=this.options.baseUrl+f)),this._addUrlArgsIfNecessaryToUrl(f)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||U.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}U.Configuration=M})(_e||(_e={}));var _e;(function(U){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,_,t,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:c}=s.getConfig().getOptionsLiteral();c?this._scriptLoader=new E:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new E;let h={callback:t,errorback:m};if(this._callbackMap.hasOwnProperty(_)){this._callbackMap[_].push(h);return}this._callbackMap[_]=[h],this._scriptLoader.load(s,_,()=>this.triggerCallback(_),c=>this.triggerErrorback(_,c))}triggerCallback(s){let _=this._callbackMap[s];delete this._callbackMap[s];for(let t=0;t<_.length;t++)_[t].callback()}triggerErrorback(s,_){let t=this._callbackMap[s];delete this._callbackMap[s];for(let m=0;m<t.length;m++)t[m].errorback(_)}}class E{attachListeners(s,_,t){let m=()=>{s.removeEventListener("load",h),s.removeEventListener("error",c)},h=L=>{m(),_()},c=L=>{m(),t(L)};s.addEventListener("load",h),s.addEventListener("error",c)}load(s,_,t,m){if(/^node\|/.test(_)){let h=s.getConfig().getOptionsLiteral(),c=f(s.getRecorder(),h.nodeRequire||U.global.nodeRequire),L=_.split("|"),d=null;try{d=c(L[1])}catch(y){m(y);return}s.enqueueDefineAnonymousModule([],()=>d),t()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,t,m);const{trustedTypesPolicy:c}=s.getConfig().getOptionsLiteral();c&&(_=c.createScriptURL(_)),h.setAttribute("src",_);const{cspNonce:L}=s.getConfig().getOptionsLiteral();L&&h.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(h)}}}function M(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(s)),this._cachedCanUseEval}load(s,_,t,m){if(/^node\|/.test(_)){const h=s.getConfig().getOptionsLiteral(),c=f(s.getRecorder(),h.nodeRequire||U.global.nodeRequire),L=_.split("|");let d=null;try{d=c(L[1])}catch(y){m(y);return}s.enqueueDefineAnonymousModule([],function(){return d}),t()}else{const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(_).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${_}`,(h?self.eval(h.createScript("",L)):new Function(L)).call(self),t()}).then(void 0,m);return}try{h&&(_=h.createScriptURL(_)),importScripts(_),t()}catch(L){m(L)}}}}class u{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,_){const{nodeCachedData:t}=_.getConfig().getOptionsLiteral();if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,h=s("module");function c(L){const d=L.constructor;let y=function(R){try{return L.require(R)}finally{}};return y.resolve=function(R,S){return d._resolveFilename(R,L,!1,S)},y.resolve.paths=function(R){return d._resolveLookupPaths(R,L)},y.main=process.mainModule,y.extensions=d._extensions,y.cache=d._cache,y}h.prototype._compile=function(L,d){const y=h.wrap(L.replace(/^#!.*/,"")),C=_.getRecorder(),R=m._getCachedDataPath(t,d),S={filename:d};let p;try{const A=m._fs.readFileSync(R);p=A.slice(0,16),S.cachedData=A.slice(16),C.record(60,R)}catch{C.record(61,R)}const r=new m._vm.Script(y,S),l=r.runInThisContext(S),o=m._path.dirname(d),v=c(this),b=[this.exports,v,this,d,o,process,Ee,Buffer],w=l.apply(this.exports,b);return m._handleCachedData(r,y,R,!S.cachedData,_),m._verifyCachedData(r,y,R,p,_),w}}load(s,_,t,m){const h=s.getConfig().getOptionsLiteral(),c=f(s.getRecorder(),h.nodeRequire||U.global.nodeRequire),L=h.nodeInstrumenter||function(y){return y};this._init(c),this._initNodeRequire(c,s);let d=s.getRecorder();if(/^node\|/.test(_)){let y=_.split("|"),C=null;try{C=c(y[1])}catch(R){m(R);return}s.enqueueDefineAnonymousModule([],()=>C),t()}else{_=U.Utilities.fileUriToFilePath(this._env.isWindows,_);const y=this._path.normalize(_),C=this._getElectronRendererScriptPathOrUri(y),R=!!h.nodeCachedData,S=R?this._getCachedDataPath(h.nodeCachedData,_):void 0;this._readSourceAndCachedData(y,S,d,(p,r,l,o)=>{if(p){m(p);return}let v;r.charCodeAt(0)===u._BOM?v=u._PREFIX+r.substring(1)+u._SUFFIX:v=u._PREFIX+r+u._SUFFIX,v=L(v,y);const b={filename:C,cachedData:l},w=this._createAndEvalScript(s,v,b,t,m);this._handleCachedData(w,v,S,R&&!l,s),this._verifyCachedData(w,v,S,o,s)})}}_createAndEvalScript(s,_,t,m,h){const c=s.getRecorder();c.record(31,t.filename);const L=new this._vm.Script(_,t),d=L.runInThisContext(t),y=s.getGlobalAMDDefineFunc();let C=!1;const R=function(){return C=!0,y.apply(null,arguments)};return R.amd=y.amd,d.call(U.global,s.getGlobalAMDRequireFunc(),R,t.filename,this._path.dirname(t.filename)),c.record(32,t.filename),C?m():h(new Error(`Didn't receive define call in ${t.filename}!`)),L}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let _=s.match(/^([a-z])\:(.*)/i);return _?`file:///${(_[1].toUpperCase()+":"+_[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,_){const t=this._crypto.createHash("md5").update(_,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(_).replace(/\.js$/,"");return this._path.join(s.path,`${m}-${t}.code`)}_handleCachedData(s,_,t,m,h){s.cachedDataRejected?this._fs.unlink(t,c=>{h.getRecorder().record(62,t),this._createAndWriteCachedData(s,_,t,h),c&&h.getConfig().onError(c)}):m&&this._createAndWriteCachedData(s,_,t,h)}_createAndWriteCachedData(s,_,t,m){let h=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),c=-1,L=0,d;const y=()=>{setTimeout(()=>{d||(d=this._crypto.createHash("md5").update(_,"utf8").digest());const C=s.createCachedData();if(!(C.length===0||C.length===c||L>=5)){if(C.length<c){y();return}c=C.length,this._fs.writeFile(t,Buffer.concat([d,C]),R=>{R&&m.getConfig().onError(R),m.getRecorder().record(63,t),y()})}},h*Math.pow(4,L++))};y()}_readSourceAndCachedData(s,_,t,m){if(!_)this._fs.readFile(s,{encoding:"utf8"},m);else{let h,c,L,d=2;const y=C=>{C?m(C):--d===0&&m(void 0,h,c,L)};this._fs.readFile(s,{encoding:"utf8"},(C,R)=>{h=R,y(C)}),this._fs.readFile(_,(C,R)=>{!C&&R&&R.length>0?(L=R.slice(0,16),c=R.slice(16),t.record(60,_)):t.record(61,_),y()})}}_verifyCachedData(s,_,t,m,h){m&&(s.cachedDataRejected||setTimeout(()=>{const c=this._crypto.createHash("md5").update(_,"utf8").digest();m.equals(c)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${t}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(t,L=>{L&&h.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function f(a,s){if(s.__$__isRecorded)return s;const _=function(m){a.record(33,m);try{return s(m)}finally{a.record(34,m)}};return _.__$__isRecorded=!0,_}U.ensureRecordedNodeRequire=f;function g(a){return new n(a)}U.createScriptLoader=g})(_e||(_e={}));var _e;(function(U){class n{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,_;for(_=/\/\.\//;_.test(s);)s=s.replace(_,"/");for(s=s.replace(/^\.\//g,""),_=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;_.test(s);)s=s.replace(_,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return U.Utilities.isAbsolutePath(s)||(U.Utilities.startsWith(s,"./")||U.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),U.ModuleIdResolver=n;class E{constructor(a,s,_,t,m,h){this.id=a,this.strId=s,this.dependencies=_,this._callback=t,this._errorback=m,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(U.global,s),producedError:null}}catch(_){return{returnedValue:null,producedError:_}}}static _invokeFactory(a,s,_,t){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(_,t):{returnedValue:_.apply(U.global,t),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,_,t){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let h=E._invokeFactory(s,this.strId,this._callback,_);m=h.producedError,a.record(22,this.strId),!m&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(m){let h=U.ensureError(m);h.phase="factory",h.moduleId=this.strId,h.neededBy=t(this.id),this.error=h,s.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}U.Module=E;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),U.RegularDependency=i;class u{constructor(a,s,_){this.id=a,this.pluginId=s,this.pluginParam=_}}U.PluginDependency=u;class f{constructor(a,s,_,t,m=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=m,this._defineFunc=_,this._requireFunc=t,this._moduleIdProvider=new M,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new f(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let _=h=>h.replace(/\\/g,"/"),t=_(a),m=s.split(/\n/);for(let h=0;h<m.length;h++){let c=m[h].match(/(.*):(\d+):(\d+)\)?$/);if(c){let L=c[1],d=c[2],y=c[3],C=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(C),L=_(L),L===t){let R={line:parseInt(d,10),col:parseInt(y,10)};return R.line===1&&(R.col-=53),R}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let _=0,t=this._modules2.length;_<t;_++){let m=this._modules2[_];if(!m)continue;let h=this._buildInfoPath[m.id]||null,c=this._buildInfoDefineStack[m.id]||null,L=this._buildInfoDependencies[m.id];a[s++]={id:m.strId,path:h,defineLocation:h&&c?f._findRelevantLocationInStack(h,c):null,dependencies:L,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let _=null;this._config.isBuild()&&(_=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:_,dependencies:a,callback:s}}defineModule(a,s,_,t,m,h=new n(a)){let c=this._moduleIdProvider.getModuleId(a);if(this._modules2[c]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let L=new E(c,a,this._normalizeDependencies(s,h),_,t,h);this._modules2[c]=L,this._config.isBuild()&&(this._buildInfoDefineStack[c]=m,this._buildInfoDependencies[c]=(L.dependencies||[]).map(d=>this._moduleIdProvider.getStrModuleId(d.id))),this._resolve(L)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let _=a.indexOf("!");if(_>=0){let t=s.resolveModule(a.substr(0,_)),m=s.resolveModule(a.substr(_+1)),h=this._moduleIdProvider.getModuleId(t+"!"+m),c=this._moduleIdProvider.getModuleId(t);return new u(h,c,m)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let _=[],t=0;for(let m=0,h=a.length;m<h;m++)_[t++]=this._normalizeDependency(a[m],s);return _}_relativeRequire(a,s,_,t){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(U.Utilities.generateAnonymousModule(),s,_,t,null,a)}synchronousRequire(a,s=new n(a)){let _=this._normalizeDependency(a,s),t=this._modules2[_.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports}configure(a,s){let _=this._config.shouldRecordStats();s?this._config=new U.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!_&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let _=this._moduleIdProvider.getStrModuleId(a),t=(this._inverseDependencies2[a]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const m=U.ensureError(s);return m.phase="loading",m.moduleId=_,m.neededBy=t,m}_onLoadError(a,s){const _=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new E(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let t=[];for(let c=0,L=this._moduleIdProvider.getMaxModuleId();c<L;c++)t[c]=!1;let m=!1,h=[];for(h.push(a),t[a]=!0;h.length>0;){let c=h.shift(),L=this._modules2[c];L&&(m=L.onDependencyError(_)||m);let d=this._inverseDependencies2[c];if(d)for(let y=0,C=d.length;y<C;y++){let R=d[y];t[R]||(h.push(R),t[R]=!0)}}m||this._config.onError(_)}_hasDependencyPath(a,s){let _=this._modules2[a];if(!_)return!1;let t=[];for(let h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)t[h]=!1;let m=[];for(m.push(_),t[a]=!0;m.length>0;){let c=m.shift().dependencies;if(c)for(let L=0,d=c.length;L<d;L++){let y=c[L];if(y.id===s)return!0;let C=this._modules2[y.id];C&&!t[y.id]&&(t[y.id]=!0,m.push(C))}}return!1}_findCyclePath(a,s,_){if(a===s||_===50)return[a];let t=this._modules2[a];if(!t)return null;let m=t.dependencies;if(m)for(let h=0,c=m.length;h<c;h++){let L=this._findCyclePath(m[h].id,s,_+1);if(L!==null)return L.push(a),L}return null}_createRequire(a){let s=(_,t,m)=>this._relativeRequire(a,_,t,m);return s.toUrl=_=>this._config.requireToUrl(a.resolveModule(_)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(_,t=!1)=>{this.configure(_,t)},s.__$__nodeRequire=U.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),_=this._config.moduleIdToPaths(s),t=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||t.test(s))&&_.push("node|"+s);let m=-1,h=c=>{if(m++,m>=_.length)this._onLoadError(a,c);else{let L=_[m],d=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[a]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}d.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=L),d.record(11,L),this._onLoad(a)},y=>{d.record(12,L),h(y)})}};h(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let _=t=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],t,null,null)};_.error=t=>{this._config.onError(this._createLoadError(s.id,t))},a.load(s.pluginParam,this._createRequire(n.ROOT),_,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let _=0,t=s.length;_<t;_++){let m=s[_];if(m===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===i.MODULE){a.unresolvedDependenciesCount--;continue}if(m===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let h=this._modules2[m.id];if(h&&h.isComplete()){if(h.error){a.onDependencyError(h.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let c=this._findCyclePath(m.id,a.id,0)||[];c.reverse(),c.push(m.id),console.warn(c.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof u){let c=this._modules2[m.pluginId];if(c&&c.isComplete()){this._loadPluginDependency(c.exports,m);continue}let L=this._inversePluginDependencies2.get(m.pluginId);L||(L=[],this._inversePluginDependencies2.set(m.pluginId,L)),L.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let _=a.dependencies,t=[];if(_)for(let L=0,d=_.length;L<d;L++){let y=_[L];if(y===i.EXPORTS){t[L]=a.exports;continue}if(y===i.MODULE){t[L]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(y===i.REQUIRE){t[L]=this._createRequire(a.moduleIdResolver);continue}let C=this._modules2[y.id];if(C){t[L]=C.exports;continue}t[L]=null}const m=L=>(this._inverseDependencies2[L]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));a.complete(s,this._config,t,m);let h=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,h)for(let L=0,d=h.length;L<d;L++){let y=h[L],C=this._modules2[y];C.unresolvedDependenciesCount--,C.unresolvedDependenciesCount===0&&this._onModuleComplete(C)}let c=this._inversePluginDependencies2.get(a.id);if(c){this._inversePluginDependencies2.delete(a.id);for(let L=0,d=c.length;L<d;L++)this._loadPluginDependency(a.exports,c[L])}}}U.ModuleManager=f})(_e||(_e={}));var K,_e;(function(U){const n=new U.Environment;let E=null;const M=function(g,a,s){typeof g!="string"&&(s=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),g?E.defineModule(g,a,s,null,null):E.enqueueDefineAnonymousModule(a,s)};M.amd={jQuery:!0};const i=function(g,a=!1){E.configure(g,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return E.getConfig().getOptionsLiteral()},u.reset=function(){E=E.reset()},u.getBuildInfo=function(){return E.getBuildInfo()},u.getStats=function(){return E.getLoaderEvents()},u.define=M;function f(){if(typeof U.global.require<"u"||typeof require<"u"){const g=U.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=U.ensureRecordedNodeRequire(E.getRecorder(),g);U.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=u:(n.isElectronRenderer||(U.global.define=M),U.global.require=u)}U.init=f,(typeof U.global.define!="function"||!U.global.define.amd)&&(E=new U.ModuleManager(n,U.createScriptLoader(n),M,u,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require<"u"&&typeof U.global.require!="function"&&u.config(U.global.require),K=function(){return M.apply(null,arguments)},K.amd=M.amd,typeof doNotInitLoader>"u"&&f())})(_e||(_e={}));var pe=this&&this.__awaiter||function(U,n,E,M){function i(u){return u instanceof E?u:new E(function(f){f(u)})}return new(E||(E=Promise))(function(u,f){function g(_){try{s(M.next(_))}catch(t){f(t)}}function a(_){try{s(M.throw(_))}catch(t){f(t)}}function s(_){_.done?u(_.value):i(_.value).then(g,a)}s((M=M.apply(U,n||[])).next())})};K(te[15],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(c,L){let d;return L.length===0?d=c:d=c.replace(/\{(\d+)\}/g,(y,C)=>{const R=C[0],S=L[R];let p=y;return typeof S=="string"?p=S:(typeof S=="number"||typeof S=="boolean"||S===void 0||S===null)&&(p=String(S)),p}),E&&(d="\uFF3B"+d.replace(/[aouei]/g,"$&$&")+"\uFF3D"),d}function u(c,L){let d=c[L];return d||(d=c["*"],d)?d:null}function f(c){return c.charAt(c.length-1)==="/"?c:c+"/"}function g(c,L,d){return pe(this,void 0,void 0,function*(){const y=f(c)+f(L)+"vscode/"+f(d),C=yield fetch(y);if(C.ok)return yield C.json();throw new Error(`${C.status} - ${C.statusText}`)})}function a(c){return function(L,d){const y=Array.prototype.slice.call(arguments,2);return i(c[L],y)}}function s(c,L,...d){return i(L,d)}n.localize=s;function _(c){}n.getConfiguredDefaultLocale=_;function t(c){E=c}n.setPseudoTranslation=t;function m(c,L){var d;return{localize:a(L[c]),getConfiguredDefaultLocale:(d=L.getConfiguredDefaultLocale)!==null&&d!==void 0?d:y=>{}}}n.create=m;function h(c,L,d,y){var C;const R=(C=y["vs/nls"])!==null&&C!==void 0?C:{};if(!c||c.length===0)return d({localize:s,getConfiguredDefaultLocale:()=>{var o;return(o=R.availableLanguages)===null||o===void 0?void 0:o["*"]}});const S=R.availableLanguages?u(R.availableLanguages,c):null,p=S===null||S===M;let r=".nls";p||(r=r+"."+S);const l=o=>{Array.isArray(o)?o.localize=a(o):o.localize=a(o[c]),o.getConfiguredDefaultLocale=()=>{var v;return(v=R.availableLanguages)===null||v===void 0?void 0:v["*"]},d(o)};typeof R.loadBundle=="function"?R.loadBundle(c,S,(o,v)=>{o?L([c+".nls"],l):l(v)}):R.translationServiceUrl&&!p?pe(this,void 0,void 0,function*(){var o;try{const v=yield g(R.translationServiceUrl,S,c);return l(v)}catch(v){if(!S.includes("-"))return console.error(v),L([c+".nls"],l);try{const b=S.split("-")[0],w=yield g(R.translationServiceUrl,b,c);return(o=R.availableLanguages)!==null&&o!==void 0||(R.availableLanguages={}),R.availableLanguages["*"]=b,l(w)}catch(b){return console.error(b),L([c+".nls"],l)}}}):L([c+r],l,o=>{if(r===".nls"){console.error("Failed trying to load default language strings",o);return}console.error(`Failed to load message bundle for language ${S}. Falling back to the default language:`,o),L([c+".nls"],l)})}n.load=h}),function(){const U=globalThis.MonacoEnvironment,n=U&&U.baseUrl?U.baseUrl:"../../../";function E(_,t){var m;if(U?.createTrustedTypesPolicy)try{return U.createTrustedTypesPolicy(_,t)}catch(h){console.warn(h);return}try{return(m=self.trustedTypes)===null||m===void 0?void 0:m.createPolicy(_,t)}catch(h){console.warn(h);return}}const M=E("amdLoader",{createScriptURL:_=>_,createScript:(_,...t)=>{const m=t.slice(0,-1).join(","),h=t.pop().toString();return`(function anonymous(${m}) { ${h}
})`}});function i(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function u(){return new Promise((_,t)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return _();const m=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(m).then(c=>{if(c.status!==200)throw new Error(c.statusText);return c.text()}).then(c=>{c=`${c}
//# sourceURL=${m}`,(M?globalThis.eval(M.createScript("",c)):new Function(c)).call(globalThis),_()}).then(void 0,t);return}M?importScripts(M.createScriptURL(m)):importScripts(m),_()})}function f(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function g(_){u().then(()=>{f(),require([_],function(t){setTimeout(function(){const m=t.create((h,c)=>{globalThis.postMessage(h,c)},null);for(globalThis.onmessage=h=>m.onmessage(h.data,h.ports);s.length>0;){const h=s.shift();m.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&f();let a=!0;const s=[];globalThis.onmessage=_=>{if(!a){s.push(_);return}a=!1,g(_.data)}}(),K(te[16],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMaxIdxBy=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.findLastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(e,P=0){return e[e.length-(1+P)]}n.tail=E;function M(e){if(e.length===0)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]}n.tail2=M;function i(e,P,k=(I,V)=>I===V){if(e===P)return!0;if(!e||!P||e.length!==P.length)return!1;for(let I=0,V=e.length;I<V;I++)if(!k(e[I],P[I]))return!1;return!0}n.equals=i;function u(e,P){const k=e.length-1;P<k&&(e[P]=e[k]),e.pop()}n.removeFastWithoutKeepingOrder=u;function f(e,P,k){return g(e.length,I=>k(e[I],P))}n.binarySearch=f;function g(e,P){let k=0,I=e-1;for(;k<=I;){const V=(k+I)/2|0,Q=P(V);if(Q<0)k=V+1;else if(Q>0)I=V-1;else return V}return-(k+1)}n.binarySearch2=g;function a(e,P){let k=0,I=e.length;if(I===0)return 0;for(;k<I;){const V=Math.floor((k+I)/2);P(e[V])?I=V:k=V+1}return k}n.findFirstInSorted=a;function s(e,P,k){if(e=e|0,e>=P.length)throw new TypeError("invalid index");const I=P[Math.floor(P.length*Math.random())],V=[],Q=[],ee=[];for(const ue of P){const he=k(ue,I);he<0?V.push(ue):he>0?Q.push(ue):ee.push(ue)}return e<V.length?s(e,V,k):e<V.length+ee.length?ee[0]:s(e-(V.length+ee.length),Q,k)}n.quickSelect=s;function _(e,P){const k=[];let I;for(const V of e.slice(0).sort(P))!I||P(I[0],V)!==0?(I=[V],k.push(I)):I.push(V);return k}n.groupBy=_;function t(e){return e.filter(P=>!!P)}n.coalesce=t;function m(e){let P=0;for(let k=0;k<e.length;k++)e[k]&&(e[P]=e[k],P+=1);e.length=P}n.coalesceInPlace=m;function h(e){return!Array.isArray(e)||e.length===0}n.isFalsyOrEmpty=h;function c(e){return Array.isArray(e)&&e.length>0}n.isNonEmptyArray=c;function L(e,P=k=>k){const k=new Set;return e.filter(I=>{const V=P(I);return k.has(V)?!1:(k.add(V),!0)})}n.distinct=L;function d(e,P){const k=y(e,P);if(k!==-1)return e[k]}n.findLast=d;function y(e,P){for(let k=e.length-1;k>=0;k--){const I=e[k];if(P(I))return k}return-1}n.findLastIndex=y;function C(e,P){return e.length>0?e[0]:P}n.firstOrDefault=C;function R(e,P){let k=typeof P=="number"?e:0;typeof P=="number"?k=e:(k=0,P=e);const I=[];if(k<=P)for(let V=k;V<P;V++)I.push(V);else for(let V=k;V>P;V--)I.push(V);return I}n.range=R;function S(e,P,k){const I=e.slice(0,P),V=e.slice(P);return I.concat(k,V)}n.arrayInsert=S;function p(e,P){const k=e.indexOf(P);k>-1&&(e.splice(k,1),e.unshift(P))}n.pushToStart=p;function r(e,P){const k=e.indexOf(P);k>-1&&(e.splice(k,1),e.push(P))}n.pushToEnd=r;function l(e,P){for(const k of P)e.push(k)}n.pushMany=l;function o(e){return Array.isArray(e)?e:[e]}n.asArray=o;function v(e,P){for(const k of e){const I=P(k);if(I!==void 0)return I}}n.mapFind=v;function b(e,P,k){const I=A(e,P),V=e.length,Q=k.length;e.length=V+Q;for(let ee=V-1;ee>=I;ee--)e[ee+Q]=e[ee];for(let ee=0;ee<Q;ee++)e[ee+I]=k[ee]}n.insertInto=b;function w(e,P,k,I){const V=A(e,P),Q=e.splice(V,k);return b(e,V,I),Q}n.splice=w;function A(e,P){return P<0?Math.max(P+e.length,0):Math.min(P,e.length)}var N;(function(e){function P(Q){return Q<0}e.isLessThan=P;function k(Q){return Q<=0}e.isLessThanOrEqual=k;function I(Q){return Q>0}e.isGreaterThan=I;function V(Q){return Q===0}e.isNeitherLessOrGreaterThan=V,e.greaterThan=1,e.lessThan=-1,e.neitherLessOrGreaterThan=0})(N||(n.CompareResult=N={}));function F(e,P){return(k,I)=>P(e(k),e(I))}n.compareBy=F;function O(...e){return(P,k)=>{for(const I of e){const V=I(P,k);if(!N.isNeitherLessOrGreaterThan(V))return V}return N.neitherLessOrGreaterThan}}n.tieBreakComparators=O;const q=(e,P)=>e-P;n.numberComparator=q;const T=(e,P)=>(0,n.numberComparator)(e?1:0,P?1:0);n.booleanComparator=T;function W(e){return(P,k)=>-e(P,k)}n.reverseOrder=W;function G(e,P){if(e.length===0)return;let k=e[0];for(let I=1;I<e.length;I++){const V=e[I];P(V,k)>0&&(k=V)}return k}n.findMaxBy=G;function ae(e,P){if(e.length===0)return;let k=e[0];for(let I=1;I<e.length;I++){const V=e[I];P(V,k)>=0&&(k=V)}return k}n.findLastMaxBy=ae;function re(e,P){return G(e,(k,I)=>-P(k,I))}n.findMinBy=re;function ne(e,P){if(e.length===0)return-1;let k=0;for(let I=1;I<e.length;I++){const V=e[I];P(V,e[k])>0&&(k=I)}return k}n.findMaxIdxBy=ne;class fe{constructor(P){this.items=P,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(P){let k=this.firstIdx;for(;k<this.items.length&&P(this.items[k]);)k++;const I=k===this.firstIdx?null:this.items.slice(this.firstIdx,k);return this.firstIdx=k,I}takeFromEndWhile(P){let k=this.lastIdx;for(;k>=0&&P(this.items[k]);)k--;const I=k===this.lastIdx?null:this.items.slice(k+1,this.lastIdx+1);return this.lastIdx=k,I}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const P=this.items[this.firstIdx];return this.firstIdx++,P}takeCount(P){const k=this.items.slice(this.firstIdx,this.firstIdx+P);return this.firstIdx+=P,k}}n.ArrayQueue=fe;class ${constructor(P){this.iterate=P}toArray(){const P=[];return this.iterate(k=>(P.push(k),!0)),P}filter(P){return new $(k=>this.iterate(I=>P(I)?k(I):!0))}map(P){return new $(k=>this.iterate(I=>k(P(I))))}findLast(P){let k;return this.iterate(I=>(P(I)&&(k=I),!0)),k}findLastMaxBy(P){let k,I=!0;return this.iterate(V=>((I||N.isGreaterThan(P(V,k)))&&(I=!1,k=V),!0)),k}}n.CallbackIterable=$,$.empty=new $(e=>{})}),K(te[27],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(u){this.fn=u,this.lastCache=void 0,this.lastArgKey=void 0}get(u){const f=JSON.stringify(u);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(u)),this.lastCache}}n.LRUCachedFunction=E;class M{get cachedValues(){return this._map}constructor(u){this.fn=u,this._map=new Map}get(u){if(this._map.has(u))return this._map.get(u);const f=this.fn(u);return this._map.set(u,f),f}}n.CachedFunction=M}),K(te[28],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=void 0;class E{constructor(){this.map=new Map}add(i,u){let f=this.map.get(i);f||(f=new Set,this.map.set(i,f)),f.add(u)}delete(i,u){const f=this.map.get(i);f&&(f.delete(u),f.size===0&&this.map.delete(i))}forEach(i,u){const f=this.map.get(i);f&&f.forEach(u)}get(i){const u=this.map.get(i);return u||new Set}}n.SetMap=E}),K(te[29],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function E(g,a){const s=Math.pow(10,a);return Math.round(g*s)/s}class M{constructor(a,s,_,t=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,_))|0,this.a=E(Math.max(Math.min(1,t),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}n.RGBA=M;class i{constructor(a,s,_,t){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.l=E(Math.max(Math.min(1,_),0),3),this.a=E(Math.max(Math.min(1,t),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,_=a.g/255,t=a.b/255,m=a.a,h=Math.max(s,_,t),c=Math.min(s,_,t);let L=0,d=0;const y=(c+h)/2,C=h-c;if(C>0){switch(d=Math.min(y<=.5?C/(2*y):C/(2-2*y),1),h){case s:L=(_-t)/C+(_<t?6:0);break;case _:L=(t-s)/C+2;break;case t:L=(s-_)/C+4;break}L*=60,L=Math.round(L)}return new i(L,d,y,m)}static _hue2rgb(a,s,_){return _<0&&(_+=1),_>1&&(_-=1),_<1/6?a+(s-a)*6*_:_<1/2?s:_<2/3?a+(s-a)*(2/3-_)*6:a}static toRGBA(a){const s=a.h/360,{s:_,l:t,a:m}=a;let h,c,L;if(_===0)h=c=L=t;else{const d=t<.5?t*(1+_):t+_-t*_,y=2*t-d;h=i._hue2rgb(y,d,s+1/3),c=i._hue2rgb(y,d,s),L=i._hue2rgb(y,d,s-1/3)}return new M(Math.round(h*255),Math.round(c*255),Math.round(L*255),m)}}n.HSLA=i;class u{constructor(a,s,_,t){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.v=E(Math.max(Math.min(1,_),0),3),this.a=E(Math.max(Math.min(1,t),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,_=a.g/255,t=a.b/255,m=Math.max(s,_,t),h=Math.min(s,_,t),c=m-h,L=m===0?0:c/m;let d;return c===0?d=0:m===s?d=((_-t)/c%6+6)%6:m===_?d=(t-s)/c+2:d=(s-_)/c+4,new u(Math.round(d*60),L,m,a.a)}static toRGBA(a){const{h:s,s:_,v:t,a:m}=a,h=t*_,c=h*(1-Math.abs(s/60%2-1)),L=t-h;let[d,y,C]=[0,0,0];return s<60?(d=h,y=c):s<120?(d=c,y=h):s<180?(y=h,C=c):s<240?(y=c,C=h):s<300?(d=c,C=h):s<=360&&(d=h,C=c),d=Math.round((d+L)*255),y=Math.round((y+L)*255),C=Math.round((C+L)*255),new M(d,y,C,m)}}n.HSVA=u;class f{static fromHex(a){return f.Format.CSS.parseHex(a)||f.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof M)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof u)this._hsva=a,this.rgba=u.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&M.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&u.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=f._relativeLuminanceForComponent(this.rgba.r),s=f._relativeLuminanceForComponent(this.rgba.g),_=f._relativeLuminanceForComponent(this.rgba.b),t=.2126*a+.7152*s+.0722*_;return E(t,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),_=a.getRelativeLuminance();return s>_}isDarkerThan(a){const s=this.getRelativeLuminance(),_=a.getRelativeLuminance();return s<_}lighten(a){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:_,b:t,a:m}=this.rgba;return new f(new M(s,_,t,m*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new f(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:_,b:t,a:m}=this.rgba;return new f(new M(a.rgba.r-m*(a.rgba.r-s),a.rgba.g-m*(a.rgba.g-_),a.rgba.b-m*(a.rgba.b-t),1))}toString(){return this._toString||(this._toString=f.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,_){if(a.isLighterThan(s))return a;_=_||.5;const t=a.getRelativeLuminance(),m=s.getRelativeLuminance();return _=_*(m-t)/m,a.lighten(_)}static getDarkerColor(a,s,_){if(a.isDarkerThan(s))return a;_=_||.5;const t=a.getRelativeLuminance(),m=s.getRelativeLuminance();return _=_*(t-m)/t,a.darken(_)}}n.Color=f,f.white=new f(new M(255,255,255,1)),f.black=new f(new M(0,0,0,1)),f.red=new f(new M(255,0,0,1)),f.blue=new f(new M(0,0,255,1)),f.green=new f(new M(0,255,0,1)),f.cyan=new f(new M(0,255,255,1)),f.lightgrey=new f(new M(211,211,211,1)),f.transparent=new f(new M(0,0,0,0)),function(g){let a;(function(s){let _;(function(t){function m(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:g.Format.CSS.formatRGBA(r)}t.formatRGB=m;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}t.formatRGBA=h;function c(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(r)}t.formatHSL=c;function L(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}t.formatHSLA=L;function d(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function y(r){return`#${d(r.rgba.r)}${d(r.rgba.g)}${d(r.rgba.b)}`}t.formatHex=y;function C(r,l=!1){return l&&r.rgba.a===1?g.Format.CSS.formatHex(r):`#${d(r.rgba.r)}${d(r.rgba.g)}${d(r.rgba.b)}${d(Math.round(r.rgba.a*255))}`}t.formatHexA=C;function R(r){return r.isOpaque()?g.Format.CSS.formatHex(r):g.Format.CSS.formatRGBA(r)}t.format=R;function S(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const o=16*p(r.charCodeAt(1))+p(r.charCodeAt(2)),v=16*p(r.charCodeAt(3))+p(r.charCodeAt(4)),b=16*p(r.charCodeAt(5))+p(r.charCodeAt(6));return new g(new M(o,v,b,1))}if(l===9){const o=16*p(r.charCodeAt(1))+p(r.charCodeAt(2)),v=16*p(r.charCodeAt(3))+p(r.charCodeAt(4)),b=16*p(r.charCodeAt(5))+p(r.charCodeAt(6)),w=16*p(r.charCodeAt(7))+p(r.charCodeAt(8));return new g(new M(o,v,b,w/255))}if(l===4){const o=p(r.charCodeAt(1)),v=p(r.charCodeAt(2)),b=p(r.charCodeAt(3));return new g(new M(16*o+o,16*v+v,16*b+b))}if(l===5){const o=p(r.charCodeAt(1)),v=p(r.charCodeAt(2)),b=p(r.charCodeAt(3)),w=p(r.charCodeAt(4));return new g(new M(16*o+o,16*v+v,16*b+b,(16*w+w)/255))}return null}t.parseHex=S;function p(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(_=s.CSS||(s.CSS={}))})(a=g.Format||(g.Format={}))}(f||(n.Color=f={}))}),K(te[30],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,u,f,g){this.originalStart=i,this.originalLength=u,this.modifiedStart=f,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),K(te[3],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(d){setTimeout(()=>{throw d.stack?h.isErrorNoTelemetry(d)?new h(d.message+`

`+d.stack):new Error(d.message+`

`+d.stack):d},0)}}emit(d){this.listeners.forEach(y=>{y(d)})}onUnexpectedError(d){this.unexpectedErrorHandler(d),this.emit(d)}onUnexpectedExternalError(d){this.unexpectedErrorHandler(d)}}n.ErrorHandler=E,n.errorHandler=new E;function M(L){g(L)||n.errorHandler.onUnexpectedError(L)}n.onUnexpectedError=M;function i(L){g(L)||n.errorHandler.onUnexpectedExternalError(L)}n.onUnexpectedExternalError=i;function u(L){if(L instanceof Error){const{name:d,message:y}=L,C=L.stacktrace||L.stack;return{$isError:!0,name:d,message:y,stack:C,noTelemetry:h.isErrorNoTelemetry(L)}}return L}n.transformErrorForSerialization=u;const f="Canceled";function g(L){return L instanceof a?!0:L instanceof Error&&L.name===f&&L.message===f}n.isCancellationError=g;class a extends Error{constructor(){super(f),this.name=this.message}}n.CancellationError=a;function s(){const L=new Error(f);return L.name=L.message,L}n.canceled=s;function _(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}n.illegalArgument=_;function t(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}n.illegalState=t;class m extends Error{constructor(d){super("NotSupported"),d&&(this.message=d)}}n.NotSupportedError=m;class h extends Error{constructor(d){super(d),this.name="CodeExpectedError"}static fromError(d){if(d instanceof h)return d;const y=new h;return y.message=d.message,y.stack=d.stack,y}static isErrorNoTelemetry(d){return d.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class c extends Error{constructor(d){super(d||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}n.BugIndicatingError=c}),K(te[9],ie([0,1,3]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(g,a){if(!g)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}n.ok=M;function i(g,a="Unreachable"){throw new Error(a)}n.assertNever=i;function u(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=u;function f(g,a){let s=0;for(;s<g.length-1;){const _=g[s],t=g[s+1];if(!a(_,t))return!1;s++}return!0}n.checkAdjacentItems=f}),K(te[17],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(M){const i=this;let u=!1,f;return function(){return u||(u=!0,f=M.apply(i,arguments)),f}}n.once=E}),K(te[18],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(M){function i(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=i;const u=Object.freeze([]);function f(){return u}M.empty=f;function*g(S){yield S}M.single=g;function a(S){return i(S)?S:g(S)}M.wrap=a;function s(S){return S||u}M.from=s;function _(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=_;function t(S){return S[Symbol.iterator]().next().value}M.first=t;function m(S,p){for(const r of S)if(p(r))return!0;return!1}M.some=m;function h(S,p){for(const r of S)if(p(r))return r}M.find=h;function*c(S,p){for(const r of S)p(r)&&(yield r)}M.filter=c;function*L(S,p){let r=0;for(const l of S)yield p(l,r++)}M.map=L;function*d(...S){for(const p of S)for(const r of p)yield r}M.concat=d;function y(S,p,r){let l=r;for(const o of S)l=p(l,o);return l}M.reduce=y;function*C(S,p,r=S.length){for(p<0&&(p+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);p<r;p++)yield S[p]}M.slice=C;function R(S,p=Number.POSITIVE_INFINITY){const r=[];if(p===0)return[r,S];const l=S[Symbol.iterator]();for(let o=0;o<p;o++){const v=l.next();if(v.done)return[r,M.empty()];r.push(v.value)}return[r,{[Symbol.iterator](){return l}}]}M.consume=R})(E||(n.Iterable=E={}))}),K(te[31],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,h){this._keyCodeToStr[m]=h,this._strToKeyCode[h.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const M=new E,i=new E,u=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],g=Object.create(null),a=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)n.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=132;t++)n.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",m=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],h=[],c=[];for(const L of m){const[d,y,C,R,S,p,r,l,o]=L;if(c[y]||(c[y]=!0,f[y]=C,g[C]=y,a[C.toLowerCase()]=y,d&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=R,R!==0&&R!==3&&R!==5&&R!==4&&R!==6&&R!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[R]=y))),!h[R]){if(h[R]=!0,!S)throw new Error(`String representation missing for key code ${R} around scan code ${C}`);M.define(R,S),i.define(R,l||S),u.define(R,o||l||S)}p&&(n.EVENT_KEY_CODE_MAP[p]=R),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=R)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(t){function m(C){return M.keyCodeToStr(C)}t.toString=m;function h(C){return M.strToKeyCode(C)}t.fromString=h;function c(C){return i.keyCodeToStr(C)}t.toUserSettingsUS=c;function L(C){return u.keyCodeToStr(C)}t.toUserSettingsGeneral=L;function d(C){return i.strToKeyCode(C)||u.strToKeyCode(C)}t.fromUserSettings=d;function y(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(C)}t.toElectronAccelerator=y})(s||(n.KeyCodeUtils=s={}));function _(t,m){const h=(m&65535)<<16>>>0;return(t|h)>>>0}n.KeyChord=_}),K(te[32],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),K(te[10],ie([0,1,17,18]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let u=null;function f(r){u=r}if(n.setDisposableTracker=f,i){const r="__is_disposable_tracked__";f(new class{trackDisposable(l){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(o)},3e3)}setParent(l,o){if(l&&l!==y.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==y.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function g(r){return u?.trackDisposable(r),r}function a(r){u?.markAsDisposed(r)}function s(r,l){u?.setParent(r,l)}function _(r,l){if(u)for(const o of r)u.setParent(o,l)}function t(r){return u?.markAsSingleton(r),r}n.markAsSingleton=t;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=m;function h(r){if(M.Iterable.is(r)){const l=[];for(const o of r)if(o)try{o.dispose()}catch(v){l.push(v)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=h;function c(...r){const l=L(()=>h(r));return _(r,l),l}n.combinedDisposable=c;function L(r){const l=g({dispose:(0,E.once)(()=>{a(l),r()})});return l}n.toDisposable=L;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,g(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return s(l,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}n.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new d,g(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var o;this._isDisposed||l===this._value||((o=this._value)===null||o===void 0||o.dispose(),l&&s(l,this),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,a(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}n.MutableDisposable=C;class R{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=R;class S{constructor(l){this.object=l}dispose(){}}n.ImmortalReference=S;class p{constructor(){this._store=new Map,this._isDisposed=!1,g(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}get(l){return this._store.get(l)}set(l,o,v=!1){var b;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||(b=this._store.get(l))===null||b===void 0||b.dispose(),this._store.set(l,o)}deleteAndDispose(l){var o;(o=this._store.get(l))===null||o===void 0||o.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=p}),K(te[19],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(u){this.element=u,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let u=this._first;for(;u!==E.Undefined;){const f=u.next;u.prev=E.Undefined,u.next=E.Undefined,u=f}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,f){const g=new E(u);if(this._first===E.Undefined)this._first=g,this._last=g;else if(f){const s=this._last;this._last=g,g.prev=s,s.next=g}else{const s=this._first;this._first=g,g.next=s,s.prev=g}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(g))}}shift(){if(this._first!==E.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==E.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==E.Undefined&&u.next!==E.Undefined){const f=u.prev;f.next=u.next,u.next.prev=f}else u.prev===E.Undefined&&u.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):u.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):u.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==E.Undefined;)yield u.element,u=u.next}}n.LinkedList=M}),K(te[20],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(u){return new M(u)}constructor(u){this._now=E&&u===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),K(te[7],ie([0,1,3,17,10,19,20]),function(U,n,E,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const g=!1,a=!1;var s;(function(b){b.None=()=>i.Disposable.None;function w(J){if(a){const{onDidAddListener:H}=J,X=h.create();let Y=0;J.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),H?.()}}}function A(J,H){return re(J,()=>{},0,void 0,!0,void 0,H)}b.defer=A;function N(J){return(H,X=null,Y)=>{let se=!1,oe;return oe=J(j=>{if(!se)return oe?oe.dispose():se=!0,H.call(X,j)},null,Y),se&&oe.dispose(),oe}}b.once=N;function F(J,H,X){return ae((Y,se=null,oe)=>J(j=>Y.call(se,H(j)),null,oe),X)}b.map=F;function O(J,H,X){return ae((Y,se=null,oe)=>J(j=>{H(j),Y.call(se,j)},null,oe),X)}b.forEach=O;function q(J,H,X){return ae((Y,se=null,oe)=>J(j=>H(j)&&Y.call(se,j),null,oe),X)}b.filter=q;function T(J){return J}b.signal=T;function W(...J){return(H,X=null,Y)=>(0,i.combinedDisposable)(...J.map(se=>se(oe=>H.call(X,oe),null,Y)))}b.any=W;function G(J,H,X,Y){let se=X;return F(J,oe=>(se=H(se,oe),se),Y)}b.reduce=G;function ae(J,H){let X;const Y={onWillAddFirstListener(){X=J(se.fire,se)},onDidRemoveLastListener(){X?.dispose()}};H||w(Y);const se=new y(Y);return H?.add(se),se.event}function re(J,H,X=100,Y=!1,se=!1,oe,j){let le,D,x,B=0,z;const Z={leakWarningThreshold:oe,onWillAddFirstListener(){le=J(de=>{B++,D=H(D,de),Y&&!x&&(ce.fire(D),D=void 0),z=()=>{const Se=D;D=void 0,x=void 0,(!Y||B>1)&&ce.fire(Se),B=0},typeof X=="number"?(clearTimeout(x),x=setTimeout(z,X)):x===void 0&&(x=0,queueMicrotask(z))})},onWillRemoveListener(){se&&B>0&&z?.()},onDidRemoveLastListener(){z=void 0,le.dispose()}};j||w(Z);const ce=new y(Z);return j?.add(ce),ce.event}b.debounce=re;function ne(J,H=0,X){return b.debounce(J,(Y,se)=>Y?(Y.push(se),Y):[se],H,void 0,!0,void 0,X)}b.accumulate=ne;function fe(J,H=(Y,se)=>Y===se,X){let Y=!0,se;return q(J,oe=>{const j=Y||!H(oe,se);return Y=!1,se=oe,j},X)}b.latch=fe;function $(J,H,X){return[b.filter(J,H,X),b.filter(J,Y=>!H(Y),X)]}b.split=$;function e(J,H=!1,X=[]){let Y=X.slice(),se=J(le=>{Y?Y.push(le):j.fire(le)});const oe=()=>{Y?.forEach(le=>j.fire(le)),Y=null},j=new y({onWillAddFirstListener(){se||(se=J(le=>j.fire(le)))},onDidAddFirstListener(){Y&&(H?setTimeout(oe):oe())},onDidRemoveLastListener(){se&&se.dispose(),se=null}});return j.event}b.buffer=e;class P{constructor(H){this.event=H,this.disposables=new i.DisposableStore}map(H){return new P(F(this.event,H,this.disposables))}forEach(H){return new P(O(this.event,H,this.disposables))}filter(H){return new P(q(this.event,H,this.disposables))}reduce(H,X){return new P(G(this.event,H,X,this.disposables))}latch(){return new P(fe(this.event,void 0,this.disposables))}debounce(H,X=100,Y=!1,se=!1,oe){return new P(re(this.event,H,X,Y,se,oe,this.disposables))}on(H,X,Y){return this.event(H,X,Y)}once(H,X,Y){return N(this.event)(H,X,Y)}dispose(){this.disposables.dispose()}}function k(J){return new P(J)}b.chain=k;function I(J,H,X=Y=>Y){const Y=(...le)=>j.fire(X(...le)),se=()=>J.on(H,Y),oe=()=>J.removeListener(H,Y),j=new y({onWillAddFirstListener:se,onDidRemoveLastListener:oe});return j.event}b.fromNodeEventEmitter=I;function V(J,H,X=Y=>Y){const Y=(...le)=>j.fire(X(...le)),se=()=>J.addEventListener(H,Y),oe=()=>J.removeEventListener(H,Y),j=new y({onWillAddFirstListener:se,onDidRemoveLastListener:oe});return j.event}b.fromDOMEventEmitter=V;function Q(J){return new Promise(H=>N(J)(H))}b.toPromise=Q;function ee(J){const H=new y;return J.then(X=>{H.fire(X)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}b.fromPromise=ee;function ue(J,H){return H(void 0),J(X=>H(X))}b.runAndSubscribe=ue;function he(J,H){let X=null;function Y(oe){X?.dispose(),X=new i.DisposableStore,H(oe,X)}Y(void 0);const se=J(oe=>Y(oe));return(0,i.toDisposable)(()=>{se.dispose(),X?.dispose()})}b.runAndSubscribeWithStore=he;class ge{constructor(H,X){this._observable=H,this._counter=0,this._hasChanged=!1;const Y={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};X||w(Y),this.emitter=new y(Y),X&&X.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,X){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function me(J,H){return new ge(J,H).emitter.event}b.fromObservable=me;function ve(J){return H=>{let X=0,Y=!1;const se={beginUpdate(){X++},endUpdate(){X--,X===0&&(J.reportChanges(),Y&&(Y=!1,H()))},handlePossibleChange(){},handleChange(){Y=!0}};return J.addObserver(se),J.reportChanges(),{dispose(){J.removeObserver(se)}}}}b.fromObservableLight=ve})(s||(n.Event=s={}));class _{constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${_._idPool++}`,_.all.add(this)}start(w){this._stopWatch=new f.StopWatch,this.listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=_,_.all=new Set,_._idPool=0;let t=-1;class m{constructor(w,A=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=A,this._warnCountdown=0}dispose(){var w;(w=this._stacks)===null||w===void 0||w.clear()}check(w,A){const N=this.threshold;if(N<=0||A<N)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(w.value)||0;if(this._stacks.set(w.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=N*.5;let O,q=0;for(const[T,W]of this._stacks)(!O||q<W)&&(O=T,q=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${q}):`),console.warn(O)}return()=>{const O=this._stacks.get(w.value)||0;this._stacks.set(w.value,O-1)}}}class h{static create(){var w;return new h((w=new Error().stack)!==null&&w!==void 0?w:"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c{constructor(w){this.value=w}}const L=2,d=(b,w)=>{if(b instanceof c)w(b);else for(let A=0;A<b.length;A++){const N=b[A];N&&w(N)}};class y{constructor(w){var A,N,F,O,q;this._size=0,this._options=w,this._leakageMon=t>0||!((A=this._options)===null||A===void 0)&&A.leakWarningThreshold?new m((F=(N=this._options)===null||N===void 0?void 0:N.leakWarningThreshold)!==null&&F!==void 0?F:t):void 0,this._perfMon=!((O=this._options)===null||O===void 0)&&O._profName?new _(this._options._profName):void 0,this._deliveryQueue=(q=this._options)===null||q===void 0?void 0:q.deliveryQueue}dispose(){var w,A,N,F;if(!this._disposed){if(this._disposed=!0,((w=this._deliveryQueue)===null||w===void 0?void 0:w.current)===this&&this._deliveryQueue.reset(),this._listeners){if(g){const O=this._listeners;queueMicrotask(()=>{d(O,q=>{var T;return(T=q.stack)===null||T===void 0?void 0:T.print()})})}this._listeners=void 0,this._size=0}(N=(A=this._options)===null||A===void 0?void 0:A.onDidRemoveLastListener)===null||N===void 0||N.call(A),(F=this._leakageMon)===null||F===void 0||F.dispose()}}get event(){var w;return(w=this._event)!==null&&w!==void 0||(this._event=(A,N,F)=>{var O,q,T,W,G;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;N&&(A=A.bind(N));const ae=new c(A);let re,ne;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ae.stack=h.create(),re=this._leakageMon.check(ae.stack,this._size+1)),g&&(ae.stack=ne??h.create()),this._listeners?this._listeners instanceof c?((G=this._deliveryQueue)!==null&&G!==void 0||(this._deliveryQueue=new R),this._listeners=[this._listeners,ae]):this._listeners.push(ae):((q=(O=this._options)===null||O===void 0?void 0:O.onWillAddFirstListener)===null||q===void 0||q.call(O,this),this._listeners=ae,(W=(T=this._options)===null||T===void 0?void 0:T.onDidAddFirstListener)===null||W===void 0||W.call(T,this)),this._size++;const fe=(0,i.toDisposable)(()=>{re?.(),this._removeListener(ae)});return F instanceof i.DisposableStore?F.add(fe):Array.isArray(F)&&F.push(fe),fe}),this._event}_removeListener(w){var A,N,F,O;if((N=(A=this._options)===null||A===void 0?void 0:A.onWillRemoveListener)===null||N===void 0||N.call(A,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(O=(F=this._options)===null||F===void 0?void 0:F.onDidRemoveLastListener)===null||O===void 0||O.call(F,this),this._size=0;return}const q=this._listeners,T=q.indexOf(w);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,q[T]=void 0;const W=this._deliveryQueue.current===this;if(this._size*L<=q.length){let G=0;for(let ae=0;ae<q.length;ae++)q[ae]?q[G++]=q[ae]:W&&(this._deliveryQueue.end--,G<this._deliveryQueue.i&&this._deliveryQueue.i--);q.length=G}}_deliver(w,A){var N;if(!w)return;const F=((N=this._options)===null||N===void 0?void 0:N.onListenerError)||E.onUnexpectedError;if(!F){w.value(A);return}try{w.value(A)}catch(O){F(O)}}_deliverQueue(w){const A=w.current._listeners;for(;w.i<w.end;)this._deliver(A[w.i++],w.value);w.reset()}fire(w){var A,N,F,O;if(!((A=this._deliveryQueue)===null||A===void 0)&&A.current&&(this._deliverQueue(this._deliveryQueue),(N=this._perfMon)===null||N===void 0||N.stop()),(F=this._perfMon)===null||F===void 0||F.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,w);else{const q=this._deliveryQueue;q.enqueue(this,w,this._listeners.length),this._deliverQueue(q)}(O=this._perfMon)===null||O===void 0||O.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const C=()=>new R;n.createEventDeliveryQueue=C;class R{constructor(){this.i=-1,this.end=0}enqueue(w,A,N){this.i=0,this.end=N,this.current=w,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends y{constructor(w){super(w),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=w?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._size&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}n.PauseableEmitter=S;class p extends S{constructor(w){var A;super(w),this._delay=(A=w.delay)!==null&&A!==void 0?A:100}fire(w){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(w)}}n.DebounceEmitter=p;class r extends y{constructor(w){super(w),this._queuedEvents=[],this._mergeFn=w?.merge}fire(w){this.hasListeners()&&(this._queuedEvents.push(w),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(A=>super.fire(A)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const A={event:w,listener:null};this.events.push(A),this.hasListeners&&this.hook(A);const N=()=>{this.hasListeners&&this.unhook(A);const F=this.events.indexOf(A);this.events.splice(F,1)};return(0,i.toDisposable)((0,M.once)(N))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(A=>this.emitter.fire(A))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=l;class o{constructor(){this.buffers=[]}wrapEvent(w){return(A,N,F)=>w(O=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>A.call(N,O)):A.call(N,O)},void 0,F)}bufferEvents(w){const A=[];this.buffers.push(A);const N=w();return this.buffers.pop(),A.forEach(F=>F()),N}}n.EventBufferer=o;class v{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=v}),K(te[33],ie([0,1,7]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(g,a){const s=setTimeout(g.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(g){function a(s){return s===g.None||s===g.Cancelled||s instanceof u?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}g.isCancellationToken=a,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(n.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class f{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){var s;a&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=f}),K(te[5],ie([0,1,27,32]),function(U,n,E,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function u(D){return!D||typeof D!="string"?!0:D.trim().length===0}n.isFalsyOrWhitespace=u;const f=/{(\d+)}/g;function g(D,...x){return x.length===0?D:D.replace(f,function(B,z){const Z=parseInt(z,10);return isNaN(Z)||Z<0||Z>=x.length?B:x[Z]})}n.format=g;function a(D){return D.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}n.escape=a;function s(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function _(D,x=" "){const B=t(D,x);return m(B,x)}n.trim=_;function t(D,x){if(!D||!x)return D;const B=x.length;if(B===0||D.length===0)return D;let z=0;for(;D.indexOf(x,z)===z;)z=z+B;return D.substring(z)}n.ltrim=t;function m(D,x){if(!D||!x)return D;const B=x.length,z=D.length;if(B===0||z===0)return D;let Z=z,ce=-1;for(;ce=D.lastIndexOf(x,Z-1),!(ce===-1||ce+B!==Z);){if(ce===0)return"";Z=ce}return D.substring(0,Z)}n.rtrim=m;function h(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function c(D){return D.replace(/\*/g,"")}n.stripWildcards=c;function L(D,x,B={}){if(!D)throw new Error("Cannot create regex from empty string");x||(D=s(D)),B.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let z="";return B.global&&(z+="g"),B.matchCase||(z+="i"),B.multiline&&(z+="m"),B.unicode&&(z+="u"),new RegExp(D,z)}n.createRegExp=L;function d(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}n.regExpLeadsToEndlessLoop=d;function y(D){return D.split(/\r\n|\r|\n/)}n.splitLines=y;function C(D){for(let x=0,B=D.length;x<B;x++){const z=D.charCodeAt(x);if(z!==32&&z!==9)return x}return-1}n.firstNonWhitespaceIndex=C;function R(D,x=0,B=D.length){for(let z=x;z<B;z++){const Z=D.charCodeAt(z);if(Z!==32&&Z!==9)return D.substring(x,z)}return D.substring(x,B)}n.getLeadingWhitespace=R;function S(D,x=D.length-1){for(let B=x;B>=0;B--){const z=D.charCodeAt(B);if(z!==32&&z!==9)return B}return-1}n.lastNonWhitespaceIndex=S;function p(D,x){return D<x?-1:D>x?1:0}n.compare=p;function r(D,x,B=0,z=D.length,Z=0,ce=x.length){for(;B<z&&Z<ce;B++,Z++){const we=D.charCodeAt(B),be=x.charCodeAt(Z);if(we<be)return-1;if(we>be)return 1}const de=z-B,Se=ce-Z;return de<Se?-1:de>Se?1:0}n.compareSubstring=r;function l(D,x){return o(D,x,0,D.length,0,x.length)}n.compareIgnoreCase=l;function o(D,x,B=0,z=D.length,Z=0,ce=x.length){for(;B<z&&Z<ce;B++,Z++){let we=D.charCodeAt(B),be=x.charCodeAt(Z);if(we===be)continue;if(we>=128||be>=128)return r(D.toLowerCase(),x.toLowerCase(),B,z,Z,ce);b(we)&&(we-=32),b(be)&&(be-=32);const Le=we-be;if(Le!==0)return Le}const de=z-B,Se=ce-Z;return de<Se?-1:de>Se?1:0}n.compareSubstringIgnoreCase=o;function v(D){return D>=48&&D<=57}n.isAsciiDigit=v;function b(D){return D>=97&&D<=122}n.isLowerAsciiLetter=b;function w(D){return D>=65&&D<=90}n.isUpperAsciiLetter=w;function A(D,x){return D.length===x.length&&o(D,x)===0}n.equalsIgnoreCase=A;function N(D,x){const B=x.length;return x.length>D.length?!1:o(D,x,0,B)===0}n.startsWithIgnoreCase=N;function F(D,x){const B=Math.min(D.length,x.length);let z;for(z=0;z<B;z++)if(D.charCodeAt(z)!==x.charCodeAt(z))return z;return B}n.commonPrefixLength=F;function O(D,x){const B=Math.min(D.length,x.length);let z;const Z=D.length-1,ce=x.length-1;for(z=0;z<B;z++)if(D.charCodeAt(Z-z)!==x.charCodeAt(ce-z))return z;return B}n.commonSuffixLength=O;function q(D){return 55296<=D&&D<=56319}n.isHighSurrogate=q;function T(D){return 56320<=D&&D<=57343}n.isLowSurrogate=T;function W(D,x){return(D-55296<<10)+(x-56320)+65536}n.computeCodePoint=W;function G(D,x,B){const z=D.charCodeAt(B);if(q(z)&&B+1<x){const Z=D.charCodeAt(B+1);if(T(Z))return W(z,Z)}return z}n.getNextCodePoint=G;function ae(D,x){const B=D.charCodeAt(x-1);if(T(B)&&x>1){const z=D.charCodeAt(x-2);if(q(z))return W(z,B)}return B}class re{get offset(){return this._offset}constructor(x,B=0){this._str=x,this._len=x.length,this._offset=B}setOffset(x){this._offset=x}prevCodePoint(){const x=ae(this._str,this._offset);return this._offset-=x>=65536?2:1,x}nextCodePoint(){const x=G(this._str,this._len,this._offset);return this._offset+=x>=65536?2:1,x}eol(){return this._offset>=this._len}}n.CodePointIterator=re;class ne{get offset(){return this._iterator.offset}constructor(x,B=0){this._iterator=new re(x,B)}nextGraphemeLength(){const x=H.getInstance(),B=this._iterator,z=B.offset;let Z=x.getGraphemeBreakType(B.nextCodePoint());for(;!B.eol();){const ce=B.offset,de=x.getGraphemeBreakType(B.nextCodePoint());if(J(Z,de)){B.setOffset(ce);break}Z=de}return B.offset-z}prevGraphemeLength(){const x=H.getInstance(),B=this._iterator,z=B.offset;let Z=x.getGraphemeBreakType(B.prevCodePoint());for(;B.offset>0;){const ce=B.offset,de=x.getGraphemeBreakType(B.prevCodePoint());if(J(de,Z)){B.setOffset(ce);break}Z=de}return z-B.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=ne;function fe(D,x){return new ne(D,x).nextGraphemeLength()}n.nextCharLength=fe;function $(D,x){return new ne(D,x).prevGraphemeLength()}n.prevCharLength=$;function e(D,x){x>0&&T(D.charCodeAt(x))&&x--;const B=x+fe(D,x);return[B-$(D,B),B]}n.getCharContainingOffset=e;let P;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function I(D){return P||(P=k()),P.test(D)}n.containsRTL=I;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(D){return V.test(D)}n.isBasicASCII=Q,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(D){return n.UNUSUAL_LINE_TERMINATORS.test(D)}n.containsUnusualLineTerminators=ee;function ue(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}n.isFullWidthCharacter=ue;function he(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}n.isEmojiImprecise=he,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ge;function me(D,x=!1){return D?(x&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}n.containsUppercaseCharacter=me;function ve(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}n.singleLetterHash=ve;function J(D,x){return D===0?x!==5&&x!==7:D===2&&x===3?!1:D===4||D===2||D===3||x===4||x===2||x===3?!0:!(D===8&&(x===8||x===9||x===11||x===12)||(D===11||D===9)&&(x===9||x===10)||(D===12||D===10)&&x===10||x===5||x===13||x===7||D===1||D===13&&x===14||D===6&&x===6)}class H{static getInstance(){return H._INSTANCE||(H._INSTANCE=new H),H._INSTANCE}constructor(){this._data=X()}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const B=this._data,z=B.length/3;let Z=1;for(;Z<=z;)if(x<B[3*Z])Z=2*Z;else if(x>B[3*Z+1])Z=2*Z+1;else return B[3*Z+2];return 0}}H._INSTANCE=null;function X(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Y(D,x){if(D===0)return 0;const B=se(D,x);if(B!==void 0)return B;const z=new re(x,D);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=Y;function se(D,x){const B=new re(x,D);let z=B.prevCodePoint();for(;oe(z)||z===65039||z===8419;){if(B.offset===0)return;z=B.prevCodePoint()}if(!he(z))return;let Z=B.offset;return Z>0&&B.prevCodePoint()===8205&&(Z=B.offset),Z}function oe(D){return 127995<=D&&D<=127999}n.noBreakWhitespace="\xA0";class j{static getInstance(x){return i.cache.get(Array.from(x))}static getLocales(){return i._locales.value}constructor(x){this.confusableDictionary=x}isAmbiguous(x){return this.confusableDictionary.has(x)}getPrimaryConfusable(x){return this.confusableDictionary.get(x)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=j,i=j,j.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),j.cache=new E.LRUCachedFunction(D=>{function x(be){const Le=new Map;for(let Ce=0;Ce<be.length;Ce+=2)Le.set(be[Ce],be[Ce+1]);return Le}function B(be,Le){const Ce=new Map(be);for(const[ye,Re]of Le)Ce.set(ye,Re);return Ce}function z(be,Le){if(!be)return Le;const Ce=new Map;for(const[ye,Re]of be)Le.has(ye)&&Ce.set(ye,Re);return Ce}const Z=i.ambiguousCharacterData.value;let ce=D.filter(be=>!be.startsWith("_")&&be in Z);ce.length===0&&(ce=["_default"]);let de;for(const be of ce){const Le=x(Z[be]);de=z(de,Le)}const Se=x(Z._common),we=B(Se,de);return new i(we)}),j._locales=new M.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(D=>!D.startsWith("_")));class le{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(le.getRawData())),this._data}static isInvisibleCharacter(x){return le.getData().has(x)}static get codePoints(){return le.getData()}}n.InvisibleCharacters=le,le._data=void 0}),K(te[34],ie([0,1,5]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(L){return i(L,0)}n.hash=M;function i(L,d){switch(typeof L){case"object":return L===null?u(349,d):Array.isArray(L)?a(L,d):s(L,d);case"string":return g(L,d);case"boolean":return f(L,d);case"number":return u(L,d);case"undefined":return u(937,d);default:return u(617,d)}}n.doHash=i;function u(L,d){return(d<<5)-d+L|0}n.numberHash=u;function f(L,d){return u(L?433:863,d)}function g(L,d){d=u(149417,d);for(let y=0,C=L.length;y<C;y++)d=u(L.charCodeAt(y),d);return d}n.stringHash=g;function a(L,d){return d=u(104579,d),L.reduce((y,C)=>i(C,y),d)}function s(L,d){return d=u(181387,d),Object.keys(L).sort().reduce((y,C)=>(y=g(C,y),i(L[C],y)),d)}function _(L,d,y=32){const C=y-d,R=~((1<<C)-1);return(L<<d|(R&L)>>>C)>>>0}function t(L,d=0,y=L.byteLength,C=0){for(let R=0;R<y;R++)L[d+R]=C}function m(L,d,y="0"){for(;L.length<d;)L=y+L;return L}function h(L,d=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(y=>y.toString(16).padStart(2,"0")).join(""):m((L>>>0).toString(16),d/4)}n.toHexString=h;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const y=d.length;if(y===0)return;const C=this._buff;let R=this._buffLen,S=this._leftoverHighSurrogate,p,r;for(S!==0?(p=S,r=-1,S=0):(p=d.charCodeAt(0),r=0);;){let l=p;if(E.isHighSurrogate(p))if(r+1<y){const o=d.charCodeAt(r+1);E.isLowSurrogate(o)?(r++,l=E.computeCodePoint(p,o)):l=65533}else{S=p;break}else E.isLowSurrogate(p)&&(l=65533);if(R=this._push(C,R,l),r++,r<y)p=d.charCodeAt(r);else break}this._buffLen=R,this._leftoverHighSurrogate=S}_push(d,y,C){return C<128?d[y++]=C:C<2048?(d[y++]=192|(C&1984)>>>6,d[y++]=128|(C&63)>>>0):C<65536?(d[y++]=224|(C&61440)>>>12,d[y++]=128|(C&4032)>>>6,d[y++]=128|(C&63)>>>0):(d[y++]=240|(C&1835008)>>>18,d[y++]=128|(C&258048)>>>12,d[y++]=128|(C&4032)>>>6,d[y++]=128|(C&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,t(this._buff,this._buffLen),this._buffLen>56&&(this._step(),t(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=c._bigBlock32,y=this._buffDV;for(let b=0;b<64;b+=4)d.setUint32(b,y.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)d.setUint32(b,_(d.getUint32(b-12,!1)^d.getUint32(b-32,!1)^d.getUint32(b-56,!1)^d.getUint32(b-64,!1),1),!1);let C=this._h0,R=this._h1,S=this._h2,p=this._h3,r=this._h4,l,o,v;for(let b=0;b<80;b++)b<20?(l=R&S|~R&p,o=1518500249):b<40?(l=R^S^p,o=1859775393):b<60?(l=R&S|R&p|S&p,o=2400959708):(l=R^S^p,o=3395469782),v=_(C,5)+l+r+o+d.getUint32(b*4,!1)&4294967295,r=p,p=S,S=_(R,30),R=C,C=v;this._h0=this._h0+C&4294967295,this._h1=this._h1+R&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+p&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=c,c._bigBlock32=new DataView(new ArrayBuffer(320))}),K(te[21],ie([0,1,30,34]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(t){this.source=t}getElements(){const t=this.source,m=new Int32Array(t.length);for(let h=0,c=t.length;h<c;h++)m[h]=t.charCodeAt(h);return m}}n.StringDiffSequence=i;function u(_,t,m){return new s(new i(_),new i(t)).ComputeDiff(m).changes}n.stringDiff=u;class f{static Assert(t,m){if(!t)throw new Error(m)}}class g{static Copy(t,m,h,c,L){for(let d=0;d<L;d++)h[c+d]=t[m+d]}static Copy2(t,m,h,c,L){for(let d=0;d<L;d++)h[c+d]=t[m+d]}}class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(t,m){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(t,m){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(t,m,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=t,this._modifiedSequence=m;const[c,L,d]=s._getElements(t),[y,C,R]=s._getElements(m);this._hasStrings=d&&R,this._originalStringElements=c,this._originalElementsOrHash=L,this._modifiedStringElements=y,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(t){return t.length>0&&typeof t[0]=="string"}static _getElements(t){const m=t.getElements();if(s._isStringArray(m)){const h=new Int32Array(m.length);for(let c=0,L=m.length;c<L;c++)h[c]=(0,M.stringHash)(m[c],0);return[m,h,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(t,m){return this._originalElementsOrHash[t]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[t]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(t,m){if(!this.ElementsAreEqual(t,m))return!1;const h=s._getStrictElement(this._originalSequence,t),c=s._getStrictElement(this._modifiedSequence,m);return h===c}static _getStrictElement(t,m){return typeof t.getStrictElement=="function"?t.getStrictElement(m):null}OriginalElementsAreEqual(t,m){return this._originalElementsOrHash[t]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[t]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(t,m){return this._modifiedElementsOrHash[t]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[t]===this._modifiedStringElements[m]:!0}ComputeDiff(t){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,t)}_ComputeDiff(t,m,h,c,L){const d=[!1];let y=this.ComputeDiffRecursive(t,m,h,c,d);return L&&(y=this.PrettifyChanges(y)),{quitEarly:d[0],changes:y}}ComputeDiffRecursive(t,m,h,c,L){for(L[0]=!1;t<=m&&h<=c&&this.ElementsAreEqual(t,h);)t++,h++;for(;m>=t&&c>=h&&this.ElementsAreEqual(m,c);)m--,c--;if(t>m||h>c){let p;return h<=c?(f.Assert(t===m+1,"originalStart should only be one more than originalEnd"),p=[new E.DiffChange(t,0,h,c-h+1)]):t<=m?(f.Assert(h===c+1,"modifiedStart should only be one more than modifiedEnd"),p=[new E.DiffChange(t,m-t+1,h,0)]):(f.Assert(t===m+1,"originalStart should only be one more than originalEnd"),f.Assert(h===c+1,"modifiedStart should only be one more than modifiedEnd"),p=[]),p}const d=[0],y=[0],C=this.ComputeRecursionPoint(t,m,h,c,d,y,L),R=d[0],S=y[0];if(C!==null)return C;if(!L[0]){const p=this.ComputeDiffRecursive(t,R,h,S,L);let r=[];return L[0]?r=[new E.DiffChange(R+1,m-(R+1)+1,S+1,c-(S+1)+1)]:r=this.ComputeDiffRecursive(R+1,m,S+1,c,L),this.ConcatenateChanges(p,r)}return[new E.DiffChange(t,m-t+1,h,c-h+1)]}WALKTRACE(t,m,h,c,L,d,y,C,R,S,p,r,l,o,v,b,w,A){let N=null,F=null,O=new a,q=m,T=h,W=l[0]-b[0]-c,G=-1073741824,ae=this.m_forwardHistory.length-1;do{const re=W+t;re===q||re<T&&R[re-1]<R[re+1]?(p=R[re+1],o=p-W-c,p<G&&O.MarkNextChange(),G=p,O.AddModifiedElement(p+1,o),W=re+1-t):(p=R[re-1]+1,o=p-W-c,p<G&&O.MarkNextChange(),G=p-1,O.AddOriginalElement(p,o+1),W=re-1-t),ae>=0&&(R=this.m_forwardHistory[ae],t=R[0],q=1,T=R.length-1)}while(--ae>=-1);if(N=O.getReverseChanges(),A[0]){let re=l[0]+1,ne=b[0]+1;if(N!==null&&N.length>0){const fe=N[N.length-1];re=Math.max(re,fe.getOriginalEnd()),ne=Math.max(ne,fe.getModifiedEnd())}F=[new E.DiffChange(re,r-re+1,ne,v-ne+1)]}else{O=new a,q=d,T=y,W=l[0]-b[0]-C,G=1073741824,ae=w?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const re=W+L;re===q||re<T&&S[re-1]>=S[re+1]?(p=S[re+1]-1,o=p-W-C,p>G&&O.MarkNextChange(),G=p+1,O.AddOriginalElement(p+1,o+1),W=re+1-L):(p=S[re-1],o=p-W-C,p>G&&O.MarkNextChange(),G=p,O.AddModifiedElement(p+1,o+1),W=re-1-L),ae>=0&&(S=this.m_reverseHistory[ae],L=S[0],q=1,T=S.length-1)}while(--ae>=-1);F=O.getChanges()}return this.ConcatenateChanges(N,F)}ComputeRecursionPoint(t,m,h,c,L,d,y){let C=0,R=0,S=0,p=0,r=0,l=0;t--,h--,L[0]=0,d[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const o=m-t+(c-h),v=o+1,b=new Int32Array(v),w=new Int32Array(v),A=c-h,N=m-t,F=t-h,O=m-c,T=(N-A)%2===0;b[A]=t,w[N]=m,y[0]=!1;for(let W=1;W<=o/2+1;W++){let G=0,ae=0;S=this.ClipDiagonalBound(A-W,W,A,v),p=this.ClipDiagonalBound(A+W,W,A,v);for(let ne=S;ne<=p;ne+=2){ne===S||ne<p&&b[ne-1]<b[ne+1]?C=b[ne+1]:C=b[ne-1]+1,R=C-(ne-A)-F;const fe=C;for(;C<m&&R<c&&this.ElementsAreEqual(C+1,R+1);)C++,R++;if(b[ne]=C,C+R>G+ae&&(G=C,ae=R),!T&&Math.abs(ne-N)<=W-1&&C>=w[ne])return L[0]=C,d[0]=R,fe<=w[ne]&&1447>0&&W<=1447+1?this.WALKTRACE(A,S,p,F,N,r,l,O,b,w,C,m,L,R,c,d,T,y):null}const re=(G-t+(ae-h)-W)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(G,re))return y[0]=!0,L[0]=G,d[0]=ae,re>0&&1447>0&&W<=1447+1?this.WALKTRACE(A,S,p,F,N,r,l,O,b,w,C,m,L,R,c,d,T,y):(t++,h++,[new E.DiffChange(t,m-t+1,h,c-h+1)]);r=this.ClipDiagonalBound(N-W,W,N,v),l=this.ClipDiagonalBound(N+W,W,N,v);for(let ne=r;ne<=l;ne+=2){ne===r||ne<l&&w[ne-1]>=w[ne+1]?C=w[ne+1]-1:C=w[ne-1],R=C-(ne-N)-O;const fe=C;for(;C>t&&R>h&&this.ElementsAreEqual(C,R);)C--,R--;if(w[ne]=C,T&&Math.abs(ne-A)<=W&&C<=b[ne])return L[0]=C,d[0]=R,fe>=b[ne]&&1447>0&&W<=1447+1?this.WALKTRACE(A,S,p,F,N,r,l,O,b,w,C,m,L,R,c,d,T,y):null}if(W<=1447){let ne=new Int32Array(p-S+2);ne[0]=A-S+1,g.Copy2(b,S,ne,1,p-S+1),this.m_forwardHistory.push(ne),ne=new Int32Array(l-r+2),ne[0]=N-r+1,g.Copy2(w,r,ne,1,l-r+1),this.m_reverseHistory.push(ne)}}return this.WALKTRACE(A,S,p,F,N,r,l,O,b,w,C,m,L,R,c,d,T,y)}PrettifyChanges(t){for(let m=0;m<t.length;m++){const h=t[m],c=m<t.length-1?t[m+1].originalStart:this._originalElementsOrHash.length,L=m<t.length-1?t[m+1].modifiedStart:this._modifiedElementsOrHash.length,d=h.originalLength>0,y=h.modifiedLength>0;for(;h.originalStart+h.originalLength<c&&h.modifiedStart+h.modifiedLength<L&&(!d||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!y||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const R=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!R)break;h.originalStart++,h.modifiedStart++}const C=[null];if(m<t.length-1&&this.ChangesOverlap(t[m],t[m+1],C)){t[m]=C[0],t.splice(m+1,1),m--;continue}}for(let m=t.length-1;m>=0;m--){const h=t[m];let c=0,L=0;if(m>0){const p=t[m-1];c=p.originalStart+p.originalLength,L=p.modifiedStart+p.modifiedLength}const d=h.originalLength>0,y=h.modifiedLength>0;let C=0,R=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let p=1;;p++){const r=h.originalStart-p,l=h.modifiedStart-p;if(r<c||l<L||d&&!this.OriginalElementsAreEqual(r,r+h.originalLength)||y&&!this.ModifiedElementsAreEqual(l,l+h.modifiedLength))break;const v=(r===c&&l===L?5:0)+this._boundaryScore(r,h.originalLength,l,h.modifiedLength);v>R&&(R=v,C=p)}h.originalStart-=C,h.modifiedStart-=C;const S=[null];if(m>0&&this.ChangesOverlap(t[m-1],t[m],S)){t[m-1]=S[0],t.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,h=t.length;m<h;m++){const c=t[m-1],L=t[m],d=L.originalStart-c.originalStart-c.originalLength,y=c.originalStart,C=L.originalStart+L.originalLength,R=C-y,S=c.modifiedStart,p=L.modifiedStart+L.modifiedLength,r=p-S;if(d<5&&R<20&&r<20){const l=this._findBetterContiguousSequence(y,R,S,r,d);if(l){const[o,v]=l;(o!==c.originalStart+c.originalLength||v!==c.modifiedStart+c.modifiedLength)&&(c.originalLength=o-c.originalStart,c.modifiedLength=v-c.modifiedStart,L.originalStart=o+d,L.modifiedStart=v+d,L.originalLength=C-L.originalStart,L.modifiedLength=p-L.modifiedStart)}}}return t}_findBetterContiguousSequence(t,m,h,c,L){if(m<L||c<L)return null;const d=t+m-L+1,y=h+c-L+1;let C=0,R=0,S=0;for(let p=t;p<d;p++)for(let r=h;r<y;r++){const l=this._contiguousSequenceScore(p,r,L);l>0&&l>C&&(C=l,R=p,S=r)}return C>0?[R,S]:null}_contiguousSequenceScore(t,m,h){let c=0;for(let L=0;L<h;L++){if(!this.ElementsAreEqual(t+L,m+L))return 0;c+=this._originalStringElements[t+L].length}return c}_OriginalIsBoundary(t){return t<=0||t>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[t])}_OriginalRegionIsBoundary(t,m){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(m>0){const h=t+m;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(t){return t<=0||t>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[t])}_ModifiedRegionIsBoundary(t,m){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(m>0){const h=t+m;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(t,m,h,c){const L=this._OriginalRegionIsBoundary(t,m)?1:0,d=this._ModifiedRegionIsBoundary(h,c)?1:0;return L+d}ConcatenateChanges(t,m){const h=[];if(t.length===0||m.length===0)return m.length>0?m:t;if(this.ChangesOverlap(t[t.length-1],m[0],h)){const c=new Array(t.length+m.length-1);return g.Copy(t,0,c,0,t.length-1),c[t.length-1]=h[0],g.Copy(m,1,c,t.length,m.length-1),c}else{const c=new Array(t.length+m.length);return g.Copy(t,0,c,0,t.length),g.Copy(m,0,c,t.length,m.length),c}}ChangesOverlap(t,m,h){if(f.Assert(t.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),f.Assert(t.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=m.originalStart||t.modifiedStart+t.modifiedLength>=m.modifiedStart){const c=t.originalStart;let L=t.originalLength;const d=t.modifiedStart;let y=t.modifiedLength;return t.originalStart+t.originalLength>=m.originalStart&&(L=m.originalStart+m.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=m.modifiedStart&&(y=m.modifiedStart+m.modifiedLength-t.modifiedStart),h[0]=new E.DiffChange(c,L,d,y),!0}else return h[0]=null,!1}ClipDiagonalBound(t,m,h,c){if(t>=0&&t<c)return t;const L=h,d=c-h-1,y=m%2===0;if(t<0){const C=L%2===0;return y===C?0:1}else{const C=d%2===0;return y===C?c-1:c-2}}}n.LcsDiff=s}),K(te[22],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(d){return typeof d=="string"}n.isString=E;function M(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}n.isObject=M;function i(d){const y=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof y}n.isTypedArray=i;function u(d){return typeof d=="number"&&!isNaN(d)}n.isNumber=u;function f(d){return!!d&&typeof d[Symbol.iterator]=="function"}n.isIterable=f;function g(d){return d===!0||d===!1}n.isBoolean=g;function a(d){return typeof d>"u"}n.isUndefined=a;function s(d){return!_(d)}n.isDefined=s;function _(d){return a(d)||d===null}n.isUndefinedOrNull=_;function t(d,y){if(!d)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}n.assertType=t;function m(d){if(_(d))throw new Error("Assertion Failed: argument is undefined or null");return d}n.assertIsDefined=m;function h(d){return typeof d=="function"}n.isFunction=h;function c(d,y){const C=Math.min(d.length,y.length);for(let R=0;R<C;R++)L(d[R],y[R])}n.validateConstraints=c;function L(d,y){if(E(y)){if(typeof d!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(h(y)){try{if(d instanceof y)return}catch{}if(!_(d)&&d.constructor===y||y.length===1&&y.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=L}),K(te[35],ie([0,1,22]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(f,g){if((0,E.isString)(g)){const a=M[g];if(a===void 0)throw new Error(`${f} references an unknown codicon: ${g}`);g=a}return M[f]=g,{id:f}}function u(){return M}n.getCodiconFontCharacters=u,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),K(te[11],ie([0,1,22]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const c=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([L,d])=>{c[L]=d&&typeof d=="object"?M(d):d}),c}n.deepClone=M;function i(h){if(!h||typeof h!="object")return h;const c=[h];for(;c.length>0;){const L=c.shift();Object.freeze(L);for(const d in L)if(u.call(L,d)){const y=L[d];typeof y=="object"&&!Object.isFrozen(y)&&!(0,E.isTypedArray)(y)&&c.push(y)}}return h}n.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function f(h,c){return g(h,c,new Set)}n.cloneAndChange=f;function g(h,c,L){if((0,E.isUndefinedOrNull)(h))return h;const d=c(h);if(typeof d<"u")return d;if(Array.isArray(h)){const y=[];for(const C of h)y.push(g(C,c,L));return y}if((0,E.isObject)(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const y={};for(const C in h)u.call(h,C)&&(y[C]=g(h[C],c,L));return L.delete(h),y}return h}function a(h,c,L=!0){return(0,E.isObject)(h)?((0,E.isObject)(c)&&Object.keys(c).forEach(d=>{d in h?L&&((0,E.isObject)(h[d])&&(0,E.isObject)(c[d])?a(h[d],c[d],L):h[d]=c[d]):h[d]=c[d]}),h):c}n.mixin=a;function s(h,c){if(h===c)return!0;if(h==null||c===null||c===void 0||typeof h!=typeof c||typeof h!="object"||Array.isArray(h)!==Array.isArray(c))return!1;let L,d;if(Array.isArray(h)){if(h.length!==c.length)return!1;for(L=0;L<h.length;L++)if(!s(h[L],c[L]))return!1}else{const y=[];for(d in h)y.push(d);y.sort();const C=[];for(d in c)C.push(d);if(C.sort(),!s(y,C))return!1;for(L=0;L<y.length;L++)if(!s(h[y[L]],c[y[L]]))return!1}return!0}n.equals=s;function _(h){let c=[];for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}n.getAllPropertyNames=_;function t(h){const c=[];for(const L of _(h))typeof h[L]=="function"&&c.push(L);return c}n.getAllMethodNames=t;function m(h,c){const L=y=>function(){const C=Array.prototype.slice.call(arguments,0);return c(y,C)},d={};for(const y of h)d[y]=L(y);return d}n.createProxyObject=m}),K(te[23],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),K(te[24],ie([0,1,23]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(f){const g=(0,E.toUint8)(f);this._defaultValue=g,this._asciiMap=M._createAsciiMap(g),this._map=new Map}static _createAsciiMap(f){const g=new Uint8Array(256);return g.fill(f),g}set(f,g){const a=(0,E.toUint8)(g);f>=0&&f<256?this._asciiMap[f]=a:this._map.set(f,a)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),K(te[6],ie([0,1,3]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class M{static addRange(f,g){let a=0;for(;a<g.length&&g[a].endExclusive<f.start;)a++;let s=a;for(;s<g.length&&g[s].start<=f.endExclusive;)s++;if(a===s)g.splice(a,0,f);else{const _=Math.min(f.start,g[a].start),t=Math.max(f.endExclusive,g[s-1].endExclusive);g.splice(a,s-a,new M(_,t))}}static tryCreate(f,g){if(!(f>g))return new M(f,g)}static ofLength(f){return new M(0,f)}constructor(f,g){if(this.start=f,this.endExclusive=g,f>g)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(f){return new M(this.start+f,this.endExclusive+f)}deltaStart(f){return new M(this.start+f,this.endExclusive)}deltaEnd(f){return new M(this.start,this.endExclusive+f)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(f){return this.start===f.start&&this.endExclusive===f.endExclusive}containsRange(f){return this.start<=f.start&&f.endExclusive<=this.endExclusive}contains(f){return this.start<=f&&f<this.endExclusive}join(f){return new M(Math.min(this.start,f.start),Math.max(this.endExclusive,f.endExclusive))}intersect(f){const g=Math.max(this.start,f.start),a=Math.min(this.endExclusive,f.endExclusive);if(g<=a)return new M(g,a)}slice(f){return f.slice(this.start,this.endExclusive)}clip(f){if(this.isEmpty)throw new E.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,f))}clipCyclic(f){if(this.isEmpty)throw new E.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return f<this.start?this.endExclusive-(this.start-f)%this.length:f>=this.endExclusive?this.start+(f-this.start)%this.length:f}}n.OffsetRange=M;class i{constructor(){this._sortedRanges=[]}addRange(f){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<f.start;)g++;let a=g;for(;a<this._sortedRanges.length&&this._sortedRanges[a].start<=f.endExclusive;)a++;if(g===a)this._sortedRanges.splice(g,0,f);else{const s=Math.min(f.start,this._sortedRanges[g].start),_=Math.max(f.endExclusive,this._sortedRanges[a-1].endExclusive);this._sortedRanges.splice(g,a-g,new M(s,_))}}toString(){return this._sortedRanges.map(f=>f.toString()).join(", ")}intersectsStrict(f){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<=f.start;)g++;return g<this._sortedRanges.length&&this._sortedRanges[g].start<f.endExclusive}intersectWithRange(f){const g=new i;for(const a of this._sortedRanges){const s=a.intersect(f);s&&g.addRange(s)}return g}intersectWithRangeLength(f){return this.intersectWithRange(f).length}get length(){return this._sortedRanges.reduce((f,g)=>f+g.length,0)}}n.OffsetRangeSet=i}),K(te[4],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new E(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return E.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const f=i.lineNumber|0,g=u.lineNumber|0;if(f===g){const a=i.column|0,s=u.column|0;return a-s}return f-g}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),K(te[2],ie([0,1,4]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(u,f,g,a){u>g||u===g&&f>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=u,this.endColumn=f):(this.startLineNumber=u,this.startColumn=f,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return M.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return M.containsPosition(this,u)}static containsPosition(u,f){return!(f.lineNumber<u.startLineNumber||f.lineNumber>u.endLineNumber||f.lineNumber===u.startLineNumber&&f.column<u.startColumn||f.lineNumber===u.endLineNumber&&f.column>u.endColumn)}static strictContainsPosition(u,f){return!(f.lineNumber<u.startLineNumber||f.lineNumber>u.endLineNumber||f.lineNumber===u.startLineNumber&&f.column<=u.startColumn||f.lineNumber===u.endLineNumber&&f.column>=u.endColumn)}containsRange(u){return M.containsRange(this,u)}static containsRange(u,f){return!(f.startLineNumber<u.startLineNumber||f.endLineNumber<u.startLineNumber||f.startLineNumber>u.endLineNumber||f.endLineNumber>u.endLineNumber||f.startLineNumber===u.startLineNumber&&f.startColumn<u.startColumn||f.endLineNumber===u.endLineNumber&&f.endColumn>u.endColumn)}strictContainsRange(u){return M.strictContainsRange(this,u)}static strictContainsRange(u,f){return!(f.startLineNumber<u.startLineNumber||f.endLineNumber<u.startLineNumber||f.startLineNumber>u.endLineNumber||f.endLineNumber>u.endLineNumber||f.startLineNumber===u.startLineNumber&&f.startColumn<=u.startColumn||f.endLineNumber===u.endLineNumber&&f.endColumn>=u.endColumn)}plusRange(u){return M.plusRange(this,u)}static plusRange(u,f){let g,a,s,_;return f.startLineNumber<u.startLineNumber?(g=f.startLineNumber,a=f.startColumn):f.startLineNumber===u.startLineNumber?(g=f.startLineNumber,a=Math.min(f.startColumn,u.startColumn)):(g=u.startLineNumber,a=u.startColumn),f.endLineNumber>u.endLineNumber?(s=f.endLineNumber,_=f.endColumn):f.endLineNumber===u.endLineNumber?(s=f.endLineNumber,_=Math.max(f.endColumn,u.endColumn)):(s=u.endLineNumber,_=u.endColumn),new M(g,a,s,_)}intersectRanges(u){return M.intersectRanges(this,u)}static intersectRanges(u,f){let g=u.startLineNumber,a=u.startColumn,s=u.endLineNumber,_=u.endColumn;const t=f.startLineNumber,m=f.startColumn,h=f.endLineNumber,c=f.endColumn;return g<t?(g=t,a=m):g===t&&(a=Math.max(a,m)),s>h?(s=h,_=c):s===h&&(_=Math.min(_,c)),g>s||g===s&&a>_?null:new M(g,a,s,_)}equalsRange(u){return M.equalsRange(this,u)}static equalsRange(u,f){return!u&&!f?!0:!!u&&!!f&&u.startLineNumber===f.startLineNumber&&u.startColumn===f.startColumn&&u.endLineNumber===f.endLineNumber&&u.endColumn===f.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(u){return new E.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(u){return new E.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,f){return new M(this.startLineNumber,this.startColumn,u,f)}setStartPosition(u,f){return new M(u,f,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(u){return new M(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(u){return new M(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new M(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,f=u){return new M(u.lineNumber,u.column,f.lineNumber,f.column)}static lift(u){return u?new M(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,f){return!(u.endLineNumber<f.startLineNumber||u.endLineNumber===f.startLineNumber&&u.endColumn<f.startColumn||f.endLineNumber<u.startLineNumber||f.endLineNumber===u.startLineNumber&&f.endColumn<u.startColumn)}static areIntersecting(u,f){return!(u.endLineNumber<f.startLineNumber||u.endLineNumber===f.startLineNumber&&u.endColumn<=f.startColumn||f.endLineNumber<u.startLineNumber||f.endLineNumber===u.startLineNumber&&f.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,f){if(u&&f){const s=u.startLineNumber|0,_=f.startLineNumber|0;if(s===_){const t=u.startColumn|0,m=f.startColumn|0;if(t===m){const h=u.endLineNumber|0,c=f.endLineNumber|0;if(h===c){const L=u.endColumn|0,d=f.endColumn|0;return L-d}return h-c}return t-m}return s-_}return(u?1:0)-(f?1:0)}static compareRangesUsingEnds(u,f){return u.endLineNumber===f.endLineNumber?u.endColumn===f.endColumn?u.startLineNumber===f.startLineNumber?u.startColumn-f.startColumn:u.startLineNumber-f.startLineNumber:u.endColumn-f.endColumn:u.endLineNumber-f.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}n.Range=M}),K(te[12],ie([0,1,3,6,2]),function(U,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class u{static fromRange(g){return new u(g.startLineNumber,g.endLineNumber)}static subtract(g,a){return a?g.startLineNumber<a.startLineNumber&&a.endLineNumberExclusive<g.endLineNumberExclusive?[new u(g.startLineNumber,a.startLineNumber),new u(a.endLineNumberExclusive,g.endLineNumberExclusive)]:a.startLineNumber<=g.startLineNumber&&g.endLineNumberExclusive<=a.endLineNumberExclusive?[]:a.endLineNumberExclusive<g.endLineNumberExclusive?[new u(Math.max(a.endLineNumberExclusive,g.startLineNumber),g.endLineNumberExclusive)]:[new u(g.startLineNumber,Math.min(a.startLineNumber,g.endLineNumberExclusive))]:[g]}static joinMany(g){if(g.length===0)return[];let a=g[0];for(let s=1;s<g.length;s++)a=this.join(a,g[s]);return a}static join(g,a){if(g.length===0)return a;if(a.length===0)return g;const s=[];let _=0,t=0,m=null;for(;_<g.length||t<a.length;){let h=null;if(_<g.length&&t<a.length){const c=g[_],L=a[t];c.startLineNumber<L.startLineNumber?(h=c,_++):(h=L,t++)}else _<g.length?(h=g[_],_++):(h=a[t],t++);m===null?m=h:m.endLineNumberExclusive>=h.startLineNumber?m=new u(m.startLineNumber,Math.max(m.endLineNumberExclusive,h.endLineNumberExclusive)):(s.push(m),m=h)}return m!==null&&s.push(m),s}static ofLength(g,a){return new u(g,g+a)}static deserialize(g){return new u(g[0],g[1])}constructor(g,a){if(g>a)throw new E.BugIndicatingError(`startLineNumber ${g} cannot be after endLineNumberExclusive ${a}`);this.startLineNumber=g,this.endLineNumberExclusive=a}contains(g){return this.startLineNumber<=g&&g<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(g){return new u(this.startLineNumber+g,this.endLineNumberExclusive+g)}deltaLength(g){return new u(this.startLineNumber,this.endLineNumberExclusive+g)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(g){return new u(Math.min(this.startLineNumber,g.startLineNumber),Math.max(this.endLineNumberExclusive,g.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(g){const a=Math.max(this.startLineNumber,g.startLineNumber),s=Math.min(this.endLineNumberExclusive,g.endLineNumberExclusive);if(a<=s)return new u(a,s)}intersectsStrict(g){return this.startLineNumber<g.endLineNumberExclusive&&g.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(g){return this.startLineNumber<=g.endLineNumberExclusive&&g.startLineNumber<=this.endLineNumberExclusive}equals(g){return this.startLineNumber===g.startLineNumber&&this.endLineNumberExclusive===g.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(g){const a=[];for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)a.push(g(s));return a}forEach(g){for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)g(a)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(g){return this.startLineNumber<=g&&g<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=u}),K(te[36],ie([0,1,4,2]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(f,g,a,s){super(f,g,a,s),this.selectionStartLineNumber=f,this.selectionStartColumn=g,this.positionLineNumber=a,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return i.selectionsEqual(this,f)}static selectionsEqual(f,g){return f.selectionStartLineNumber===g.selectionStartLineNumber&&f.selectionStartColumn===g.selectionStartColumn&&f.positionLineNumber===g.positionLineNumber&&f.positionColumn===g.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,g){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,f,g):new i(f,g,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,g){return this.getDirection()===0?new i(f,g,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,f,g)}static fromPositions(f,g=f){return new i(f.lineNumber,f.column,g.lineNumber,g.column)}static fromRange(f,g){return g===0?new i(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new i(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new i(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,g){if(f&&!g||!f&&g)return!1;if(!f&&!g)return!0;if(f.length!==g.length)return!1;for(let a=0,s=f.length;a<s;a++)if(!this.selectionsEqual(f[a],g[a]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,g,a,s,_){return _===0?new i(f,g,a,s):new i(a,s,f,g)}}n.Selection=i}),K(te[37],ie([0,1,24]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends E.CharacterClassifier{constructor(f){super(0);for(let g=0,a=f.length;g<a;g++)this.set(f.charCodeAt(g),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(u){const f={};return g=>(f.hasOwnProperty(g)||(f[g]=u(g)),f[g])}n.getMapForWordSeparators=i(u=>new M(u))}),K(te[25],ie([0,1,18,19]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const t of n.USUAL_WORD_SEPARATORS)s.indexOf(t)>=0||(_+="\\"+t);return _+="\\s]+)",new RegExp(_,"g")}n.DEFAULT_WORD_REGEXP=i();function u(s){let _=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)_=s;else{let t="g";s.ignoreCase&&(t+="i"),s.multiline&&(t+="m"),s.unicode&&(t+="u"),_=new RegExp(s.source,t)}return _.lastIndex=0,_}n.ensureValidWordDefinition=u;const f=new M.LinkedList;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function g(s,_,t,m,h){if(h||(h=E.Iterable.first(f)),t.length>h.maxLen){let C=s-h.maxLen/2;return C<0?C=0:m+=C,t=t.substring(C,s+h.maxLen/2),g(s,_,t,m,h)}const c=Date.now(),L=s-1-m;let d=-1,y=null;for(let C=1;!(Date.now()-c>=h.timeBudget);C++){const R=L-h.windowSize*C;_.lastIndex=Math.max(0,R);const S=a(_,t,L,d);if(!S&&y||(y=S,R<=0))break;d=R}if(y){const C={word:y[0],startColumn:m+1+y.index,endColumn:m+1+y.index+y[0].length};return _.lastIndex=0,C}return null}n.getWordAtText=g;function a(s,_,t,m){let h;for(;h=s.exec(_);){const c=h.index||0;if(c<=t&&s.lastIndex>=t)return h;if(m>0&&c>m)return null}return null}}),K(te[8],ie([0,1,3,6]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,_){return new i([new u(new M.OffsetRange(0,s.length),new M.OffsetRange(0,_.length))],!1)}static trivialTimedOut(s,_){return new i([new u(new M.OffsetRange(0,s.length),new M.OffsetRange(0,_.length))],!0)}constructor(s,_){this.diffs=s,this.hitTimeout=_}}n.DiffAlgorithmResult=i;class u{constructor(s,_){this.seq1Range=s,this.seq2Range=_}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new u(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new u(this.seq1Range.delta(s),this.seq2Range.delta(s))}}n.SequenceDiff=u;class f{isValid(){return!0}}n.InfiniteTimeout=f,f.instance=new f;class g{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=g}),K(te[38],ie([0,1,6,8]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.removeRandomMatches=n.removeRandomLineMatches=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(t,m,h){let c=h;return c=a(t,m,c),c=s(t,m,c),c}n.optimizeSequenceDiffs=i;function u(t,m,h){const c=[];for(const L of h){const d=c[c.length-1];if(!d){c.push(L);continue}L.seq1Range.start-d.seq1Range.endExclusive<=2||L.seq2Range.start-d.seq2Range.endExclusive<=2?c[c.length-1]=new M.SequenceDiff(d.seq1Range.join(L.seq1Range),d.seq2Range.join(L.seq2Range)):c.push(L)}return c}n.smoothenSequenceDiffs=u;function f(t,m,h){let c=h;if(c.length===0)return c;let L=0,d;do{d=!1;const y=[c[0]];for(let C=1;C<c.length;C++){let p=function(l,o){const v=new E.OffsetRange(S.seq1Range.endExclusive,R.seq1Range.start);return t.getText(v).replace(/\s/g,"").length<=4&&(l.seq1Range.length+l.seq2Range.length>5||o.seq1Range.length+o.seq2Range.length>5)};const R=c[C],S=y[y.length-1];p(S,R)?(d=!0,y[y.length-1]=y[y.length-1].join(R)):y.push(R)}c=y}while(L++<10&&d);return c}n.removeRandomLineMatches=f;function g(t,m,h){let c=h;if(c.length===0)return c;let L=0,d;do{d=!1;const y=[c[0]];for(let C=1;C<c.length;C++){let p=function(l,o){const v=new E.OffsetRange(S.seq1Range.endExclusive,R.seq1Range.start);if(t.countLinesIn(v)>5||v.length>500)return!1;const w=t.getText(v).trim();if(w.length>20||w.split(/\r\n|\r|\n/).length>1)return!1;const A=t.countLinesIn(l.seq1Range),N=l.seq1Range.length,F=m.countLinesIn(l.seq2Range),O=l.seq2Range.length,q=t.countLinesIn(o.seq1Range),T=o.seq1Range.length,W=m.countLinesIn(o.seq2Range),G=o.seq2Range.length,ae=2*40+50;function re(ne){return Math.min(ne,ae)}return Math.pow(Math.pow(re(A*40+N),1.5)+Math.pow(re(F*40+O),1.5),1.5)+Math.pow(Math.pow(re(q*40+T),1.5)+Math.pow(re(W*40+G),1.5),1.5)>Math.pow(Math.pow(ae,1.5),1.5)*1.3};const R=c[C],S=y[y.length-1];p(S,R)?(d=!0,y[y.length-1]=y[y.length-1].join(R)):y.push(R)}c=y}while(L++<10&&d);for(let y=0;y<c.length;y++){const C=c[y];let R=C.seq1Range,S=C.seq2Range;const p=t.extendToFullLines(C.seq1Range),r=t.getText(new E.OffsetRange(p.start,C.seq1Range.start));r.length>0&&r.trim().length<=3&&C.seq1Range.length+C.seq2Range.length>100&&(R=C.seq1Range.deltaStart(-r.length),S=C.seq2Range.deltaStart(-r.length));const l=t.getText(new E.OffsetRange(C.seq1Range.endExclusive,p.endExclusive));l.length>0&&l.trim().length<=3&&C.seq1Range.length+C.seq2Range.length>150&&(R=R.deltaEnd(l.length),S=S.deltaEnd(l.length)),c[y]=new M.SequenceDiff(R,S)}return c}n.removeRandomMatches=g;function a(t,m,h){if(h.length===0)return h;const c=[];c.push(h[0]);for(let d=1;d<h.length;d++){const y=c[c.length-1];let C=h[d];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const R=C.seq1Range.start-y.seq1Range.endExclusive;let S;for(S=1;S<=R&&!(t.getElement(C.seq1Range.start-S)!==t.getElement(C.seq1Range.endExclusive-S)||m.getElement(C.seq2Range.start-S)!==m.getElement(C.seq2Range.endExclusive-S));S++);if(S--,S===R){c[c.length-1]=new M.SequenceDiff(new E.OffsetRange(y.seq1Range.start,C.seq1Range.endExclusive-R),new E.OffsetRange(y.seq2Range.start,C.seq2Range.endExclusive-R));continue}C=C.delta(-S)}c.push(C)}const L=[];for(let d=0;d<c.length-1;d++){const y=c[d+1];let C=c[d];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const R=y.seq1Range.start-C.seq1Range.endExclusive;let S;for(S=0;S<R&&!(t.getElement(C.seq1Range.start+S)!==t.getElement(C.seq1Range.endExclusive+S)||m.getElement(C.seq2Range.start+S)!==m.getElement(C.seq2Range.endExclusive+S));S++);if(S===R){c[d+1]=new M.SequenceDiff(new E.OffsetRange(C.seq1Range.start+R,y.seq1Range.endExclusive),new E.OffsetRange(C.seq2Range.start+R,y.seq2Range.endExclusive));continue}S>0&&(C=C.delta(S))}L.push(C)}return c.length>0&&L.push(c[c.length-1]),L}n.joinSequenceDiffs=a;function s(t,m,h){if(!t.getBoundaryScore||!m.getBoundaryScore)return h;for(let c=0;c<h.length;c++){const L=c>0?h[c-1]:void 0,d=h[c],y=c+1<h.length?h[c+1]:void 0,C=new E.OffsetRange(L?L.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:t.length),R=new E.OffsetRange(L?L.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:m.length);d.seq1Range.isEmpty?h[c]=_(d,t,m,C,R):d.seq2Range.isEmpty&&(h[c]=_(d.reverse(),m,t,R,C).reverse())}return h}n.shiftSequenceDiffs=s;function _(t,m,h,c,L){let y=1;for(;t.seq1Range.start-y>=c.start&&t.seq2Range.start-y>=L.start&&h.isStronglyEqual(t.seq2Range.start-y,t.seq2Range.endExclusive-y)&&y<100;)y++;y--;let C=0;for(;t.seq1Range.start+C<c.endExclusive&&t.seq2Range.endExclusive+C<L.endExclusive&&h.isStronglyEqual(t.seq2Range.start+C,t.seq2Range.endExclusive+C)&&C<100;)C++;if(y===0&&C===0)return t;let R=0,S=-1;for(let p=-y;p<=C;p++){const r=t.seq2Range.start+p,l=t.seq2Range.endExclusive+p,o=t.seq1Range.start+p,v=m.getBoundaryScore(o)+h.getBoundaryScore(r)+h.getBoundaryScore(l);v>S&&(S=v,R=p)}return t.delta(R)}}),K(te[39],ie([0,1,6,8]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,_,t=M.InfiniteTimeout.instance){if(s.length===0||_.length===0)return M.DiffAlgorithmResult.trivial(s,_);function m(p,r){for(;p<s.length&&r<_.length&&s.getElement(p)===_.getElement(r);)p++,r++;return p}let h=0;const c=new f;c.set(0,m(0,0));const L=new g;L.set(0,c.get(0)===0?null:new u(null,0,0,c.get(0)));let d=0;e:for(;;){if(h++,!t.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,_);const p=-Math.min(h,_.length+h%2),r=Math.min(h,s.length+h%2);for(d=p;d<=r;d+=2){const l=d===r?-1:c.get(d+1),o=d===p?-1:c.get(d-1)+1,v=Math.min(Math.max(l,o),s.length),b=v-d;if(v>s.length||b>_.length)continue;const w=m(v,b);c.set(d,w);const A=v===l?L.get(d+1):L.get(d-1);if(L.set(d,w!==v?new u(A,v,b,w-v):A),c.get(d)===s.length&&c.get(d)-d===_.length)break e}}let y=L.get(d);const C=[];let R=s.length,S=_.length;for(;;){const p=y?y.x+y.length:0,r=y?y.y+y.length:0;if((p!==R||r!==S)&&C.push(new M.SequenceDiff(new E.OffsetRange(p,R),new E.OffsetRange(r,S))),!y)break;R=y.x,S=y.y,y=y.prev}return C.reverse(),new M.DiffAlgorithmResult(C,!1)}}n.MyersDiffAlgorithm=i;class u{constructor(s,_,t,m){this.prev=s,this.x=_,this.y=t,this.length=m}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const t=this.negativeArr;this.negativeArr=new Int32Array(t.length*2),this.negativeArr.set(t)}this.negativeArr[s]=_}else{if(s>=this.positiveArr.length){const t=this.positiveArr;this.positiveArr=new Int32Array(t.length*2),this.positiveArr.set(t)}this.positiveArr[s]=_}}}class g{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,_){s<0?(s=-s-1,this.negativeArr[s]=_):this.positiveArr[s]=_}}}),K(te[40],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,f){this.array[i+u*this.width]=f}}n.Array2D=E}),K(te[41],ie([0,1,6,8,40]),function(U,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class u{compute(g,a,s=M.InfiniteTimeout.instance,_){if(g.length===0||a.length===0)return M.DiffAlgorithmResult.trivial(g,a);const t=new i.Array2D(g.length,a.length),m=new i.Array2D(g.length,a.length),h=new i.Array2D(g.length,a.length);for(let S=0;S<g.length;S++)for(let p=0;p<a.length;p++){if(!s.isValid())return M.DiffAlgorithmResult.trivialTimedOut(g,a);const r=S===0?0:t.get(S-1,p),l=p===0?0:t.get(S,p-1);let o;g.getElement(S)===a.getElement(p)?(S===0||p===0?o=0:o=t.get(S-1,p-1),S>0&&p>0&&m.get(S-1,p-1)===3&&(o+=h.get(S-1,p-1)),o+=_?_(S,p):1):o=-1;const v=Math.max(r,l,o);if(v===o){const b=S>0&&p>0?h.get(S-1,p-1):0;h.set(S,p,b+1),m.set(S,p,3)}else v===r?(h.set(S,p,0),m.set(S,p,1)):v===l&&(h.set(S,p,0),m.set(S,p,2));t.set(S,p,v)}const c=[];let L=g.length,d=a.length;function y(S,p){(S+1!==L||p+1!==d)&&c.push(new M.SequenceDiff(new E.OffsetRange(S+1,L),new E.OffsetRange(p+1,d))),L=S,d=p}let C=g.length-1,R=a.length-1;for(;C>=0&&R>=0;)m.get(C,R)===3?(y(C,R),C--,R--):m.get(C,R)===1?C--:R--;return y(-1,-1),c.reverse(),new M.DiffAlgorithmResult(c,!1)}}n.DynamicProgrammingDiffing=u}),K(te[26],ie([0,1,12]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class M{constructor(s,_,t){this.changes=s,this.moves=_,this.hitTimeout=t}}n.LinesDiff=M;class i{static inverse(s,_,t){const m=[];let h=1,c=1;for(const d of s){const y=new i(new E.LineRange(h,d.originalRange.startLineNumber),new E.LineRange(c,d.modifiedRange.startLineNumber),void 0);y.modifiedRange.isEmpty||m.push(y),h=d.originalRange.endLineNumberExclusive,c=d.modifiedRange.endLineNumberExclusive}const L=new i(new E.LineRange(h,_+1),new E.LineRange(c,t+1),void 0);return L.modifiedRange.isEmpty||m.push(L),m}constructor(s,_,t){this.originalRange=s,this.modifiedRange=_,this.innerChanges=t}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(_=>_.flip()))}}n.LineRangeMapping=i;class u{constructor(s,_){this.originalRange=s,this.modifiedRange=_}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}}n.RangeMapping=u;class f{constructor(s,_){this.original=s,this.modified=_}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new f(this.modified,this.original)}join(s){return new f(this.original.join(s.original),this.modified.join(s.modified))}}n.SimpleLineRangeMapping=f;class g{constructor(s,_){this.lineRangeMapping=s,this.changes=_}flip(){return new g(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=g}),K(te[42],ie([0,1,16,9,28,3,12,6,4,2,8,41,38,39,26]),function(U,n,E,M,i,u,f,g,a,s,_,t,m,h,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.findFirstMonotonous=n.findLastMonotonous=n.LinesSliceCharSequence=n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.AdvancedLinesDiffComputer=void 0;class L{constructor(){this.dynamicProgrammingDiffing=new t.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new h.MyersDiffAlgorithm}computeDiff(e,P,k){if(e.length<=1&&(0,E.equals)(e,P,(D,x)=>D===x))return new c.LinesDiff([],[],!1);if(e.length===1&&e[0].length===0||P.length===1&&P[0].length===0)return new c.LinesDiff([new c.LineRangeMapping(new f.LineRange(1,e.length+1),new f.LineRange(1,P.length+1),[new c.RangeMapping(new s.Range(1,1,e.length,e[0].length+1),new s.Range(1,1,P.length,P[0].length+1))])],[],!1);const I=k.maxComputationTimeMs===0?_.InfiniteTimeout.instance:new _.DateTimeout(k.maxComputationTimeMs),V=!k.ignoreTrimWhitespace,Q=new Map;function ee(D){let x=Q.get(D);return x===void 0&&(x=Q.size,Q.set(D,x)),x}const ue=e.map(D=>ee(D.trim())),he=P.map(D=>ee(D.trim())),ge=new v(ue,e),me=new v(he,P),ve=(()=>ge.length+me.length<1700?this.dynamicProgrammingDiffing.compute(ge,me,I,(D,x)=>e[D]===P[x]?P[x].length===0?.1:1+Math.log(1+P[x].length):.99):this.myersDiffingAlgorithm.compute(ge,me))();let J=ve.diffs,H=ve.hitTimeout;J=(0,m.optimizeSequenceDiffs)(ge,me,J),J=(0,m.removeRandomLineMatches)(ge,me,J);const X=[],Y=D=>{if(V)for(let x=0;x<D;x++){const B=se+x,z=oe+x;if(e[B]!==P[z]){const Z=this.refineDiff(e,P,new _.SequenceDiff(new g.OffsetRange(B,B+1),new g.OffsetRange(z,z+1)),I,V);for(const ce of Z.mappings)X.push(ce);Z.hitTimeout&&(H=!0)}}};let se=0,oe=0;for(const D of J){(0,M.assertFn)(()=>D.seq1Range.start-se===D.seq2Range.start-oe);const x=D.seq1Range.start-se;Y(x),se=D.seq1Range.endExclusive,oe=D.seq2Range.endExclusive;const B=this.refineDiff(e,P,D,I,V);B.hitTimeout&&(H=!0);for(const z of B.mappings)X.push(z)}Y(e.length-se);const j=r(X,e,P);let le=[];return k.computeMoves&&(le=this.computeMoves(j,e,P,ue,he,I,V)),(0,M.assertFn)(()=>{function D(B,z){if(B.lineNumber<1||B.lineNumber>z.length)return!1;const Z=z[B.lineNumber-1];return!(B.column<1||B.column>Z.length+1)}function x(B,z){return!(B.startLineNumber<1||B.startLineNumber>z.length+1||B.endLineNumberExclusive<1||B.endLineNumberExclusive>z.length+1)}for(const B of j){if(!B.innerChanges)return!1;for(const z of B.innerChanges)if(!(D(z.modifiedRange.getStartPosition(),P)&&D(z.modifiedRange.getEndPosition(),P)&&D(z.originalRange.getStartPosition(),e)&&D(z.originalRange.getEndPosition(),e)))return!1;if(!x(B.modifiedRange,P)||!x(B.originalRange,e))return!1}return!0}),new c.LinesDiff(j,le,H)}computeMoves(e,P,k,I,V,Q,ee){const ue=[],he=e.filter(j=>j.modifiedRange.isEmpty&&j.originalRange.length>=3).map(j=>new fe(j.originalRange,P,j)),ge=new Set(e.filter(j=>j.originalRange.isEmpty&&j.modifiedRange.length>=3).map(j=>new fe(j.modifiedRange,k,j))),me=new Set;for(const j of he){let le=-1,D;for(const x of ge){const B=j.computeSimilarity(x);B>le&&(le=B,D=x)}if(le>.9&&D&&(ge.delete(D),ue.push(new c.SimpleLineRangeMapping(j.range,D.range)),me.add(j.source),me.add(D.source)),!Q.isValid())return[]}const ve=new i.SetMap;for(const j of e)if(!me.has(j))for(let le=j.originalRange.startLineNumber;le<j.originalRange.endLineNumberExclusive-2;le++){const D=`${I[le-1]}:${I[le+1-1]}:${I[le+2-1]}`;ve.add(D,{range:new f.LineRange(le,le+3)})}const J=[];e.sort((0,E.compareBy)(j=>j.modifiedRange.startLineNumber,E.numberComparator));for(const j of e){if(me.has(j))continue;let le=[];for(let D=j.modifiedRange.startLineNumber;D<j.modifiedRange.endLineNumberExclusive-2;D++){const x=`${V[D-1]}:${V[D+1-1]}:${V[D+2-1]}`,B=new f.LineRange(D,D+3),z=[];ve.forEach(x,({range:Z})=>{for(const de of le)if(de.originalLineRange.endLineNumberExclusive+1===Z.endLineNumberExclusive&&de.modifiedLineRange.endLineNumberExclusive+1===B.endLineNumberExclusive){de.originalLineRange=new f.LineRange(de.originalLineRange.startLineNumber,Z.endLineNumberExclusive),de.modifiedLineRange=new f.LineRange(de.modifiedLineRange.startLineNumber,B.endLineNumberExclusive),z.push(de);return}const ce={modifiedLineRange:B,originalLineRange:Z};J.push(ce),z.push(ce)}),le=z}if(!Q.isValid())return[]}J.sort((0,E.reverseOrder)((0,E.compareBy)(j=>j.modifiedLineRange.length,E.numberComparator)));const H=new C,X=new C;for(const j of J){const le=j.modifiedLineRange.startLineNumber-j.originalLineRange.startLineNumber,D=H.subtractFrom(j.modifiedLineRange),x=X.subtractFrom(j.originalLineRange).map(z=>z.delta(le)),B=y(D,x);for(const z of B){if(z.length<3)continue;const Z=z,ce=z.delta(-le);ue.push(new c.SimpleLineRangeMapping(ce,Z)),H.addRange(Z),X.addRange(ce)}}if(ue.sort((0,E.compareBy)(j=>j.original.startLineNumber,E.numberComparator)),ue.length===0)return[];let Y=[ue[0]];for(let j=1;j<ue.length;j++){const le=Y[Y.length-1],D=ue[j],x=D.original.startLineNumber-le.original.endLineNumberExclusive,B=D.modified.startLineNumber-le.modified.endLineNumberExclusive;if(x>=0&&B>=0&&x+B<=2){Y[Y.length-1]=le.join(D);continue}D.original.toOffsetRange().slice(P).map(ce=>ce.trim()).join(`
`).length<=10||Y.push(D)}const se=d.createOfSorted(e,j=>j.originalRange.endLineNumberExclusive,E.numberComparator);return Y=Y.filter(j=>{const le=se.findLastItemBeforeOrEqual(j.original.startLineNumber)||new c.LineRangeMapping(new f.LineRange(1,1),new f.LineRange(1,1),[]),D=j.modified.startLineNumber-le.modifiedRange.endLineNumberExclusive,x=j.original.startLineNumber-le.originalRange.endLineNumberExclusive;return D!==x}),Y.map(j=>{const le=this.refineDiff(P,k,new _.SequenceDiff(j.original.toOffsetRange(),j.modified.toOffsetRange()),Q,ee),D=r(le.mappings,P,k,!0);return new c.MovedText(j,D)})}refineDiff(e,P,k,I,V){const Q=new w(e,k.seq1Range,V),ee=new w(P,k.seq2Range,V),ue=Q.length+ee.length<500?this.dynamicProgrammingDiffing.compute(Q,ee,I):this.myersDiffingAlgorithm.compute(Q,ee,I);let he=ue.diffs;return he=(0,m.optimizeSequenceDiffs)(Q,ee,he),he=S(Q,ee,he),he=(0,m.smoothenSequenceDiffs)(Q,ee,he),he=(0,m.removeRandomMatches)(Q,ee,he),{mappings:he.map(me=>new c.RangeMapping(Q.translateRange(me.seq1Range),ee.translateRange(me.seq2Range))),hitTimeout:ue.hitTimeout}}}n.AdvancedLinesDiffComputer=L;class d{static createOfSorted(e,P,k){return new d(e,P,k)}constructor(e,P,k){this._items=e,this._itemToDomain=P,this._domainComparator=k,this._currentIdx=0,this._lastValue=void 0,this._hasLastValue=!1}findLastItemBeforeOrEqual(e){if(this._hasLastValue&&E.CompareResult.isLessThan(this._domainComparator(e,this._lastValue)))throw new u.BugIndicatingError;for(this._lastValue=e,this._hasLastValue=!0;this._currentIdx<this._items.length&&E.CompareResult.isLessThanOrEqual(this._domainComparator(this._itemToDomain(this._items[this._currentIdx]),e));)this._currentIdx++;return this._currentIdx===0?void 0:this._items[this._currentIdx-1]}}function y($,e){const P=[];let k=0,I=0;for(;k<$.length&&I<e.length;){const V=$[k],Q=e[I],ee=V.intersect(Q);ee&&!ee.isEmpty&&P.push(ee),V.endLineNumberExclusive<Q.endLineNumberExclusive?k++:I++}return P}class C{constructor(){this._normalizedRanges=[]}addRange(e){const P=R(this._normalizedRanges.findIndex(I=>I.endLineNumberExclusive>=e.startLineNumber),this._normalizedRanges.length),k=(0,E.findLastIndex)(this._normalizedRanges,I=>I.startLineNumber<=e.endLineNumberExclusive)+1;if(P===k)this._normalizedRanges.splice(P,0,e);else if(P===k-1){const I=this._normalizedRanges[P];this._normalizedRanges[P]=I.join(e)}else{const I=this._normalizedRanges[P].join(this._normalizedRanges[k-1]).join(e);this._normalizedRanges.splice(P,k-P,I)}}subtractFrom(e){const P=R(this._normalizedRanges.findIndex(Q=>Q.endLineNumberExclusive>=e.startLineNumber),this._normalizedRanges.length),k=(0,E.findLastIndex)(this._normalizedRanges,Q=>Q.startLineNumber<=e.endLineNumberExclusive)+1;if(P===k)return[e];const I=[];let V=e.startLineNumber;for(let Q=P;Q<k;Q++){const ee=this._normalizedRanges[Q];ee.startLineNumber>V&&I.push(new f.LineRange(V,ee.startLineNumber)),V=ee.endLineNumberExclusive}return V<e.endLineNumberExclusive&&I.push(new f.LineRange(V,e.endLineNumberExclusive)),I}}function R($,e){return $===-1?e:$}function S($,e,P){const k=[];let I;function V(){if(!I)return;const ee=I.s1Range.length-I.deleted,ue=I.s2Range.length-I.added;Math.max(I.deleted,I.added)+(I.count-1)>ee&&k.push(new _.SequenceDiff(I.s1Range,I.s2Range)),I=void 0}for(const ee of P){let ue=function(J,H){var X,Y,se,oe;if(!I||!I.s1Range.containsRange(J)||!I.s2Range.containsRange(H))if(I&&!(I.s1Range.endExclusive<J.start&&I.s2Range.endExclusive<H.start)){const D=g.OffsetRange.tryCreate(I.s1Range.endExclusive,J.start),x=g.OffsetRange.tryCreate(I.s2Range.endExclusive,H.start);I.deleted+=(X=D?.length)!==null&&X!==void 0?X:0,I.added+=(Y=x?.length)!==null&&Y!==void 0?Y:0,I.s1Range=I.s1Range.join(J),I.s2Range=I.s2Range.join(H)}else V(),I={added:0,deleted:0,count:0,s1Range:J,s2Range:H};const j=J.intersect(ee.seq1Range),le=H.intersect(ee.seq2Range);I.count++,I.deleted+=(se=j?.length)!==null&&se!==void 0?se:0,I.added+=(oe=le?.length)!==null&&oe!==void 0?oe:0};const he=$.findWordContaining(ee.seq1Range.start-1),ge=e.findWordContaining(ee.seq2Range.start-1),me=$.findWordContaining(ee.seq1Range.endExclusive),ve=e.findWordContaining(ee.seq2Range.endExclusive);he&&me&&ge&&ve&&he.equals(me)&&ge.equals(ve)?ue(he,ge):(he&&ge&&ue(he,ge),me&&ve&&ue(me,ve))}return V(),p(P,k)}function p($,e){const P=[];for(;$.length>0||e.length>0;){const k=$[0],I=e[0];let V;k&&(!I||k.seq1Range.start<I.seq1Range.start)?V=$.shift():V=e.shift(),P.length>0&&P[P.length-1].seq1Range.endExclusive>=V.seq1Range.start?P[P.length-1]=P[P.length-1].join(V):P.push(V)}return P}function r($,e,P,k=!1){const I=[];for(const V of o($.map(Q=>l(Q,e,P)),(Q,ee)=>Q.originalRange.overlapOrTouch(ee.originalRange)||Q.modifiedRange.overlapOrTouch(ee.modifiedRange))){const Q=V[0],ee=V[V.length-1];I.push(new c.LineRangeMapping(Q.originalRange.join(ee.originalRange),Q.modifiedRange.join(ee.modifiedRange),V.map(ue=>ue.innerChanges[0])))}return(0,M.assertFn)(()=>!k&&I.length>0&&I[0].originalRange.startLineNumber!==I[0].modifiedRange.startLineNumber?!1:(0,M.checkAdjacentItems)(I,(V,Q)=>Q.originalRange.startLineNumber-V.originalRange.endLineNumberExclusive===Q.modifiedRange.startLineNumber-V.modifiedRange.endLineNumberExclusive&&V.originalRange.endLineNumberExclusive<Q.originalRange.startLineNumber&&V.modifiedRange.endLineNumberExclusive<Q.modifiedRange.startLineNumber)),I}n.lineRangeMappingFromRangeMappings=r;function l($,e,P){let k=0,I=0;$.modifiedRange.endColumn===1&&$.originalRange.endColumn===1&&$.originalRange.startLineNumber+k<=$.originalRange.endLineNumber&&$.modifiedRange.startLineNumber+k<=$.modifiedRange.endLineNumber&&(I=-1),$.modifiedRange.startColumn-1>=P[$.modifiedRange.startLineNumber-1].length&&$.originalRange.startColumn-1>=e[$.originalRange.startLineNumber-1].length&&$.originalRange.startLineNumber<=$.originalRange.endLineNumber+I&&$.modifiedRange.startLineNumber<=$.modifiedRange.endLineNumber+I&&(k=1);const V=new f.LineRange($.originalRange.startLineNumber+k,$.originalRange.endLineNumber+1+I),Q=new f.LineRange($.modifiedRange.startLineNumber+k,$.modifiedRange.endLineNumber+1+I);return new c.LineRangeMapping(V,Q,[$])}n.getLineRangeMapping=l;function*o($,e){let P,k;for(const I of $)k!==void 0&&e(k,I)?P.push(I):(P&&(yield P),P=[I]),k=I;P&&(yield P)}class v{constructor(e,P){this.trimmedHash=e,this.lines=P}getElement(e){return this.trimmedHash[e]}get length(){return this.trimmedHash.length}getBoundaryScore(e){const P=e===0?0:b(this.lines[e-1]),k=e===this.lines.length?0:b(this.lines[e]);return 1e3-(P+k)}getText(e){return this.lines.slice(e.start,e.endExclusive).join(`
`)}isStronglyEqual(e,P){return this.lines[e]===this.lines[P]}}n.LineSequence=v;function b($){let e=0;for(;e<$.length&&($.charCodeAt(e)===32||$.charCodeAt(e)===9);)e++;return e}class w{constructor(e,P,k){this.lines=e,this.considerWhitespaceChanges=k,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.additionalOffsetByLine=[];let I=!1;P.start>0&&P.endExclusive>=e.length&&(P=new g.OffsetRange(P.start-1,P.endExclusive),I=!0),this.lineRange=P;for(let V=this.lineRange.start;V<this.lineRange.endExclusive;V++){let Q=e[V],ee=0;if(I)ee=Q.length,Q="",I=!1;else if(!k){const ue=Q.trimStart();ee=Q.length-ue.length,Q=ue.trimEnd()}this.additionalOffsetByLine.push(ee);for(let ue=0;ue<Q.length;ue++)this.elements.push(Q.charCodeAt(ue));V<e.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[V-this.lineRange.start]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new g.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(P=>String.fromCharCode(P)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const P=G(e>0?this.elements[e-1]:-1),k=G(e<this.elements.length?this.elements[e]:-1);if(P===6&&k===7)return 0;let I=0;return P!==k&&(I+=10,k===1&&(I+=1)),I+=W(P),I+=W(k),I}translateOffset(e){if(this.lineRange.isEmpty)return new a.Position(this.lineRange.start+1,1);let P=0,k=this.firstCharOffsetByLineMinusOne.length;for(;P<k;){const V=Math.floor((P+k)/2);this.firstCharOffsetByLineMinusOne[V]>e?k=V:P=V+1}const I=P===0?0:this.firstCharOffsetByLineMinusOne[P-1];return new a.Position(this.lineRange.start+P+1,e-I+1+this.additionalOffsetByLine[P])}translateRange(e){return s.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!q(this.elements[e]))return;let P=e;for(;P>0&&q(this.elements[P-1]);)P--;let k=e;for(;k<this.elements.length&&q(this.elements[k]);)k++;return new g.OffsetRange(P,k)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,P){return this.elements[e]===this.elements[P]}extendToFullLines(e){var P,k;const I=(P=N(this.firstCharOffsetByLineMinusOne,Q=>Q<=e.start))!==null&&P!==void 0?P:0,V=(k=O(this.firstCharOffsetByLineMinusOne,Q=>e.endExclusive<=Q))!==null&&k!==void 0?k:this.elements.length;return new g.OffsetRange(I,V)}}n.LinesSliceCharSequence=w;function A($,e){let P=0,k=$.length;for(;P<k;){const I=Math.floor((P+k)/2);e($[I])?P=I+1:k=I}return P-1}function N($,e){const P=A($,e);return P===-1?void 0:$[P]}n.findLastMonotonous=N;function F($,e){let P=0,k=$.length;for(;P<k;){const I=Math.floor((P+k)/2);e($[I])?k=I:P=I+1}return P}function O($,e){const P=F($,e);return P===$.length?void 0:$[P]}n.findFirstMonotonous=O;function q($){return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57}const T={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function W($){return T[$]}function G($){return $===10?7:$===13?6:ae($)?5:$>=97&&$<=122?0:$>=65&&$<=90?1:$>=48&&$<=57?2:$===-1?3:4}function ae($){return $===32||$===9}const re=new Map;function ne($){let e=re.get($);return e===void 0&&(e=re.size,re.set($,e)),e}class fe{constructor(e,P,k){this.range=e,this.lines=P,this.source=k,this.histogram=[];let I=0;for(let V=e.startLineNumber-1;V<e.endLineNumberExclusive-1;V++){const Q=P[V];for(let ue=0;ue<Q.length;ue++){I++;const he=Q[ue],ge=ne(he);this.histogram[ge]=(this.histogram[ge]||0)+1}I++;const ee=ne(`
`);this.histogram[ee]=(this.histogram[ee]||0)+1}this.totalCount=I}computeSimilarity(e){var P,k;let I=0;const V=Math.max(this.histogram.length,e.histogram.length);for(let Q=0;Q<V;Q++)I+=Math.abs(((P=this.histogram[Q])!==null&&P!==void 0?P:0)-((k=e.histogram[Q])!==null&&k!==void 0?k:0));return 1-I/(this.totalCount+e.totalCount)}}}),K(te[43],ie([0,1,21,26,5,2,9,12]),function(U,n,E,M,i,u,f,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const a=3;class s{computeDiff(p,r,l){var o;const b=new d(p,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),w=[];let A=null;for(const N of b.changes){let F;N.originalEndLineNumber===0?F=new g.LineRange(N.originalStartLineNumber+1,N.originalStartLineNumber+1):F=new g.LineRange(N.originalStartLineNumber,N.originalEndLineNumber+1);let O;N.modifiedEndLineNumber===0?O=new g.LineRange(N.modifiedStartLineNumber+1,N.modifiedStartLineNumber+1):O=new g.LineRange(N.modifiedStartLineNumber,N.modifiedEndLineNumber+1);let q=new M.LineRangeMapping(F,O,(o=N.charChanges)===null||o===void 0?void 0:o.map(T=>new M.RangeMapping(new u.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new u.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));A&&(A.modifiedRange.endLineNumberExclusive===q.modifiedRange.startLineNumber||A.originalRange.endLineNumberExclusive===q.originalRange.startLineNumber)&&(q=new M.LineRangeMapping(A.originalRange.join(q.originalRange),A.modifiedRange.join(q.modifiedRange),A.innerChanges&&q.innerChanges?A.innerChanges.concat(q.innerChanges):void 0),w.pop()),w.push(q),A=q}return(0,f.assertFn)(()=>(0,f.checkAdjacentItems)(w,(N,F)=>F.originalRange.startLineNumber-N.originalRange.endLineNumberExclusive===F.modifiedRange.startLineNumber-N.modifiedRange.endLineNumberExclusive&&N.originalRange.endLineNumberExclusive<F.originalRange.startLineNumber&&N.modifiedRange.endLineNumberExclusive<F.modifiedRange.startLineNumber)),new M.LinesDiff(w,[],b.quitEarly)}}n.LegacyLinesDiffComputer=s;function _(S,p,r,l){return new E.LcsDiff(S,p,r).ComputeDiff(l)}class t{constructor(p){const r=[],l=[];for(let o=0,v=p.length;o<v;o++)r[o]=y(p[o],1),l[o]=C(p[o],1);this.lines=p,this._startColumns=r,this._endColumns=l}getElements(){const p=[];for(let r=0,l=this.lines.length;r<l;r++)p[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return p}getStrictElement(p){return this.lines[p]}getStartLineNumber(p){return p+1}getEndLineNumber(p){return p+1}createCharSequence(p,r,l){const o=[],v=[],b=[];let w=0;for(let A=r;A<=l;A++){const N=this.lines[A],F=p?this._startColumns[A]:1,O=p?this._endColumns[A]:N.length+1;for(let q=F;q<O;q++)o[w]=N.charCodeAt(q-1),v[w]=A+1,b[w]=q,w++;!p&&A<l&&(o[w]=10,v[w]=A+1,b[w]=N.length+1,w++)}return new m(o,v,b)}}class m{constructor(p,r,l){this._charCodes=p,this._lineNumbers=r,this._columns=l}toString(){return"["+this._charCodes.map((p,r)=>(p===10?"\\n":String.fromCharCode(p))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(p,r){if(p<0||p>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(p){return p>0&&p===this._lineNumbers.length?this.getEndLineNumber(p-1):(this._assertIndex(p,this._lineNumbers),this._lineNumbers[p])}getEndLineNumber(p){return p===-1?this.getStartLineNumber(p+1):(this._assertIndex(p,this._lineNumbers),this._charCodes[p]===10?this._lineNumbers[p]+1:this._lineNumbers[p])}getStartColumn(p){return p>0&&p===this._columns.length?this.getEndColumn(p-1):(this._assertIndex(p,this._columns),this._columns[p])}getEndColumn(p){return p===-1?this.getStartColumn(p+1):(this._assertIndex(p,this._columns),this._charCodes[p]===10?1:this._columns[p]+1)}}class h{constructor(p,r,l,o,v,b,w,A){this.originalStartLineNumber=p,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=o,this.modifiedStartLineNumber=v,this.modifiedStartColumn=b,this.modifiedEndLineNumber=w,this.modifiedEndColumn=A}static createFromDiffChange(p,r,l){const o=r.getStartLineNumber(p.originalStart),v=r.getStartColumn(p.originalStart),b=r.getEndLineNumber(p.originalStart+p.originalLength-1),w=r.getEndColumn(p.originalStart+p.originalLength-1),A=l.getStartLineNumber(p.modifiedStart),N=l.getStartColumn(p.modifiedStart),F=l.getEndLineNumber(p.modifiedStart+p.modifiedLength-1),O=l.getEndColumn(p.modifiedStart+p.modifiedLength-1);return new h(o,v,b,w,A,N,F,O)}}function c(S){if(S.length<=1)return S;const p=[S[0]];let r=p[0];for(let l=1,o=S.length;l<o;l++){const v=S[l],b=v.originalStart-(r.originalStart+r.originalLength),w=v.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(b,w)<a?(r.originalLength=v.originalStart+v.originalLength-r.originalStart,r.modifiedLength=v.modifiedStart+v.modifiedLength-r.modifiedStart):(p.push(v),r=v)}return p}class L{constructor(p,r,l,o,v){this.originalStartLineNumber=p,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=o,this.charChanges=v}static createFromDiffResult(p,r,l,o,v,b,w){let A,N,F,O,q;if(r.originalLength===0?(A=l.getStartLineNumber(r.originalStart)-1,N=0):(A=l.getStartLineNumber(r.originalStart),N=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(F=o.getStartLineNumber(r.modifiedStart)-1,O=0):(F=o.getStartLineNumber(r.modifiedStart),O=o.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),b&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&v()){const T=l.createCharSequence(p,r.originalStart,r.originalStart+r.originalLength-1),W=o.createCharSequence(p,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(T.getElements().length>0&&W.getElements().length>0){let G=_(T,W,v,!0).changes;w&&(G=c(G)),q=[];for(let ae=0,re=G.length;ae<re;ae++)q.push(h.createFromDiffChange(G[ae],T,W))}}return new L(A,N,F,O,q)}}class d{constructor(p,r,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=p,this.modifiedLines=r,this.original=new t(p),this.modified=new t(r),this.continueLineDiff=R(l.maxComputationTime),this.continueCharDiff=R(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const p=_(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=p.changes,l=p.quitEarly;if(this.shouldIgnoreTrimWhitespace){const w=[];for(let A=0,N=r.length;A<N;A++)w.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[A],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:w}}const o=[];let v=0,b=0;for(let w=-1,A=r.length;w<A;w++){const N=w+1<A?r[w+1]:null,F=N?N.originalStart:this.originalLines.length,O=N?N.modifiedStart:this.modifiedLines.length;for(;v<F&&b<O;){const q=this.originalLines[v],T=this.modifiedLines[b];if(q!==T){{let W=y(q,1),G=y(T,1);for(;W>1&&G>1;){const ae=q.charCodeAt(W-2),re=T.charCodeAt(G-2);if(ae!==re)break;W--,G--}(W>1||G>1)&&this._pushTrimWhitespaceCharChange(o,v+1,1,W,b+1,1,G)}{let W=C(q,1),G=C(T,1);const ae=q.length+1,re=T.length+1;for(;W<ae&&G<re;){const ne=q.charCodeAt(W-1),fe=q.charCodeAt(G-1);if(ne!==fe)break;W++,G++}(W<ae||G<re)&&this._pushTrimWhitespaceCharChange(o,v+1,W,ae,b+1,G,re)}}v++,b++}N&&(o.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,N,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),v+=N.originalLength,b+=N.modifiedLength)}return{quitEarly:l,changes:o}}_pushTrimWhitespaceCharChange(p,r,l,o,v,b,w){if(this._mergeTrimWhitespaceCharChange(p,r,l,o,v,b,w))return;let A;this.shouldComputeCharChanges&&(A=[new h(r,l,r,o,v,b,v,w)]),p.push(new L(r,r,v,v,A))}_mergeTrimWhitespaceCharChange(p,r,l,o,v,b,w){const A=p.length;if(A===0)return!1;const N=p[A-1];return N.originalEndLineNumber===0||N.modifiedEndLineNumber===0?!1:N.originalEndLineNumber===r&&N.modifiedEndLineNumber===v?(this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new h(r,l,r,o,v,b,v,w)),!0):N.originalEndLineNumber+1===r&&N.modifiedEndLineNumber+1===v?(N.originalEndLineNumber=r,N.modifiedEndLineNumber=v,this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new h(r,l,r,o,v,b,v,w)),!0):!1}}n.DiffComputer=d;function y(S,p){const r=i.firstNonWhitespaceIndex(S);return r===-1?p:r+1}function C(S,p){const r=i.lastNonWhitespaceIndex(S);return r===-1?p:r+2}function R(S){if(S===0)return()=>!0;const p=Date.now();return()=>Date.now()-p<S}}),K(te[44],ie([0,1,43,42]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new E.LegacyLinesDiffComputer,getAdvanced:()=>new M.AdvancedLinesDiffComputer}}),K(te[45],ie([0,1,29]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function M(m){const h=[];for(const c of m){const L=Number(c);(L||L===0&&c.replace(/\s/g,"")!=="")&&h.push(L)}return h}function i(m,h,c,L){return{red:m/255,blue:c/255,green:h/255,alpha:L}}function u(m,h){const c=h.index,L=h[0].length;if(!c)return;const d=m.positionAt(c);return{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:d.lineNumber,endColumn:d.column+L}}function f(m,h){if(!m)return;const c=E.Color.Format.CSS.parseHex(h);if(c)return{range:m,color:i(c.rgba.r,c.rgba.g,c.rgba.b,c.rgba.a)}}function g(m,h,c){if(!m||h.length!==1)return;const d=h[0].values(),y=M(d);return{range:m,color:i(y[0],y[1],y[2],c?y[3]:1)}}function a(m,h,c){if(!m||h.length!==1)return;const d=h[0].values(),y=M(d),C=new E.Color(new E.HSLA(y[0],y[1]/100,y[2]/100,c?y[3]:1));return{range:m,color:i(C.rgba.r,C.rgba.g,C.rgba.b,C.rgba.a)}}function s(m,h){return typeof m=="string"?[...m.matchAll(h)]:m.findMatches(h)}function _(m){const h=[],L=s(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const d of L){const y=d.filter(p=>p!==void 0),C=y[1],R=y[2];if(!R)continue;let S;if(C==="rgb"){const p=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=g(u(m,d),s(R,p),!1)}else if(C==="rgba"){const p=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=g(u(m,d),s(R,p),!0)}else if(C==="hsl"){const p=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=a(u(m,d),s(R,p),!1)}else if(C==="hsla"){const p=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=a(u(m,d),s(R,p),!0)}else C==="#"&&(S=f(u(m,d),C+R));S&&h.push(S)}return h}function t(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:_(m)}n.computeDefaultDocumentColors=t}),K(te[46],ie([0,1,24]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(m,h,c){const L=new Uint8Array(m*h);for(let d=0,y=m*h;d<y;d++)L[d]=c;this._data=L,this.rows=m,this.cols=h}get(m,h){return this._data[m*this.cols+h]}set(m,h,c){this._data[m*this.cols+h]=c}}class i{constructor(m){let h=0,c=0;for(let d=0,y=m.length;d<y;d++){const[C,R,S]=m[d];R>h&&(h=R),C>c&&(c=C),S>c&&(c=S)}h++,c++;const L=new M(c,h,0);for(let d=0,y=m.length;d<y;d++){const[C,R,S]=m[d];L.set(C,R,S)}this._states=L,this._maxCharCode=h}nextState(m,h){return h<0||h>=this._maxCharCode?0:this._states.get(m,h)}}n.StateMachine=i;let u=null;function f(){return u===null&&(u=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),u}let g=null;function a(){if(g===null){g=new E.CharacterClassifier(0);const t=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<t.length;h++)g.set(t.charCodeAt(h),1);const m=".,;:";for(let h=0;h<m.length;h++)g.set(m.charCodeAt(h),2)}return g}class s{static _createLink(m,h,c,L,d){let y=d-1;do{const C=h.charCodeAt(y);if(m.get(C)!==2)break;y--}while(y>L);if(L>0){const C=h.charCodeAt(L-1),R=h.charCodeAt(y);(C===40&&R===41||C===91&&R===93||C===123&&R===125)&&y--}return{range:{startLineNumber:c,startColumn:L+1,endLineNumber:c,endColumn:y+2},url:h.substring(L,y+1)}}static computeLinks(m,h=f()){const c=a(),L=[];for(let d=1,y=m.getLineCount();d<=y;d++){const C=m.getLineContent(d),R=C.length;let S=0,p=0,r=0,l=1,o=!1,v=!1,b=!1,w=!1;for(;S<R;){let A=!1;const N=C.charCodeAt(S);if(l===13){let F;switch(N){case 40:o=!0,F=0;break;case 41:F=o?0:1;break;case 91:b=!0,v=!0,F=0;break;case 93:b=!1,F=v?0:1;break;case 123:w=!0,F=0;break;case 125:F=w?0:1;break;case 39:case 34:case 96:r===N?F=1:r===39||r===34||r===96?F=0:F=1;break;case 42:F=r===42?1:0;break;case 124:F=r===124?1:0;break;case 32:F=b?0:1;break;default:F=c.get(N)}F===1&&(L.push(s._createLink(c,C,d,p,S)),A=!0)}else if(l===12){let F;N===91?(v=!0,F=0):F=c.get(N),F===1?A=!0:l=13}else l=h.nextState(l,N),l===0&&(A=!0);A&&(l=1,o=!1,v=!1,w=!1,p=S+1,r=N),S++}l===13&&L.push(s._createLink(c,C,d,p,R))}return L}}n.LinkComputer=s;function _(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:s.computeLinks(t)}n.computeLinks=_}),K(te[47],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,f,g,a){if(i&&u){const s=this.doNavigateValueSet(u,a);if(s)return{range:i,value:s}}if(f&&g){const s=this.doNavigateValueSet(g,a);if(s)return{range:f,value:s}}return null}doNavigateValueSet(i,u){const f=this.numberReplace(i,u);return f!==null?f:this.textReplace(i,u)}numberReplace(i,u){const f=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let g=Number(i);const a=parseFloat(i);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!u?null:(g=Math.floor(g*f),g+=u?f:-f,String(g/f)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,f){let g=null;for(let a=0,s=i.length;g===null&&a<s;a++)g=this.valueSetReplace(i[a],u,f);return g}valueSetReplace(i,u,f){let g=i.indexOf(u);return g>=0?(g+=f?1:-1,g<0?g=i.length-1:g%=i.length,i[g]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),K(te[48],ie([0,1,11]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var M;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var i;(function(c){c[c.Left=1]="Left",c[c.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var u;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(u||(n.MinimapPosition=u={}));var f;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(f||(n.InjectedTextCursorStops=f={}));class g{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(L){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,L.tabSize|0),L.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,L.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!L.insertSpaces,this.defaultEOL=L.defaultEOL|0,this.trimAutoWhitespace=!!L.trimAutoWhitespace,this.bracketPairColorizationOptions=L.bracketPairColorizationOptions}equals(L){return this.tabSize===L.tabSize&&this._indentSizeIsTabSize===L._indentSizeIsTabSize&&this.indentSize===L.indentSize&&this.insertSpaces===L.insertSpaces&&this.defaultEOL===L.defaultEOL&&this.trimAutoWhitespace===L.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,L.bracketPairColorizationOptions)}createChangeEvent(L){return{tabSize:this.tabSize!==L.tabSize,indentSize:this.indentSize!==L.indentSize,insertSpaces:this.insertSpaces!==L.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==L.trimAutoWhitespace}}}n.TextModelResolvedOptions=g;class a{constructor(L,d){this._findMatchBrand=void 0,this.range=L,this.matches=d}}n.FindMatch=a;function s(c){return c&&typeof c.read=="function"}n.isITextSnapshot=s;class _{constructor(L,d,y,C,R,S){this.identifier=L,this.range=d,this.text=y,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=R,this._isTracked=S}}n.ValidAnnotatedEditOperation=_;class t{constructor(L,d,y){this.regex=L,this.wordSeparators=d,this.simpleSearch=y}}n.SearchData=t;class m{constructor(L,d,y){this.reverseEdits=L,this.changes=d,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=m;function h(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}n.shouldSynchronizeModel=h}),K(te[49],ie([0,1,16,23]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(a,s){a=(0,M.toUint32)(a);const _=this.values,t=this.prefixSum,m=s.length;return m===0?!1:(this.values=new Uint32Array(_.length+m),this.values.set(_.subarray(0,a),0),this.values.set(_.subarray(a),a+m),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,M.toUint32)(a),s=(0,M.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,M.toUint32)(a),s=(0,M.toUint32)(s);const _=this.values,t=this.prefixSum;if(a>=_.length)return!1;const m=_.length-a;return s>=m&&(s=m),s===0?!1:(this.values=new Uint32Array(_.length-s),this.values.set(_.subarray(0,a),0),this.values.set(_.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,M.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let _=s;_<=a;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,_=this.values.length-1,t=0,m=0,h=0;for(;s<=_;)if(t=s+(_-s)/2|0,m=this.prefixSum[t],h=m-this.values[t],a<h)_=t-1;else if(a>=m)s=t+1;else break;return new f(t,a-h)}}n.PrefixSumComputer=i;class u{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],_=s>0?this._prefixSum[s-1]:0;return new f(s,a-_)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,E.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const _=this._values[a],t=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=t+_;for(let m=0;m<_;m++)this._indexBySum[t+m]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=u;class f{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}n.PrefixSumIndexOfResult=f}),K(te[50],ie([0,1,5,4,49]),function(U,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(g,a,s,_){this._uri=g,this._lines=a,this._eol=s,this._versionId=_,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(g){g.eol&&g.eol!==this._eol&&(this._eol=g.eol,this._lineStarts=null);const a=g.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new M.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=g.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const g=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let _=0;_<a;_++)s[_]=this._lines[_].length+g;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(g,a){this._lines[g]=a,this._lineStarts&&this._lineStarts.setValue(g,this._lines[g].length+this._eol.length)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.startLineNumber-1].substring(g.endColumn-1));return}this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.endLineNumber-1].substring(g.endColumn-1)),this._lines.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}_acceptInsertText(g,a){if(a.length===0)return;const s=(0,E.splitLines)(a);if(s.length===1){this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+s[0]+this._lines[g.lineNumber-1].substring(g.column-1));return}s[s.length-1]+=this._lines[g.lineNumber-1].substring(g.column-1),this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+s[0]);const _=new Uint32Array(s.length-1);for(let t=1;t<s.length;t++)this._lines.splice(g.lineNumber+t-1,0,s[t]),_[t-1]=s[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(g.lineNumber,_)}}n.MirrorTextModel=u}),K(te[51],ie([0,1,5,37,4,2,48]),function(U,n,E,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const g=999;class a{constructor(C,R,S,p){this.searchString=C,this.isRegex=R,this.matchCase=S,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let C;this.isRegex?C=s(this.searchString):C=this.searchString.indexOf(`
`)>=0;let R=null;try{R=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:C,global:!0,unicode:!0})}catch{return null}if(!R)return null;let S=!this.isRegex&&!C;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new f.SearchData(R,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=a;function s(y){if(!y||y.length===0)return!1;for(let C=0,R=y.length;C<R;C++){const S=y.charCodeAt(C);if(S===10)return!0;if(S===92){if(C++,C>=R)break;const p=y.charCodeAt(C);if(p===110||p===114||p===87)return!0}}return!1}n.isMultilineRegexSource=s;function _(y,C,R){if(!R)return new f.FindMatch(y,null);const S=[];for(let p=0,r=C.length;p<r;p++)S[p]=C[p];return new f.FindMatch(y,S)}n.createFindMatch=_;class t{constructor(C){const R=[];let S=0;for(let p=0,r=C.length;p<r;p++)C.charCodeAt(p)===10&&(R[S++]=p);this._lineFeedsOffsets=R}findLineFeedCountBeforeOffset(C){const R=this._lineFeedsOffsets;let S=0,p=R.length-1;if(p===-1||C<=R[0])return 0;for(;S<p;){const r=S+((p-S)/2>>0);R[r]>=C?p=r-1:R[r+1]>=C?(S=r,p=r):S=r+1}return S+1}}class m{static findMatches(C,R,S,p,r){const l=R.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(C,S,new d(l.wordSeparators,l.regex),p,r):this._doFindMatchesLineByLine(C,S,l,p,r):[]}static _getMultilineMatchRange(C,R,S,p,r,l){let o,v=0;p?(v=p.findLineFeedCountBeforeOffset(r),o=R+r+v):o=R+r;let b;if(p){const F=p.findLineFeedCountBeforeOffset(r+l.length)-v;b=o+l.length+F}else b=o+l.length;const w=C.getPositionAt(o),A=C.getPositionAt(b);return new u.Range(w.lineNumber,w.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(C,R,S,p,r){const l=C.getOffsetAt(R.getStartPosition()),o=C.getValueInRange(R,1),v=C.getEOL()===`\r
`?new t(o):null,b=[];let w=0,A;for(S.reset(0);A=S.next(o);)if(b[w++]=_(this._getMultilineMatchRange(C,l,o,v,A.index,A[0]),A,p),w>=r)return b;return b}static _doFindMatchesLineByLine(C,R,S,p,r){const l=[];let o=0;if(R.startLineNumber===R.endLineNumber){const b=C.getLineContent(R.startLineNumber).substring(R.startColumn-1,R.endColumn-1);return o=this._findMatchesInLine(S,b,R.startLineNumber,R.startColumn-1,o,l,p,r),l}const v=C.getLineContent(R.startLineNumber).substring(R.startColumn-1);o=this._findMatchesInLine(S,v,R.startLineNumber,R.startColumn-1,o,l,p,r);for(let b=R.startLineNumber+1;b<R.endLineNumber&&o<r;b++)o=this._findMatchesInLine(S,C.getLineContent(b),b,0,o,l,p,r);if(o<r){const b=C.getLineContent(R.endLineNumber).substring(0,R.endColumn-1);o=this._findMatchesInLine(S,b,R.endLineNumber,0,o,l,p,r)}return l}static _findMatchesInLine(C,R,S,p,r,l,o,v){const b=C.wordSeparators;if(!o&&C.simpleSearch){const N=C.simpleSearch,F=N.length,O=R.length;let q=-F;for(;(q=R.indexOf(N,q+F))!==-1;)if((!b||L(b,R,O,q,F))&&(l[r++]=new f.FindMatch(new u.Range(S,q+1+p,S,q+1+F+p),null),r>=v))return r;return r}const w=new d(C.wordSeparators,C.regex);let A;w.reset(0);do if(A=w.next(R),A&&(l[r++]=_(new u.Range(S,A.index+1+p,S,A.index+1+A[0].length+p),A,o),r>=v))return r;while(A);return r}static findNextMatch(C,R,S,p){const r=R.parseSearchRequest();if(!r)return null;const l=new d(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(C,S,l,p):this._doFindNextMatchLineByLine(C,S,l,p)}static _doFindNextMatchMultiline(C,R,S,p){const r=new i.Position(R.lineNumber,1),l=C.getOffsetAt(r),o=C.getLineCount(),v=C.getValueInRange(new u.Range(r.lineNumber,r.column,o,C.getLineMaxColumn(o)),1),b=C.getEOL()===`\r
`?new t(v):null;S.reset(R.column-1);const w=S.next(v);return w?_(this._getMultilineMatchRange(C,l,v,b,w.index,w[0]),w,p):R.lineNumber!==1||R.column!==1?this._doFindNextMatchMultiline(C,new i.Position(1,1),S,p):null}static _doFindNextMatchLineByLine(C,R,S,p){const r=C.getLineCount(),l=R.lineNumber,o=C.getLineContent(l),v=this._findFirstMatchInLine(S,o,l,R.column,p);if(v)return v;for(let b=1;b<=r;b++){const w=(l+b-1)%r,A=C.getLineContent(w+1),N=this._findFirstMatchInLine(S,A,w+1,1,p);if(N)return N}return null}static _findFirstMatchInLine(C,R,S,p,r){C.reset(p-1);const l=C.next(R);return l?_(new u.Range(S,l.index+1,S,l.index+1+l[0].length),l,r):null}static findPreviousMatch(C,R,S,p){const r=R.parseSearchRequest();if(!r)return null;const l=new d(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(C,S,l,p):this._doFindPreviousMatchLineByLine(C,S,l,p)}static _doFindPreviousMatchMultiline(C,R,S,p){const r=this._doFindMatchesMultiline(C,new u.Range(1,1,R.lineNumber,R.column),S,p,10*g);if(r.length>0)return r[r.length-1];const l=C.getLineCount();return R.lineNumber!==l||R.column!==C.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(C,new i.Position(l,C.getLineMaxColumn(l)),S,p):null}static _doFindPreviousMatchLineByLine(C,R,S,p){const r=C.getLineCount(),l=R.lineNumber,o=C.getLineContent(l).substring(0,R.column-1),v=this._findLastMatchInLine(S,o,l,p);if(v)return v;for(let b=1;b<=r;b++){const w=(r+l-b-1)%r,A=C.getLineContent(w+1),N=this._findLastMatchInLine(S,A,w+1,p);if(N)return N}return null}static _findLastMatchInLine(C,R,S,p){let r=null,l;for(C.reset(0);l=C.next(R);)r=_(new u.Range(S,l.index+1,S,l.index+1+l[0].length),l,p);return r}}n.TextModelSearch=m;function h(y,C,R,S,p){if(S===0)return!0;const r=C.charCodeAt(S-1);if(y.get(r)!==0||r===13||r===10)return!0;if(p>0){const l=C.charCodeAt(S);if(y.get(l)!==0)return!0}return!1}function c(y,C,R,S,p){if(S+p===R)return!0;const r=C.charCodeAt(S+p);if(y.get(r)!==0||r===13||r===10)return!0;if(p>0){const l=C.charCodeAt(S+p-1);if(y.get(l)!==0)return!0}return!1}function L(y,C,R,S,p){return h(y,C,R,S,p)&&c(y,C,R,S,p)}n.isValidMatch=L;class d{constructor(C,R){this._wordSeparators=C,this._searchRegex=R,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(C){this._searchRegex.lastIndex=C,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(C){const R=C.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===R||(S=this._searchRegex.exec(C),!S))return null;const p=S.index,r=S[0].length;if(p===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(C,R,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=r,!this._wordSeparators||L(this._wordSeparators,C,R,p,r))return S}while(S);return null}}n.Searcher=d}),K(te[52],ie([0,1,2,51,5,9,25]),function(U,n,E,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class g{static computeUnicodeHighlights(m,h,c){const L=c?c.startLineNumber:1,d=c?c.endLineNumber:m.getLineCount(),y=new s(h),C=y.getCandidateCodePoints();let R;C==="allNonBasicAscii"?R=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):R=new RegExp(`${a(Array.from(C))}`,"g");const S=new M.Searcher(null,R),p=[];let r=!1,l,o=0,v=0,b=0;e:for(let w=L,A=d;w<=A;w++){const N=m.getLineContent(w),F=N.length;S.reset(0);do if(l=S.next(N),l){let O=l.index,q=l.index+l[0].length;if(O>0){const ae=N.charCodeAt(O-1);i.isHighSurrogate(ae)&&O--}if(q+1<F){const ae=N.charCodeAt(q-1);i.isHighSurrogate(ae)&&q++}const T=N.substring(O,q);let W=(0,f.getWordAtText)(O+1,f.DEFAULT_WORD_REGEXP,N,0);W&&W.endColumn<=O+1&&(W=null);const G=y.shouldHighlightNonBasicASCII(T,W?W.word:null);if(G!==0){G===3?o++:G===2?v++:G===1?b++:(0,u.assertNever)(G);const ae=1e3;if(p.length>=ae){r=!0;break e}p.push(new E.Range(w,O+1,w,q+1))}}while(l)}return{ranges:p,hasMore:r,ambiguousCharacterCount:o,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(m,h){const c=new s(h);switch(c.shouldHighlightNonBasicASCII(m,null)){case 0:return null;case 2:return{kind:1};case 3:{const d=m.codePointAt(0),y=c.ambiguousCharacters.getPrimaryConfusable(d),C=i.AmbiguousCharacters.getLocales().filter(R=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,R])).isAmbiguous(d));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:C}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=g;function a(t,m){return`[${i.escapeRegExpCharacters(t.map(c=>String.fromCodePoint(c)).join(""))}]`}class s{constructor(m){this.options=m,this.allowedCodePoints=new Set(m.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(m.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const m=new Set;if(this.options.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)_(String.fromCodePoint(h))||m.add(h);if(this.options.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())m.add(h);for(const h of this.allowedCodePoints)m.delete(h);return m}shouldHighlightNonBasicASCII(m,h){const c=m.codePointAt(0);if(this.allowedCodePoints.has(c))return 0;if(this.options.nonBasicASCII)return 1;let L=!1,d=!1;if(h)for(const y of h){const C=y.codePointAt(0),R=i.isBasicASCII(y);L=L||R,!R&&!this.ambiguousCharacters.isAmbiguous(C)&&!i.InvisibleCharacters.isInvisibleCharacter(C)&&(d=!0)}return!L&&d?0:this.options.invisibleCharacters&&!_(m)&&i.InvisibleCharacters.isInvisibleCharacter(c)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(c)?3:0}}function _(t){return t===" "||t===`
`||t==="	"}}),K(te[53],ie([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(E||(n.AccessibilitySupport=E={}));var M;(function(e){e[e.Invoke=1]="Invoke",e[e.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var i;(function(e){e[e.None=0]="None",e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var u;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(u||(n.CompletionItemKind=u={}));var f;(function(e){e[e.Deprecated=1]="Deprecated"})(f||(n.CompletionItemTag=f={}));var g;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(n.CompletionTriggerKind=g={}));var a;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(a||(n.ContentWidgetPositionPreference=a={}));var s;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var _;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(_||(n.DefaultEndOfLine=_={}));var t;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(t||(n.DocumentHighlightKind=t={}));var m;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(m||(n.EditorAutoIndentStrategy=m={}));var h;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.ariaRequired=5]="ariaRequired",e[e.autoClosingBrackets=6]="autoClosingBrackets",e[e.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",e[e.autoClosingDelete=8]="autoClosingDelete",e[e.autoClosingOvertype=9]="autoClosingOvertype",e[e.autoClosingQuotes=10]="autoClosingQuotes",e[e.autoIndent=11]="autoIndent",e[e.automaticLayout=12]="automaticLayout",e[e.autoSurround=13]="autoSurround",e[e.bracketPairColorization=14]="bracketPairColorization",e[e.guides=15]="guides",e[e.codeLens=16]="codeLens",e[e.codeLensFontFamily=17]="codeLensFontFamily",e[e.codeLensFontSize=18]="codeLensFontSize",e[e.colorDecorators=19]="colorDecorators",e[e.colorDecoratorsLimit=20]="colorDecoratorsLimit",e[e.columnSelection=21]="columnSelection",e[e.comments=22]="comments",e[e.contextmenu=23]="contextmenu",e[e.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",e[e.cursorBlinking=25]="cursorBlinking",e[e.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",e[e.cursorStyle=27]="cursorStyle",e[e.cursorSurroundingLines=28]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",e[e.cursorWidth=30]="cursorWidth",e[e.disableLayerHinting=31]="disableLayerHinting",e[e.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",e[e.domReadOnly=33]="domReadOnly",e[e.dragAndDrop=34]="dragAndDrop",e[e.dropIntoEditor=35]="dropIntoEditor",e[e.emptySelectionClipboard=36]="emptySelectionClipboard",e[e.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",e[e.extraEditorClassName=38]="extraEditorClassName",e[e.fastScrollSensitivity=39]="fastScrollSensitivity",e[e.find=40]="find",e[e.fixedOverflowWidgets=41]="fixedOverflowWidgets",e[e.folding=42]="folding",e[e.foldingStrategy=43]="foldingStrategy",e[e.foldingHighlight=44]="foldingHighlight",e[e.foldingImportsByDefault=45]="foldingImportsByDefault",e[e.foldingMaximumRegions=46]="foldingMaximumRegions",e[e.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=48]="fontFamily",e[e.fontInfo=49]="fontInfo",e[e.fontLigatures=50]="fontLigatures",e[e.fontSize=51]="fontSize",e[e.fontWeight=52]="fontWeight",e[e.fontVariations=53]="fontVariations",e[e.formatOnPaste=54]="formatOnPaste",e[e.formatOnType=55]="formatOnType",e[e.glyphMargin=56]="glyphMargin",e[e.gotoLocation=57]="gotoLocation",e[e.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",e[e.hover=59]="hover",e[e.inDiffEditor=60]="inDiffEditor",e[e.inlineSuggest=61]="inlineSuggest",e[e.letterSpacing=62]="letterSpacing",e[e.lightbulb=63]="lightbulb",e[e.lineDecorationsWidth=64]="lineDecorationsWidth",e[e.lineHeight=65]="lineHeight",e[e.lineNumbers=66]="lineNumbers",e[e.lineNumbersMinChars=67]="lineNumbersMinChars",e[e.linkedEditing=68]="linkedEditing",e[e.links=69]="links",e[e.matchBrackets=70]="matchBrackets",e[e.minimap=71]="minimap",e[e.mouseStyle=72]="mouseStyle",e[e.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=74]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",e[e.multiCursorModifier=76]="multiCursorModifier",e[e.multiCursorPaste=77]="multiCursorPaste",e[e.multiCursorLimit=78]="multiCursorLimit",e[e.occurrencesHighlight=79]="occurrencesHighlight",e[e.overviewRulerBorder=80]="overviewRulerBorder",e[e.overviewRulerLanes=81]="overviewRulerLanes",e[e.padding=82]="padding",e[e.pasteAs=83]="pasteAs",e[e.parameterHints=84]="parameterHints",e[e.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",e[e.quickSuggestions=87]="quickSuggestions",e[e.quickSuggestionsDelay=88]="quickSuggestionsDelay",e[e.readOnly=89]="readOnly",e[e.readOnlyMessage=90]="readOnlyMessage",e[e.renameOnType=91]="renameOnType",e[e.renderControlCharacters=92]="renderControlCharacters",e[e.renderFinalNewline=93]="renderFinalNewline",e[e.renderLineHighlight=94]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=96]="renderValidationDecorations",e[e.renderWhitespace=97]="renderWhitespace",e[e.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",e[e.roundedSelection=99]="roundedSelection",e[e.rulers=100]="rulers",e[e.scrollbar=101]="scrollbar",e[e.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=103]="scrollBeyondLastLine",e[e.scrollPredominantAxis=104]="scrollPredominantAxis",e[e.selectionClipboard=105]="selectionClipboard",e[e.selectionHighlight=106]="selectionHighlight",e[e.selectOnLineNumbers=107]="selectOnLineNumbers",e[e.showFoldingControls=108]="showFoldingControls",e[e.showUnused=109]="showUnused",e[e.snippetSuggestions=110]="snippetSuggestions",e[e.smartSelect=111]="smartSelect",e[e.smoothScrolling=112]="smoothScrolling",e[e.stickyScroll=113]="stickyScroll",e[e.stickyTabStops=114]="stickyTabStops",e[e.stopRenderingLineAfter=115]="stopRenderingLineAfter",e[e.suggest=116]="suggest",e[e.suggestFontSize=117]="suggestFontSize",e[e.suggestLineHeight=118]="suggestLineHeight",e[e.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",e[e.suggestSelection=120]="suggestSelection",e[e.tabCompletion=121]="tabCompletion",e[e.tabIndex=122]="tabIndex",e[e.unicodeHighlighting=123]="unicodeHighlighting",e[e.unusualLineTerminators=124]="unusualLineTerminators",e[e.useShadowDOM=125]="useShadowDOM",e[e.useTabStops=126]="useTabStops",e[e.wordBreak=127]="wordBreak",e[e.wordSeparators=128]="wordSeparators",e[e.wordWrap=129]="wordWrap",e[e.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=132]="wordWrapColumn",e[e.wordWrapOverride1=133]="wordWrapOverride1",e[e.wordWrapOverride2=134]="wordWrapOverride2",e[e.wrappingIndent=135]="wrappingIndent",e[e.wrappingStrategy=136]="wrappingStrategy",e[e.showDeprecated=137]="showDeprecated",e[e.inlayHints=138]="inlayHints",e[e.editorClassName=139]="editorClassName",e[e.pixelRatio=140]="pixelRatio",e[e.tabFocusMode=141]="tabFocusMode",e[e.layoutInfo=142]="layoutInfo",e[e.wrappingInfo=143]="wrappingInfo",e[e.defaultColorDecorators=144]="defaultColorDecorators",e[e.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",e[e.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(h||(n.EditorOption=h={}));var c;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c||(n.EndOfLinePreference=c={}));var L;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(L||(n.EndOfLineSequence=L={}));var d;(function(e){e[e.Left=1]="Left",e[e.Right=2]="Right"})(d||(n.GlyphMarginLane=d={}));var y;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var C;(function(e){e[e.Both=0]="Both",e[e.Right=1]="Right",e[e.Left=2]="Left",e[e.None=3]="None"})(C||(n.InjectedTextCursorStops=C={}));var R;(function(e){e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(R||(n.InlayHintKind=R={}));var S;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var p;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(p||(n.KeyCode=p={}));var r;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var l;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(l||(n.MarkerTag=l={}));var o;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(o||(n.MinimapPosition=o={}));var v;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(v||(n.MouseTargetType=v={}));var b;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(b||(n.OverlayWidgetPositionPreference=b={}));var w;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(w||(n.OverviewRulerLane=w={}));var A;(function(e){e[e.Left=0]="Left",e[e.Right=1]="Right",e[e.None=2]="None",e[e.LeftOfInjectedText=3]="LeftOfInjectedText",e[e.RightOfInjectedText=4]="RightOfInjectedText"})(A||(n.PositionAffinity=A={}));var N;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(N||(n.RenderLineNumbersType=N={}));var F;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(F||(n.RenderMinimap=F={}));var O;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(O||(n.ScrollType=O={}));var q;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(q||(n.ScrollbarVisibility=q={}));var T;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(T||(n.SelectionDirection=T={}));var W;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(W||(n.SignatureHelpTriggerKind=W={}));var G;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(G||(n.SymbolKind=G={}));var ae;(function(e){e[e.Deprecated=1]="Deprecated"})(ae||(n.SymbolTag=ae={}));var re;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(re||(n.TextEditorCursorBlinkingStyle=re={}));var ne;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(ne||(n.TextEditorCursorStyle=ne={}));var fe;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(fe||(n.TrackedRangeStickiness=fe={}));var $;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})($||(n.WrappingIndent=$={}))}),K(te[54],ie([0,1,7,10]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(g){this._onDidChange.fire({changedLanguages:g,changedColorMap:!1})}register(g,a){return this._tokenizationSupports.set(g,a),this.handleChange([g]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(g)===a&&(this._tokenizationSupports.delete(g),this.handleChange([g]))})}get(g){return this._tokenizationSupports.get(g)||null}registerFactory(g,a){var s;(s=this._factories.get(g))===null||s===void 0||s.dispose();const _=new u(this,g,a);return this._factories.set(g,_),(0,M.toDisposable)(()=>{const t=this._factories.get(g);!t||t!==_||(this._factories.delete(g),t.dispose())})}getOrCreate(g){return pe(this,void 0,void 0,function*(){const a=this.get(g);if(a)return a;const s=this._factories.get(g);return!s||s.isResolved?null:(yield s.resolve(),this.get(g))})}isResolved(g){if(this.get(g))return!0;const s=this._factories.get(g);return!!(!s||s.isResolved)}setColorMap(g){this._colorMap=g,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class u extends M.Disposable{get isResolved(){return this._isResolved}constructor(g,a,s){super(),this._registry=g,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return pe(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return pe(this,void 0,void 0,function*(){const g=yield this._factory.tokenizationSupport;this._isResolved=!0,g&&!this._isDisposed&&this._register(this._registry.register(this._languageId,g))})}}}),K(te[55],ie([15,56]),function(U,n){return U.create("vs/base/common/platform",n)}),K(te[13],ie([0,1,55]),function(U,n,E){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,u=!1,f=!1,g=!1,a=!1,s=!1,_=!1,t=!1,m=!1,h=!1,c,L=n.LANGUAGE_DEFAULT,d=n.LANGUAGE_DEFAULT,y,C;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let R;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?R=n.globals.vscode.process:typeof process<"u"&&(R=process);const S=typeof((M=R?.versions)===null||M===void 0?void 0:M.electron)=="string",p=S&&R?.type==="renderer";if(typeof navigator=="object"&&!p)C=navigator.userAgent,i=C.indexOf("Windows")>=0,u=C.indexOf("Macintosh")>=0,t=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=C.indexOf("Linux")>=0,h=C?.indexOf("Mobi")>=0,s=!0,c=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,L=c,d=navigator.language;else if(typeof R=="object"){i=R.platform==="win32",u=R.platform==="darwin",f=R.platform==="linux",g=f&&!!R.env.SNAP&&!!R.env.SNAP_REVISION,_=S,m=!!R.env.CI||!!R.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=n.LANGUAGE_DEFAULT,L=n.LANGUAGE_DEFAULT;const b=R.env.VSCODE_NLS_CONFIG;if(b)try{const w=JSON.parse(b),A=w.availableLanguages["*"];c=w.locale,d=w.osLocale,L=A||n.LANGUAGE_DEFAULT,y=w._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");let r=0;u?r=1:i?r=3:f&&(r=2),n.isWindows=i,n.isMacintosh=u,n.isLinux=f,n.isNative=a,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=t,n.isMobile=h,n.userAgent=C,n.language=L,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const b=[];n.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let N=0,F=b.length;N<F;N++){const O=b[N];if(O.id===A.data.vscodeScheduleAsyncWork){b.splice(N,1),O.callback();return}}});let w=0;return A=>{const N=++w;b.push({id:N,callback:A}),n.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return b=>setTimeout(b)})(),n.OS=u||t?2:i?1:3;let l=!0,o=!1;function v(){if(!o){o=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,l=new Uint16Array(b.buffer)[0]===(2<<8)+1}return l}n.isLittleEndian=v,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),K(te[57],ie([0,1,13]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),K(te[58],ie([0,1,57]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,u=90,f=122,g=46,a=47,s=92,_=58,t=63;class m extends Error{constructor(l,o,v){let b;typeof o=="string"&&o.indexOf("not ")===0?(b="must not be",o=o.replace(/^not /,"")):b="must be";const w=l.indexOf(".")!==-1?"property":"argument";let A=`The "${l}" ${w} ${b} of type ${o}`;A+=`. Received type ${typeof v}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,l){if(r===null||typeof r!="object")throw new m(l,"Object",r)}function c(r,l){if(typeof r!="string")throw new m(l,"string",r)}const L=E.platform==="win32";function d(r){return r===a||r===s}function y(r){return r===a}function C(r){return r>=M&&r<=u||r>=i&&r<=f}function R(r,l,o,v){let b="",w=0,A=-1,N=0,F=0;for(let O=0;O<=r.length;++O){if(O<r.length)F=r.charCodeAt(O);else{if(v(F))break;F=a}if(v(F)){if(!(A===O-1||N===1))if(N===2){if(b.length<2||w!==2||b.charCodeAt(b.length-1)!==g||b.charCodeAt(b.length-2)!==g){if(b.length>2){const q=b.lastIndexOf(o);q===-1?(b="",w=0):(b=b.slice(0,q),w=b.length-1-b.lastIndexOf(o)),A=O,N=0;continue}else if(b.length!==0){b="",w=0,A=O,N=0;continue}}l&&(b+=b.length>0?`${o}..`:"..",w=2)}else b.length>0?b+=`${o}${r.slice(A+1,O)}`:b=r.slice(A+1,O),w=O-A-1;A=O,N=0}else F===g&&N!==-1?++N:N=-1}return b}function S(r,l){h(l,"pathObject");const o=l.dir||l.root,v=l.base||`${l.name||""}${l.ext||""}`;return o?o===l.root?`${o}${v}`:`${o}${r}${v}`:v}n.win32={resolve(...r){let l="",o="",v=!1;for(let b=r.length-1;b>=-1;b--){let w;if(b>=0){if(w=r[b],c(w,"path"),w.length===0)continue}else l.length===0?w=E.cwd():(w=E.env[`=${l}`]||E.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==l.toLowerCase()&&w.charCodeAt(2)===s)&&(w=`${l}\\`));const A=w.length;let N=0,F="",O=!1;const q=w.charCodeAt(0);if(A===1)d(q)&&(N=1,O=!0);else if(d(q))if(O=!0,d(w.charCodeAt(1))){let T=2,W=T;for(;T<A&&!d(w.charCodeAt(T));)T++;if(T<A&&T!==W){const G=w.slice(W,T);for(W=T;T<A&&d(w.charCodeAt(T));)T++;if(T<A&&T!==W){for(W=T;T<A&&!d(w.charCodeAt(T));)T++;(T===A||T!==W)&&(F=`\\\\${G}\\${w.slice(W,T)}`,N=T)}}}else N=1;else C(q)&&w.charCodeAt(1)===_&&(F=w.slice(0,2),N=2,A>2&&d(w.charCodeAt(2))&&(O=!0,N=3));if(F.length>0)if(l.length>0){if(F.toLowerCase()!==l.toLowerCase())continue}else l=F;if(v){if(l.length>0)break}else if(o=`${w.slice(N)}\\${o}`,v=O,O&&l.length>0)break}return o=R(o,!v,"\\",d),v?`${l}\\${o}`:`${l}${o}`||"."},normalize(r){c(r,"path");const l=r.length;if(l===0)return".";let o=0,v,b=!1;const w=r.charCodeAt(0);if(l===1)return y(w)?"\\":r;if(d(w))if(b=!0,d(r.charCodeAt(1))){let N=2,F=N;for(;N<l&&!d(r.charCodeAt(N));)N++;if(N<l&&N!==F){const O=r.slice(F,N);for(F=N;N<l&&d(r.charCodeAt(N));)N++;if(N<l&&N!==F){for(F=N;N<l&&!d(r.charCodeAt(N));)N++;if(N===l)return`\\\\${O}\\${r.slice(F)}\\`;N!==F&&(v=`\\\\${O}\\${r.slice(F,N)}`,o=N)}}}else o=1;else C(w)&&r.charCodeAt(1)===_&&(v=r.slice(0,2),o=2,l>2&&d(r.charCodeAt(2))&&(b=!0,o=3));let A=o<l?R(r.slice(o),!b,"\\",d):"";return A.length===0&&!b&&(A="."),A.length>0&&d(r.charCodeAt(l-1))&&(A+="\\"),v===void 0?b?`\\${A}`:A:b?`${v}\\${A}`:`${v}${A}`},isAbsolute(r){c(r,"path");const l=r.length;if(l===0)return!1;const o=r.charCodeAt(0);return d(o)||l>2&&C(o)&&r.charCodeAt(1)===_&&d(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,o;for(let w=0;w<r.length;++w){const A=r[w];c(A,"path"),A.length>0&&(l===void 0?l=o=A:l+=`\\${A}`)}if(l===void 0)return".";let v=!0,b=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++b;const w=o.length;w>1&&d(o.charCodeAt(1))&&(++b,w>2&&(d(o.charCodeAt(2))?++b:v=!1))}if(v){for(;b<l.length&&d(l.charCodeAt(b));)b++;b>=2&&(l=`\\${l.slice(b)}`)}return n.win32.normalize(l)},relative(r,l){if(c(r,"from"),c(l,"to"),r===l)return"";const o=n.win32.resolve(r),v=n.win32.resolve(l);if(o===v||(r=o.toLowerCase(),l=v.toLowerCase(),r===l))return"";let b=0;for(;b<r.length&&r.charCodeAt(b)===s;)b++;let w=r.length;for(;w-1>b&&r.charCodeAt(w-1)===s;)w--;const A=w-b;let N=0;for(;N<l.length&&l.charCodeAt(N)===s;)N++;let F=l.length;for(;F-1>N&&l.charCodeAt(F-1)===s;)F--;const O=F-N,q=A<O?A:O;let T=-1,W=0;for(;W<q;W++){const ae=r.charCodeAt(b+W);if(ae!==l.charCodeAt(N+W))break;ae===s&&(T=W)}if(W!==q){if(T===-1)return v}else{if(O>q){if(l.charCodeAt(N+W)===s)return v.slice(N+W+1);if(W===2)return v.slice(N+W)}A>q&&(r.charCodeAt(b+W)===s?T=W:W===2&&(T=3)),T===-1&&(T=0)}let G="";for(W=b+T+1;W<=w;++W)(W===w||r.charCodeAt(W)===s)&&(G+=G.length===0?"..":"\\..");return N+=T,G.length>0?`${G}${v.slice(N,F)}`:(v.charCodeAt(N)===s&&++N,v.slice(N,F))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=n.win32.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const o=l.charCodeAt(2);if(o!==t&&o!==g)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(C(l.charCodeAt(0))&&l.charCodeAt(1)===_&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return r},dirname(r){c(r,"path");const l=r.length;if(l===0)return".";let o=-1,v=0;const b=r.charCodeAt(0);if(l===1)return d(b)?r:".";if(d(b)){if(o=v=1,d(r.charCodeAt(1))){let N=2,F=N;for(;N<l&&!d(r.charCodeAt(N));)N++;if(N<l&&N!==F){for(F=N;N<l&&d(r.charCodeAt(N));)N++;if(N<l&&N!==F){for(F=N;N<l&&!d(r.charCodeAt(N));)N++;if(N===l)return r;N!==F&&(o=v=N+1)}}}}else C(b)&&r.charCodeAt(1)===_&&(o=l>2&&d(r.charCodeAt(2))?3:2,v=o);let w=-1,A=!0;for(let N=l-1;N>=v;--N)if(d(r.charCodeAt(N))){if(!A){w=N;break}}else A=!1;if(w===-1){if(o===-1)return".";w=o}return r.slice(0,w)},basename(r,l){l!==void 0&&c(l,"ext"),c(r,"path");let o=0,v=-1,b=!0,w;if(r.length>=2&&C(r.charCodeAt(0))&&r.charCodeAt(1)===_&&(o=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let A=l.length-1,N=-1;for(w=r.length-1;w>=o;--w){const F=r.charCodeAt(w);if(d(F)){if(!b){o=w+1;break}}else N===-1&&(b=!1,N=w+1),A>=0&&(F===l.charCodeAt(A)?--A===-1&&(v=w):(A=-1,v=N))}return o===v?v=N:v===-1&&(v=r.length),r.slice(o,v)}for(w=r.length-1;w>=o;--w)if(d(r.charCodeAt(w))){if(!b){o=w+1;break}}else v===-1&&(b=!1,v=w+1);return v===-1?"":r.slice(o,v)},extname(r){c(r,"path");let l=0,o=-1,v=0,b=-1,w=!0,A=0;r.length>=2&&r.charCodeAt(1)===_&&C(r.charCodeAt(0))&&(l=v=2);for(let N=r.length-1;N>=l;--N){const F=r.charCodeAt(N);if(d(F)){if(!w){v=N+1;break}continue}b===-1&&(w=!1,b=N+1),F===g?o===-1?o=N:A!==1&&(A=1):o!==-1&&(A=-1)}return o===-1||b===-1||A===0||A===1&&o===b-1&&o===v+1?"":r.slice(o,b)},format:S.bind(null,"\\"),parse(r){c(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const o=r.length;let v=0,b=r.charCodeAt(0);if(o===1)return d(b)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(d(b)){if(v=1,d(r.charCodeAt(1))){let T=2,W=T;for(;T<o&&!d(r.charCodeAt(T));)T++;if(T<o&&T!==W){for(W=T;T<o&&d(r.charCodeAt(T));)T++;if(T<o&&T!==W){for(W=T;T<o&&!d(r.charCodeAt(T));)T++;T===o?v=T:T!==W&&(v=T+1)}}}}else if(C(b)&&r.charCodeAt(1)===_){if(o<=2)return l.root=l.dir=r,l;if(v=2,d(r.charCodeAt(2))){if(o===3)return l.root=l.dir=r,l;v=3}}v>0&&(l.root=r.slice(0,v));let w=-1,A=v,N=-1,F=!0,O=r.length-1,q=0;for(;O>=v;--O){if(b=r.charCodeAt(O),d(b)){if(!F){A=O+1;break}continue}N===-1&&(F=!1,N=O+1),b===g?w===-1?w=O:q!==1&&(q=1):w!==-1&&(q=-1)}return N!==-1&&(w===-1||q===0||q===1&&w===N-1&&w===A+1?l.base=l.name=r.slice(A,N):(l.name=r.slice(A,w),l.base=r.slice(A,N),l.ext=r.slice(w,N))),A>0&&A!==v?l.dir=r.slice(0,A-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(L){const r=/\\/g;return()=>{const l=E.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let l="",o=!1;for(let v=r.length-1;v>=-1&&!o;v--){const b=v>=0?r[v]:p();c(b,"path"),b.length!==0&&(l=`${b}/${l}`,o=b.charCodeAt(0)===a)}return l=R(l,!o,"/",y),o?`/${l}`:l.length>0?l:"."},normalize(r){if(c(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,o=r.charCodeAt(r.length-1)===a;return r=R(r,!l,"/",y),r.length===0?l?"/":o?"./":".":(o&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return c(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let o=0;o<r.length;++o){const v=r[o];c(v,"path"),v.length>0&&(l===void 0?l=v:l+=`/${v}`)}return l===void 0?".":n.posix.normalize(l)},relative(r,l){if(c(r,"from"),c(l,"to"),r===l||(r=n.posix.resolve(r),l=n.posix.resolve(l),r===l))return"";const o=1,v=r.length,b=v-o,w=1,A=l.length-w,N=b<A?b:A;let F=-1,O=0;for(;O<N;O++){const T=r.charCodeAt(o+O);if(T!==l.charCodeAt(w+O))break;T===a&&(F=O)}if(O===N)if(A>N){if(l.charCodeAt(w+O)===a)return l.slice(w+O+1);if(O===0)return l.slice(w+O)}else b>N&&(r.charCodeAt(o+O)===a?F=O:O===0&&(F=0));let q="";for(O=o+F+1;O<=v;++O)(O===v||r.charCodeAt(O)===a)&&(q+=q.length===0?"..":"/..");return`${q}${l.slice(w+F)}`},toNamespacedPath(r){return r},dirname(r){if(c(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let o=-1,v=!0;for(let b=r.length-1;b>=1;--b)if(r.charCodeAt(b)===a){if(!v){o=b;break}}else v=!1;return o===-1?l?"/":".":l&&o===1?"//":r.slice(0,o)},basename(r,l){l!==void 0&&c(l,"ext"),c(r,"path");let o=0,v=-1,b=!0,w;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let A=l.length-1,N=-1;for(w=r.length-1;w>=0;--w){const F=r.charCodeAt(w);if(F===a){if(!b){o=w+1;break}}else N===-1&&(b=!1,N=w+1),A>=0&&(F===l.charCodeAt(A)?--A===-1&&(v=w):(A=-1,v=N))}return o===v?v=N:v===-1&&(v=r.length),r.slice(o,v)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===a){if(!b){o=w+1;break}}else v===-1&&(b=!1,v=w+1);return v===-1?"":r.slice(o,v)},extname(r){c(r,"path");let l=-1,o=0,v=-1,b=!0,w=0;for(let A=r.length-1;A>=0;--A){const N=r.charCodeAt(A);if(N===a){if(!b){o=A+1;break}continue}v===-1&&(b=!1,v=A+1),N===g?l===-1?l=A:w!==1&&(w=1):l!==-1&&(w=-1)}return l===-1||v===-1||w===0||w===1&&l===v-1&&l===o+1?"":r.slice(l,v)},format:S.bind(null,"/"),parse(r){c(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const o=r.charCodeAt(0)===a;let v;o?(l.root="/",v=1):v=0;let b=-1,w=0,A=-1,N=!0,F=r.length-1,O=0;for(;F>=v;--F){const q=r.charCodeAt(F);if(q===a){if(!N){w=F+1;break}continue}A===-1&&(N=!1,A=F+1),q===g?b===-1?b=F:O!==1&&(O=1):b!==-1&&(O=-1)}if(A!==-1){const q=w===0&&o?1:w;b===-1||O===0||O===1&&b===A-1&&b===w+1?l.base=l.name=r.slice(q,A):(l.name=r.slice(q,b),l.base=r.slice(q,A),l.ext=r.slice(b,A))}return w>0?l.dir=r.slice(0,w-1):o&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=L?n.win32.normalize:n.posix.normalize,n.resolve=L?n.win32.resolve:n.posix.resolve,n.relative=L?n.win32.relative:n.posix.relative,n.dirname=L?n.win32.dirname:n.posix.dirname,n.basename=L?n.win32.basename:n.posix.basename,n.extname=L?n.win32.extname:n.posix.extname,n.sep=L?n.win32.sep:n.posix.sep}),K(te[14],ie([0,1,58,13]),function(U,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,f=/^\/\//;function g(o,v){if(!o.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!i.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!u.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(f.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(o,v){return!o&&!v?"file":o}function s(o,v){switch(o){case"https":case"http":case"file":v?v[0]!==t&&(v=t+v):v=t;break}return v}const _="",t="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(v){return v instanceof h?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,b,w,A,N,F=!1){typeof v=="object"?(this.scheme=v.scheme||_,this.authority=v.authority||_,this.path=v.path||_,this.query=v.query||_,this.fragment=v.fragment||_):(this.scheme=a(v,F),this.authority=b||_,this.path=s(this.scheme,w||_),this.query=A||_,this.fragment=N||_,g(this,F))}get fsPath(){return R(this,!1)}with(v){if(!v)return this;let{scheme:b,authority:w,path:A,query:N,fragment:F}=v;return b===void 0?b=this.scheme:b===null&&(b=_),w===void 0?w=this.authority:w===null&&(w=_),A===void 0?A=this.path:A===null&&(A=_),N===void 0?N=this.query:N===null&&(N=_),F===void 0?F=this.fragment:F===null&&(F=_),b===this.scheme&&w===this.authority&&A===this.path&&N===this.query&&F===this.fragment?this:new L(b,w,A,N,F)}static parse(v,b=!1){const w=m.exec(v);return w?new L(w[2]||_,l(w[4]||_),l(w[5]||_),l(w[7]||_),l(w[9]||_),b):new L(_,_,_,_,_)}static file(v){let b=_;if(M.isWindows&&(v=v.replace(/\\/g,t)),v[0]===t&&v[1]===t){const w=v.indexOf(t,2);w===-1?(b=v.substring(2),v=t):(b=v.substring(2,w),v=v.substring(w)||t)}return new L("file",b,v,_,_)}static from(v,b){return new L(v.scheme,v.authority,v.path,v.query,v.fragment,b)}static joinPath(v,...b){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return M.isWindows&&v.scheme==="file"?w=h.file(E.win32.join(R(v,!0),...b)).path:w=E.posix.join(v.path,...b),v.with({path:w})}toString(v=!1){return S(this,v)}toJSON(){return this}static revive(v){var b,w;if(v){if(v instanceof h)return v;{const A=new L(v);return A._formatted=(b=v.external)!==null&&b!==void 0?b:null,A._fsPath=v._sep===c&&(w=v.fsPath)!==null&&w!==void 0?w:null,A}}else return v}}n.URI=h;const c=M.isWindows?1:void 0;class L extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=R(this,!1)),this._fsPath}toString(v=!1){return v?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=c),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(o,v,b){let w,A=-1;for(let N=0;N<o.length;N++){const F=o.charCodeAt(N);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||v&&F===47||b&&F===91||b&&F===93||b&&F===58)A!==-1&&(w+=encodeURIComponent(o.substring(A,N)),A=-1),w!==void 0&&(w+=o.charAt(N));else{w===void 0&&(w=o.substr(0,N));const O=d[F];O!==void 0?(A!==-1&&(w+=encodeURIComponent(o.substring(A,N)),A=-1),w+=O):A===-1&&(A=N)}}return A!==-1&&(w+=encodeURIComponent(o.substring(A))),w!==void 0?w:o}function C(o){let v;for(let b=0;b<o.length;b++){const w=o.charCodeAt(b);w===35||w===63?(v===void 0&&(v=o.substr(0,b)),v+=d[w]):v!==void 0&&(v+=o[b])}return v!==void 0?v:o}function R(o,v){let b;return o.authority&&o.path.length>1&&o.scheme==="file"?b=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?v?b=o.path.substr(1):b=o.path[1].toLowerCase()+o.path.substr(2):b=o.path,M.isWindows&&(b=b.replace(/\//g,"\\")),b}n.uriToFsPath=R;function S(o,v){const b=v?C:y;let w="",{scheme:A,authority:N,path:F,query:O,fragment:q}=o;if(A&&(w+=A,w+=":"),(N||A==="file")&&(w+=t,w+=t),N){let T=N.indexOf("@");if(T!==-1){const W=N.substr(0,T);N=N.substr(T+1),T=W.lastIndexOf(":"),T===-1?w+=b(W,!1,!1):(w+=b(W.substr(0,T),!1,!1),w+=":",w+=b(W.substr(T+1),!1,!0)),w+="@"}N=N.toLowerCase(),T=N.lastIndexOf(":"),T===-1?w+=b(N,!1,!0):(w+=b(N.substr(0,T),!1,!0),w+=N.substr(T))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const T=F.charCodeAt(1);T>=65&&T<=90&&(F=`/${String.fromCharCode(T+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const T=F.charCodeAt(0);T>=65&&T<=90&&(F=`${String.fromCharCode(T+32)}:${F.substr(2)}`)}w+=b(F,!0,!1)}return O&&(w+="?",w+=b(O,!1,!1)),q&&(w+="#",w+=v?q:y(q,!1,!1)),w}function p(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(o){return o.match(r)?o.replace(r,v=>p(v)):o}}),K(te[62],ie([0,1,3,7,10,11,13,5]),function(U,n,E,M,i,u,f,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function _(l){f.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}n.logOnceWebWorkerWarning=_;class t{constructor(o,v,b,w){this.vsWorker=o,this.req=v,this.method=b,this.args=w,this.type=0}}class m{constructor(o,v,b,w){this.vsWorker=o,this.seq=v,this.res=b,this.err=w,this.type=1}}class h{constructor(o,v,b,w){this.vsWorker=o,this.req=v,this.eventName=b,this.arg=w,this.type=2}}class c{constructor(o,v,b){this.vsWorker=o,this.req=v,this.event=b,this.type=3}}class L{constructor(o,v){this.vsWorker=o,this.req=v,this.type=4}}class d{constructor(o){this._workerId=-1,this._handler=o,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(o){this._workerId=o}sendMessage(o,v){const b=String(++this._lastSentReq);return new Promise((w,A)=>{this._pendingReplies[b]={resolve:w,reject:A},this._send(new t(this._workerId,b,o,v))})}listen(o,v){let b=null;const w=new M.Emitter({onWillAddFirstListener:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,w),this._send(new h(this._workerId,b,o,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(b),this._send(new L(this._workerId,b)),b=null}});return w.event}handleMessage(o){!o||!o.vsWorker||this._workerId!==-1&&o.vsWorker!==this._workerId||this._handleMessage(o)}_handleMessage(o){switch(o.type){case 1:return this._handleReplyMessage(o);case 0:return this._handleRequestMessage(o);case 2:return this._handleSubscribeEventMessage(o);case 3:return this._handleEventMessage(o);case 4:return this._handleUnsubscribeEventMessage(o)}}_handleReplyMessage(o){if(!this._pendingReplies[o.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[o.seq];if(delete this._pendingReplies[o.seq],o.err){let b=o.err;o.err.$isError&&(b=new Error,b.name=o.err.name,b.message=o.err.message,b.stack=o.err.stack),v.reject(b);return}v.resolve(o.res)}_handleRequestMessage(o){const v=o.req;this._handler.handleMessage(o.method,o.args).then(w=>{this._send(new m(this._workerId,v,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,E.transformErrorForSerialization)(w.detail)),this._send(new m(this._workerId,v,void 0,(0,E.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(o){const v=o.req,b=this._handler.handleEvent(o.eventName,o.arg)(w=>{this._send(new c(this._workerId,v,w))});this._pendingEvents.set(v,b)}_handleEventMessage(o){if(!this._pendingEmitters.has(o.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(o.req).fire(o.event)}_handleUnsubscribeEventMessage(o){if(!this._pendingEvents.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(o.req).dispose(),this._pendingEvents.delete(o.req)}_send(o){const v=[];if(o.type===0)for(let b=0;b<o.args.length;b++)o.args[b]instanceof ArrayBuffer&&v.push(o.args[b]);else o.type===1&&o.res instanceof ArrayBuffer&&v.push(o.res);this._handler.sendMessage(o,v)}}class y extends i.Disposable{constructor(o,v,b){super();let w=null;this._worker=this._register(o.create("vs/base/common/worker/simpleWorker",T=>{this._protocol.handleMessage(T)},T=>{w?.(T)})),this._protocol=new d({sendMessage:(T,W)=>{this._worker.postMessage(T,W)},handleMessage:(T,W)=>{if(typeof b[T]!="function")return Promise.reject(new Error("Missing method "+T+" on main thread host."));try{return Promise.resolve(b[T].apply(b,W))}catch(G){return Promise.reject(G)}},handleEvent:(T,W)=>{if(R(T)){const G=b[T].call(b,W);if(typeof G!="function")throw new Error(`Missing dynamic event ${T} on main thread host.`);return G}if(C(T)){const G=b[T];if(typeof G!="function")throw new Error(`Missing event ${T} on main thread host.`);return G}throw new Error(`Malformed event name ${T}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;const N=globalThis.require;typeof N<"u"&&typeof N.getConfig=="function"?A=N.getConfig():typeof globalThis.requirejs<"u"&&(A=globalThis.requirejs.s.contexts._.config);const F=(0,u.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(A)),v,F]);const O=(T,W)=>this._request(T,W),q=(T,W)=>this._protocol.listen(T,W);this._lazyProxy=new Promise((T,W)=>{w=W,this._onModuleLoaded.then(G=>{T(S(G,O,q))},G=>{W(G),this._onError("Worker failed to load "+v,G)})})}getProxyObject(){return this._lazyProxy}_request(o,v){return new Promise((b,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(o,v).then(b,w)},w)})}_onError(o,v){console.error(o),console.info(v)}}n.SimpleWorkerClient=y;function C(l){return l[0]==="o"&&l[1]==="n"&&g.isUpperAsciiLetter(l.charCodeAt(2))}function R(l){return/^onDynamic/.test(l)&&g.isUpperAsciiLetter(l.charCodeAt(9))}function S(l,o,v){const b=N=>function(){const F=Array.prototype.slice.call(arguments,0);return o(N,F)},w=N=>function(F){return v(N,F)},A={};for(const N of l){if(R(N)){A[N]=w(N);continue}if(C(N)){A[N]=v(N,void 0);continue}A[N]=b(N)}return A}class p{constructor(o,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new d({sendMessage:(b,w)=>{o(b,w)},handleMessage:(b,w)=>this._handleMessage(b,w),handleEvent:(b,w)=>this._handleEvent(b,w)})}onmessage(o){this._protocol.handleMessage(o)}_handleMessage(o,v){if(o===a)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this._requestHandler[o].apply(this._requestHandler,v))}catch(b){return Promise.reject(b)}}_handleEvent(o,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(R(o)){const b=this._requestHandler[o].call(this._requestHandler,v);if(typeof b!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return b}if(C(o)){const b=this._requestHandler[o];if(typeof b!="function")throw new Error(`Missing event ${o} on request handler.`);return b}throw new Error(`Malformed event name ${o}`)}initialize(o,v,b,w){this._protocol.setWorkerId(o);const F=S(w,(O,q)=>this._protocol.sendMessage(O,q),(O,q)=>this._protocol.listen(O,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(F),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((O,q)=>{(globalThis.require||U)([b],W=>{if(this._requestHandler=W.create(F),!this._requestHandler){q(new Error("No RequestHandler!"));return}O((0,u.getAllMethodNames)(this._requestHandler))},q)}))}}n.SimpleWorkerServer=p;function r(l){return new p(l,null)}n.create=r}),K(te[59],ie([15,56]),function(U,n){return U.create("vs/editor/common/languages",n)}),K(te[60],ie([0,1,35,14,2,54,59]),function(U,n,E,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class g{constructor(o,v,b){this.offset=o,this.type=v,this.language=b,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=g;class a{constructor(o,v){this.tokens=o,this.endState=v,this._tokenizationResultBrand=void 0}}n.TokenizationResult=a;class s{constructor(o,v){this.tokens=o,this.endState=v,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=s;var _;(function(l){const o=new Map;o.set(0,E.Codicon.symbolMethod),o.set(1,E.Codicon.symbolFunction),o.set(2,E.Codicon.symbolConstructor),o.set(3,E.Codicon.symbolField),o.set(4,E.Codicon.symbolVariable),o.set(5,E.Codicon.symbolClass),o.set(6,E.Codicon.symbolStruct),o.set(7,E.Codicon.symbolInterface),o.set(8,E.Codicon.symbolModule),o.set(9,E.Codicon.symbolProperty),o.set(10,E.Codicon.symbolEvent),o.set(11,E.Codicon.symbolOperator),o.set(12,E.Codicon.symbolUnit),o.set(13,E.Codicon.symbolValue),o.set(15,E.Codicon.symbolEnum),o.set(14,E.Codicon.symbolConstant),o.set(15,E.Codicon.symbolEnum),o.set(16,E.Codicon.symbolEnumMember),o.set(17,E.Codicon.symbolKeyword),o.set(27,E.Codicon.symbolSnippet),o.set(18,E.Codicon.symbolText),o.set(19,E.Codicon.symbolColor),o.set(20,E.Codicon.symbolFile),o.set(21,E.Codicon.symbolReference),o.set(22,E.Codicon.symbolCustomColor),o.set(23,E.Codicon.symbolFolder),o.set(24,E.Codicon.symbolTypeParameter),o.set(25,E.Codicon.account),o.set(26,E.Codicon.issues);function v(A){let N=o.get(A);return N||(console.info("No codicon found for CompletionItemKind "+A),N=E.Codicon.symbolProperty),N}l.toIcon=v;const b=new Map;b.set("method",0),b.set("function",1),b.set("constructor",2),b.set("field",3),b.set("variable",4),b.set("class",5),b.set("struct",6),b.set("interface",7),b.set("module",8),b.set("property",9),b.set("event",10),b.set("operator",11),b.set("unit",12),b.set("value",13),b.set("constant",14),b.set("enum",15),b.set("enum-member",16),b.set("enumMember",16),b.set("keyword",17),b.set("snippet",27),b.set("text",18),b.set("color",19),b.set("file",20),b.set("reference",21),b.set("customcolor",22),b.set("folder",23),b.set("type-parameter",24),b.set("typeParameter",24),b.set("account",25),b.set("issue",26);function w(A,N){let F=b.get(A);return typeof F>"u"&&!N&&(F=9),F}l.fromString=w})(_||(n.CompletionItemKinds=_={}));var t;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(t||(n.InlineCompletionTriggerKind=t={}));class m{constructor(o,v,b,w){this.range=o,this.text=v,this.completionKind=b,this.isSnippetText=w}equals(o){return i.Range.lift(this.range).equalsRange(o.range)&&this.text===o.text&&this.completionKind===o.completionKind&&this.isSnippetText===o.isSnippetText}}n.SelectedSuggestionInfo=m;var h;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(h||(n.SignatureHelpTriggerKind=h={}));var c;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(c||(n.DocumentHighlightKind=c={}));function L(l){return l&&M.URI.isUri(l.uri)&&i.Range.isIRange(l.range)&&(i.Range.isIRange(l.originSelectionRange)||i.Range.isIRange(l.targetSelectionRange))}n.isLocationLink=L,n.symbolKindNames={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function d(l,o){return(0,f.localize)(26,null,l,n.symbolKindNames[o])}n.getAriaLabelForSymbol=d;var y;(function(l){const o=new Map;o.set(0,E.Codicon.symbolFile),o.set(1,E.Codicon.symbolModule),o.set(2,E.Codicon.symbolNamespace),o.set(3,E.Codicon.symbolPackage),o.set(4,E.Codicon.symbolClass),o.set(5,E.Codicon.symbolMethod),o.set(6,E.Codicon.symbolProperty),o.set(7,E.Codicon.symbolField),o.set(8,E.Codicon.symbolConstructor),o.set(9,E.Codicon.symbolEnum),o.set(10,E.Codicon.symbolInterface),o.set(11,E.Codicon.symbolFunction),o.set(12,E.Codicon.symbolVariable),o.set(13,E.Codicon.symbolConstant),o.set(14,E.Codicon.symbolString),o.set(15,E.Codicon.symbolNumber),o.set(16,E.Codicon.symbolBoolean),o.set(17,E.Codicon.symbolArray),o.set(18,E.Codicon.symbolObject),o.set(19,E.Codicon.symbolKey),o.set(20,E.Codicon.symbolNull),o.set(21,E.Codicon.symbolEnumMember),o.set(22,E.Codicon.symbolStruct),o.set(23,E.Codicon.symbolEvent),o.set(24,E.Codicon.symbolOperator),o.set(25,E.Codicon.symbolTypeParameter);function v(b){let w=o.get(b);return w||(console.info("No codicon found for SymbolKind "+b),w=E.Codicon.symbolProperty),w}l.toIcon=v})(y||(n.SymbolKinds=y={}));class C{}n.TextEdit=C;class R{static fromValue(o){switch(o){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(o)}constructor(o){this.value=o}}n.FoldingRangeKind=R,R.Comment=new R("comment"),R.Imports=new R("imports"),R.Region=new R("region");var S;(function(l){function o(v){return!v||typeof v!="object"?!1:typeof v.id=="string"&&typeof v.title=="string"}l.is=o})(S||(n.Command=S={}));var p;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(p||(n.InlayHintKind=p={}));class r{constructor(o){this.createSupport=o,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(o=>{o&&o.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new u.TokenizationRegistry}),K(te[61],ie([0,1,33,7,31,14,4,2,36,60,53]),function(U,n,E,M,i,u,f,g,a,s,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class t{static chord(c,L){return(0,i.KeyChord)(c,L)}}n.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:_.KeyCode,KeyMod:t,Position:f.Position,Range:g.Range,Selection:a.Selection,SelectionDirection:_.SelectionDirection,MarkerSeverity:_.MarkerSeverity,MarkerTag:_.MarkerTag,Uri:u.URI,Token:s.Token}}n.createMonacoBaseAPI=m}),K(te[63],ie([0,1,21,14,4,2,50,25,46,47,61,20,52,44,11,45]),function(U,n,E,M,i,u,f,g,a,s,_,t,m,h,c,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class d extends f.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const p=[];for(let r=0;r<this._lines.length;r++){const l=this._lines[r],o=this.offsetAt(new i.Position(r+1,1)),v=l.matchAll(S);for(const b of v)(b.index||b.index===0)&&(b.index=b.index+o),p.push(b)}return p}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,p){const r=(0,g.getWordAtText)(S.column,(0,g.ensureValidWordDefinition)(p),this._lines[S.lineNumber-1],0);return r?new u.Range(S.lineNumber,r.startColumn,S.lineNumber,r.endColumn):null}words(S){const p=this._lines,r=this._wordenize.bind(this);let l=0,o="",v=0,b=[];return{*[Symbol.iterator](){for(;;)if(v<b.length){const w=o.substring(b[v].start,b[v].end);v+=1,yield w}else if(l<p.length)o=p[l],b=r(o,S),v=0,l+=1;else break}}}getLineWords(S,p){const r=this._lines[S-1],l=this._wordenize(r,p),o=[];for(const v of l)o.push({word:r.substring(v.start,v.end),startColumn:v.start+1,endColumn:v.end+1});return o}_wordenize(S,p){const r=[];let l;for(p.lastIndex=0;(l=p.exec(S))&&l[0].length!==0;)r.push({start:l.index,end:l.index+l[0].length});return r}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const p=this._eol,r=S.startLineNumber-1,l=S.endLineNumber-1,o=[];o.push(this._lines[r].substring(S.startColumn-1));for(let v=r+1;v<l;v++)o.push(this._lines[v]);return o.push(this._lines[l].substring(0,S.endColumn-1)),o.join(p)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(S),r=this._lines[p.index].length;return{lineNumber:1+p.index,column:1+Math.min(p.remainder,r)}}_validateRange(S){const p=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),r=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return p.lineNumber!==S.startLineNumber||p.column!==S.startColumn||r.lineNumber!==S.endLineNumber||r.column!==S.endColumn?{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:r.lineNumber,endColumn:r.column}:S}_validatePosition(S){if(!i.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:p,column:r}=S,l=!1;if(p<1)p=1,r=1,l=!0;else if(p>this._lines.length)p=this._lines.length,r=this._lines[p-1].length+1,l=!0;else{const o=this._lines[p-1].length+1;r<1?(r=1,l=!0):r>o&&(r=o,l=!0)}return l?{lineNumber:p,column:r}:S}}class y{constructor(S,p){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=p,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(p=>S.push(this._models[p])),S}acceptNewModel(S){this._models[S.url]=new d(M.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,p){if(!this._models[S])return;this._models[S].onEvents(p)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}computeUnicodeHighlights(S,p,r){return pe(this,void 0,void 0,function*(){const l=this._getModel(S);return l?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(l,p,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(S,p,r,l){return pe(this,void 0,void 0,function*(){const o=this._getModel(S),v=this._getModel(p);return!o||!v?null:y.computeDiff(o,v,r,l)})}static computeDiff(S,p,r,l){const o=l==="advanced"?h.linesDiffComputers.getAdvanced():h.linesDiffComputers.getLegacy(),v=S.getLinesContent(),b=p.getLinesContent(),w=o.computeDiff(v,b,r),A=w.changes.length>0?!1:this._modelsAreIdentical(S,p);function N(F){return F.map(O=>{var q;return[O.originalRange.startLineNumber,O.originalRange.endLineNumberExclusive,O.modifiedRange.startLineNumber,O.modifiedRange.endLineNumberExclusive,(q=O.innerChanges)===null||q===void 0?void 0:q.map(T=>[T.originalRange.startLineNumber,T.originalRange.startColumn,T.originalRange.endLineNumber,T.originalRange.endColumn,T.modifiedRange.startLineNumber,T.modifiedRange.startColumn,T.modifiedRange.endLineNumber,T.modifiedRange.endColumn])]})}return{identical:A,quitEarly:w.hitTimeout,changes:N(w.changes),moves:w.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,N(F.changes)])}}static _modelsAreIdentical(S,p){const r=S.getLineCount(),l=p.getLineCount();if(r!==l)return!1;for(let o=1;o<=r;o++){const v=S.getLineContent(o),b=p.getLineContent(o);if(v!==b)return!1}return!0}computeMoreMinimalEdits(S,p,r){return pe(this,void 0,void 0,function*(){const l=this._getModel(S);if(!l)return p;const o=[];let v;p=p.slice(0).sort((b,w)=>{if(b.range&&w.range)return u.Range.compareRangesUsingStarts(b.range,w.range);const A=b.range?0:1,N=w.range?0:1;return A-N});for(let{range:b,text:w,eol:A}of p){if(typeof A=="number"&&(v=A),u.Range.isEmpty(b)&&!w)continue;const N=l.getValueInRange(b);if(w=w.replace(/\r\n|\n|\r/g,l.eol),N===w)continue;if(Math.max(w.length,N.length)>y._diffLimit){o.push({range:b,text:w});continue}const F=(0,E.stringDiff)(N,w,r),O=l.offsetAt(u.Range.lift(b).getStartPosition());for(const q of F){const T=l.positionAt(O+q.originalStart),W=l.positionAt(O+q.originalStart+q.originalLength),G={text:w.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:W.lineNumber,endColumn:W.column}};l.getValueInRange(G.range)!==G.text&&o.push(G)}}return typeof v=="number"&&o.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),o})}computeLinks(S){return pe(this,void 0,void 0,function*(){const p=this._getModel(S);return p?(0,a.computeLinks)(p):null})}computeDefaultDocumentColors(S){return pe(this,void 0,void 0,function*(){const p=this._getModel(S);return p?(0,L.computeDefaultDocumentColors)(p):null})}textualSuggest(S,p,r,l){return pe(this,void 0,void 0,function*(){const o=new t.StopWatch,v=new RegExp(r,l),b=new Set;e:for(const w of S){const A=this._getModel(w);if(A){for(const N of A.words(v))if(!(N===p||!isNaN(Number(N)))&&(b.add(N),b.size>y._suggestionsLimit))break e}}return{words:Array.from(b),duration:o.elapsed()}})}computeWordRanges(S,p,r,l){return pe(this,void 0,void 0,function*(){const o=this._getModel(S);if(!o)return Object.create(null);const v=new RegExp(r,l),b=Object.create(null);for(let w=p.startLineNumber;w<p.endLineNumber;w++){const A=o.getLineWords(w,v);for(const N of A){if(!isNaN(Number(N.word)))continue;let F=b[N.word];F||(F=[],b[N.word]=F),F.push({startLineNumber:w,startColumn:N.startColumn,endLineNumber:w,endColumn:N.endColumn})}}return b})}navigateValueSet(S,p,r,l,o){return pe(this,void 0,void 0,function*(){const v=this._getModel(S);if(!v)return null;const b=new RegExp(l,o);p.startColumn===p.endColumn&&(p={startLineNumber:p.startLineNumber,startColumn:p.startColumn,endLineNumber:p.endLineNumber,endColumn:p.endColumn+1});const w=v.getValueInRange(p),A=v.getWordAtPosition({lineNumber:p.startLineNumber,column:p.startColumn},b);if(!A)return null;const N=v.getValueInRange(A);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(p,w,A,N,r)})}loadForeignModule(S,p,r){const l=(b,w)=>this._host.fhr(b,w),v={host:(0,c.createProxyObject)(r,l),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(v,p),Promise.resolve((0,c.getAllMethodNames)(this._foreignModule))):new Promise((b,w)=>{U([S],A=>{this._foreignModule=A.create(v,p),b((0,c.getAllMethodNames)(this._foreignModule))},w)})}fmr(S,p){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,p))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function C(R){return new y(R,null)}n.create=C,typeof importScripts=="function"&&(globalThis.monaco=(0,_.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map